2026-04-16  Pádraig Brady  <P@draigBrady.com>

	build: update gnulib to latest

2026-04-16  Collin Funk  <collin.funk1@gmail.com>

	tests: avoid a failure on musl
	* tests/misc/io-errors.sh: Allow a generic error string on musl since
	the first line is emitted immediately instead of being buffered as
	expected.
	Reported by Bruno Haible.

2026-04-16  Pádraig Brady  <P@draigBrady.com>

	build: fix build failure on AIX
	* m4/jm-macros.m4: AIX has a splice() function for TCP,
	so check for vmsplice() instead.
	* src/splice.h: Define HAVE_SPLICE if vmsplice available.
	Reported by Bruno Haible.

	test: avoid false failure on OpenBSD
	* tests/numfmt/numfmt.pl: Use standard getopt error map,
	needed on OpenBSD.
	Reported by Bruno Haible.

	tests: avoid false failure with hidden /proc on Guix
	* tests/stat/stat-mount.sh: Don't try our stat under unshare
	unless mount(8) exits gracefully.
	Reported by Bruno Haible.

	tests: avoid failure on Manjaro Linux
	* tests/misc/user.sh: Comment out part of test.
	Reported by Bruno Haible.

2026-04-16  Pádraig Brady  <P@draigBrady.com>

	cksum: fix --length validation on 32 bit platforms
	Fix an unreleased issue due to the recent change
	to using idx_t in commit v9.10-91-g02983e493

	* src/cksum.c (main): Limit the possible return to
	the range supported by idx_t.
	Reported by Bruno Haible.

2026-04-16  Pádraig Brady  <P@draigBrady.com>

	tests: fix false failure due to ulimit usage
	* tests/dd/no-allocate.sh: Run getlimits_ to ensure
	we have $SSIZE_MAX etc. available.  Also give some buffer
	for the configured ulimit to leave space for returns_ to work.

	tests: avoid failure on older Centos 7
	* tests/cp/sparse-perf.sh: Old Centos 7 can give EINVAL
	from SEEK_DATA on sparse files being copied from /dev/shm.
	Avoid this failure as it's not practical to fix.

	tests: fix false failure on Centos 7
	* tests/date/date-locale-hour.sh: Ensure `locale date_fmt`
	is propagated exactly, even when it contains trailing new lines,
	as was seen with Serbian locales on Centos 7.

2026-04-15  Pádraig Brady  <P@draigBrady.com>

	build: update gnulib to latest

2026-04-15  Pádraig Brady  <P@draigBrady.com>

	tests: avoid intermittent false failures with ksh
	As noted in https://bugs.gnu.org/9089
	ksh gives intermittent ECONNRESET errors with closed pipes.
	This can be seen reliably on Linux with:
	ksh -c 'yes | (sleep .1; head -n10 >/dev/null)'

	* tests/misc/io-errors.sh: Avoid part of test on ksh.
	* tests/misc/write-errors.sh: Likewise.

2026-04-15  Pádraig Brady  <P@draigBrady.com>

	tests: use more accurate ulimit with $SHELL -c
	* tests/misc/write-errors.sh: Use a more accurate ulimit determination
	when we're using $SHELL -c.

	tests: avoid $SHELL -c "ulimit ..." pattern
	As described in commit v9.10-283-g5cb0cca3b
	avoid using ulimit with $SHELL -c, and explict
	invocation of the shell like that can require lots of memory,
	often due to loading the locale archive.
	* tests/basenc/bounded-memory.sh: Avoid $SHELL -c with ulimit.
	* tests/cut/bounded-memory.sh: Likewise.
	* tests/expand/bounded-memory.sh Likewise.
	* tests/pr/bounded-memory.sh Likewise.
	* tests/unexpand/bounded-memory.sh Likewise.
	* tests/fold/fold-zero-width.sh: Bring the ulimit bound
	down to the standard 6M over the determined limit.

	tests: fix false failure due to race
	* tests/misc/tty-eof.pl: Fix a race that commit v9.10-269-gf312af49a
	made more apparent, and resulted in intermittent failure like:
	"... (with input) didn't produce expected output".
	Now Instead of waiting for overlapping echo and output,
	just wait for EOF, and if received, use exp->before()
	to inspect the accumulated output.

2026-04-15  Lukáš Zaoral  <lzaoral@redhat.com>

	df: improve detection of duplicate entries
	Do not compare only with the latest entry for given device id but also
	all previously saved entries with the same id.

	* src/df.c (struct devlist): Add next_same_dev struct member.
	(filter_mount_list): Iterate over next_same_dev to find duplicates.
	* tests/df/skip-duplicates.sh: Add test cases.
	* NEWS: Mention the improvement.
	https://redhat.atlassian.net/browse/RHEL-5649

2026-04-12  Pádraig Brady  <P@draigBrady.com>

	tests: fix false failure under some shells
	Verified with:
	  make -j4 PREFERABLY_POSIX_SHELL=/bin/ksh SUBDIRS=. check

	* tests/fold/fold-zero-width.sh: Don't timeout $SHELL -c ...
	as the ulimit induces a failure in the subshell depending
	on the order of the allocations it does.  The main issue is
	disparity between the probed ulimit and that needed by $SHELL -c.
	Such subshells load the often very large locale archive, thus
	if there are any allocations done after the now too low ulimit is set,
	then the $SHELL command fails. Note we timeout fold rather than
	the whole pipeline so any 124 exit status is propagated.

2026-04-11  Pádraig Brady  <P@draigBrady.com>

	tests: validate error handling when reading multiple files
	* tests/misc/read-errors.sh: Validate that commands which read multiple
	files, read all files on error, and exit with appropriate status.

2026-04-11  Collin Funk  <collin.funk1@gmail.com>

	mktemp: prefer rmdir and unlink to remove
	This avoids the following behavior:

	    $ strace -e silence=exit -e trace=unlink,rmdir \
	        mktemp -d > /dev/full
	    unlink("/tmp/tmp.ZBuPmS9ZGD") = -1 EISDIR (Is a directory)
	    rmdir("/tmp/tmp.ZBuPmS9ZGD")  = 0
	    mktemp: write error: No space left on device

	In the above invocation we know that we created a directory, so we
	should not remove a regular file that must have been created by another
	process:

	    $ strace -e silence=exit -e trace=unlink,rmdir \
	        ./src/mktemp -d > /dev/full
	    rmdir("/tmp/tmp.hGbME1HmJr") = 0
	    mktemp: write error: No space left on device

	* src/mktemp.c (main): Prefer rmdir and unlink depending on whether we
	created a directory or regular file.
	* bootstrap.conf (gnulib_modules): Remove the remove module.

2026-04-11  Collin Funk  <collin.funk1@gmail.com>
	    Pádraig Brady  <P@draigBrady.com>

	cat: avoid redundant pipe creation and resizing
	* src/cat.c (splice_cat): Don't bother resizing input as it generally
	doesn't help perf, and also save an fstat per input. Don't close the
	intermediate pipe once created, unless there is an error reading from
	it.

2026-04-10  Pádraig Brady  <P@draigBrady.com>

	tests: validate command responsiveness
	* tests/misc/responsive.sh: Test commands that should output immediately
	upon receiving input, and that there is no unecessary buffering.
	* cfg.mk: Avoid false failure in sc_prohibit_test_backticks.
	* tests/local.mk: Reference the new test.

	tests: stat: ensure independence from /proc/
	* tests/stat/stat-mount.sh: Ensure stat -c '%a'
	is independent from /proc.
	https://github.com/coreutils/coreutils/pull/250

	tests: cut: ensure separate read paths checked
	* tests/misc/read-errors.sh: Use cut -b as that has a separate
	read path to cut -c.

2026-04-10  Bruno Haible  <bruno@clisp.org>

	tests: Avoid accidental matching of the vendor field of $host
	* tests/chgrp/basic.sh: Test $host_os, not $host_triplet.
	* tests/chown/separator.sh: Likewise.
	* tests/rm/r-root.sh: Likewise.
	* tests/tail/pipe-f.sh: Likewise.
	* tests/tail/tail-c.sh: Likewise.
	* tests/tee/tee.sh: Likewise.
	* tests/touch/dangling-symlink.sh: Likewise.

2026-04-10  Collin Funk  <collin.funk1@gmail.com>

	env: avoid locking standard output for each printed variable
	* src/env.c (main): Use fputs and putchar instead of printf.

	printenv: avoid locking standard output for each printed variable
	* src/printenv.c (main): Use fputs and putchar instead of printf.

2026-04-09  Pádraig Brady  <P@draigBrady.com>

	maint: remove last remaining assert()
	* src/split.c (bytes_chunk_extract): Prefer affirm to assert,
	as it allows for better static checking when compiling with -DNDEBUG.

	maint: move tty-eof.pl to misc directory
	* tests/tty/tty-eof.pl: Rename to ...
	* tests/misc/tty-eof.pl: ... this more general directory.
	* tests/local.mk: Adjust accordingly.

	tests: tty-eof.pl: address FIXME re hardcoded Ctrl-d
	* tests/tty/tty-eof.pl: Try to explicitly set EOF char to Ctrl-d
	in case it's different.

	tests: tty-eof.pl: make fully table driven
	* tests/tty/tty-eof.pl: Remove command specific logic,
	and adjust commands to support general input.
	Also add cut -b, as cut_bytes has its own read loop.

	tests: all: check empty tty input is handled appropriately
	* tests/tty/tty-eof.pl: Test all commands twice.
	Once with input and once with empty input.

	maint: cat: avoid coverity NULL dreference warning
	* src/cat.c (ensure_buf_size): Affirm we won't return NULL;

	cat: avoid memory allocation per file
	* src/cat.c (main): Only resize the allocated buffer when needed,
	which avoids per file heap manipulation and mmap/munmap syscalls.

	cat: fix splice() from empty input
	* src/cat.c (splice_cat): Ensure we don't retry a read() after
	splice() completes, as this is significant on a tty.

2026-04-09  oech3  <79379754+oech3@users.noreply.github.com>

	tests: tee: ensure intermittent data is handled
	* tests/tee/tee.sh: Add test case for input from pipe containing sleep.
	https://github.com/coreutils/coreutils/pull/247

2026-04-09  Collin Funk  <collin.funk1@gmail.com>

	maint: touch: prefer timespec_cmp
	* src/touch.c (main): Use timespec_cmp instead of comparing each member
	of the timespec.

2026-04-07  Pádraig Brady  <P@draigBrady.com>

	tests: date: fix false failure on OpenBSD 7.8
	* tests/date/date.pl: Set the max supported year to INT_MAX.
	Most systems support INT_MAX+1900, but mktime() on OpenBSD 7.8
	limits the passed tm_year to INT_MAX.
	Reported by Bruno Haible.

	tests: numfmt: avoid false failure on systems without long double
	* tests/numfmt/numfmt.pl: Move recently added test that depends
	on long double support to the appropriately guarded set.
	Also reduce the value to be in the definitely safe long double range.
	Reported by Bruno Haible.

2026-04-07  Pádraig Brady  <P@draigBrady.com>

	maint: cut: avoid discarded-qualifiers warnings
	Seen on GCC 15.2.1 with GLIBC 2.43 on Arch
	Not seen on GCC 15.2.1 on GLIBC 2.42 on Fedora

	* src/cut.c (search_bytes): Cast the return from memchr()
	to avoid const propagation.
	(find_field_delim): Adjust the return from strstr() similarly.
	https://github.com/coreutils/coreutils/issues/244

2026-04-07  Pádraig Brady  <P@draigBrady.com>

	tests: cat: avoid false failure on systems without splice
	* tests/cat/splice.sh: Ensure splice is called multiple times
	before we check specific invocation counts.
	On Linux kernel 5.10 for example, splice from /dev/zero
	returns EINVAL.

2026-04-07  Collin Funk  <collin.funk1@gmail.com>

	cat: use splice if operating on pipes or if copy_file_range fails
	On a AMD Ryzen 7 3700X system:

	    $ timeout 10 taskset 1 ./src/cat-prev /dev/zero \
	        | taskset 2 pv -r > /dev/null
	    [1.67GiB/s]
	    $ timeout 10 taskset 1 ./src/cat /dev/zero \
	        | taskset 2 pv -r > /dev/null
	    [9.03GiB/s]

	On a Power10 system:

	    $ taskset 1 ./src/yes | timeout 10 taskset 2 ./src/cat-prev \
	        | taskset 3 pv -r > /dev/null
	    [12.9GiB/s]
	    $ taskset 1 ./src/yes | timeout 10 taskset 2 ./src/cat \
	            | taskset 3 pv -r > /dev/null
	    [81.8GiB/s]

	* NEWS: Mention the improvement.
	* src/cat.c: Include isapipe.h, splice.h, and unistd--.h.
	(splice_cat): New function.
	(main): Use it.
	* src/local.mk (noinst_HEADERS): Add src/splice.h.
	* src/splice.h: New file, based on definitions from src/yes.c.
	* src/yes.c: Include splice.h.
	(pipe_splice_size): Use increase_pipe_size from src/splice.h.
	(SPLICE_PIPE_SIZE): Remove definition, moved to src/splice.h.
	* tests/cat/splice.sh: New file, based on some tests in
	tests/misc/yes.sh.
	* tests/local.mk (all_tests): Add the new test.

2026-04-07  Collin Funk  <collin.funk1@gmail.com>

	build: update gnulib submodule to latest
	For the Gnulib commit 2c480fa522 (mbrtowc, mbrtoc32: Silence -Wshadow
	warnings (regr. 2026-04-02)., 2026-04-06).

2026-04-06  Pádraig Brady  <P@draigBrady.com>

	build: cut: fix compilation error on non C23 compilers
	* src/cut.c (main): Add curly brackets around variable
	declaration in case label.
	Reported by Bruno Haible.

2026-04-06  Sylvestre Ledru  <sylvestre@debian.org>

	tests: date: add large year test
	* tests/date/date.pl: Add the test case.
	Add test case for https://github.com/uutils/coreutils/issues/9774
	to verify with large dates.
	https://github.com/coreutils/coreutils/pull/237

2026-04-06  Paul Eggert  <eggert@cs.ucla.edu>

	maint: revert “avoid pthread_sigmask lock”
	* configure.ac (GNULIB_SIGACTION_SINGLE_THREAD): Remove.
	This never worked (it was a misspelling) and the properly-spelled
	identifier (whose spelling has since been renamed) is useful
	mostly for programs like gzip that do not need Gnulib’s ‘lock’ module.
	For coreutils, which needs ‘lock’ for other reasons, it’s overkill.

	maint: avoid pthread_sigmask lock overhead
	This matters only for MS-Windows.
	* configure.ac (GNULIB_PTHREAD_SIGMASK_SINGLE_THREAD):
	Define this instead of defining GNULIB_SIGACTION_SINGLE_THREAD.
	The latter was a typo, and Gnulib has evolved anyway.

2026-04-06  Paul Eggert  <eggert@cs.ucla.edu>

	maint: simplify c32issep
	* src/system.h (c32issep): Avoid unnecessary ‘!!’.

2026-04-06  Sylvestre Ledru  <sylvestre@debian.org>

	tests: expr: add short-circuit tests with parenthesized branches
	* tests/expr/expr.pl: Add tests to verify that short-circuit
	evaluation of | and & correctly skips parenthesized dead branches,
	including nested parenthesized expressions containing division by zero.
	https://github.com/uutils/coreutils/pull/11395
	https://github.com/coreutils/coreutils/pull/238

	tests: split: verify non-UTF-8 bytes are preserved in filenames
	* tests/split/non-utf8.sh: New test to ensure that non-UTF-8 bytes
	in the prefix and --additional-suffix are preserved as-is in output
	filenames, rather than being replaced by UTF-8 replacement characters.
	* tests/local.mk: Register new test.
	https://github.com/uutils/coreutils/pull/11397
	https://github.com/coreutils/coreutils/pull/239

	tests: ln: add test for non-UTF-8 source names in target-dir mode
	* tests/ln/non-utf8-src.sh: New test ensuring ln handles source
	filenames containing non-UTF-8 bytes when linking into a target
	directory, for both hard links and symbolic links with -t.
	* tests/local.mk: Register the new test.
	https://github.com/uutils/coreutils/pull/11403
	https://github.com/coreutils/coreutils/pull/240

	test: od: verify -t f defaults to double precision
	* tests/od/od-float.sh: Add cases to ensure -t f = -t fD,
	and also verify the resulting number.
	https://github.com/uutils/coreutils/pull/11396
	https://github.com/coreutils/coreutils/pull/241

	tests: ls: add quoting-utf8 test for Unicode quotes in UTF-8 locales
	* tests/ls/quoting-utf8.sh: New test verifying that
	--quoting-style=locale and --quoting-style=clocale use Unicode
	left/right single quotation marks in UTF-8 locales, and that
	embedded apostrophes and double quotes are not escaped when the
	delimiters are different characters.
	Also check C locale fallback to ASCII quotes.
	* tests/local.mk: Reference the new test.
	https://github.com/coreutils/coreutils/pull/243

	tests: numfmt: cover GNU/uutils compatibility edge cases
	* tests/numfmt/numfmt.pl: Add tests exercising corner cases around
	negative-argument rejection, large integer precision, scientific
	notation rejection, '--from-unit' fractional precision, zero-padded
	format sign ordering, '--to-unit' prefix selection, and
	'--format=%.0f' with '--to=<scale>'.
	https://github.com/uutils/coreutils/pull/11668

2026-04-06  Pádraig Brady  <P@draigBrady.com>

	doc: document cut(1) multi-byte and interface consolidation
	This patch set updates cut(1) to be multi-byte aware.
	It also reduces interface divergence across implementations.

	multi-byte awareness was added to the existing -c, n, and -d options.
	Also considered for compatibility are the -w, -F, and -O options,
	as these are present on at least two other common implementations.

	= Interface / New functionality =

	    macOS,  i18n, uutils, Toybox, Busybox, GNU
	-c    x      x       x      x        x      x
	-n    x      x                              x
	-w    x              x                      x
	-F                          x        x      x
	-O                          x        x      x

	-c is needed anyway as specified by all, including POSIX.
	-n is needed also as specified by i18n/macOS/POSIX
	-w is somewhat less important, but seeing as it's
	on two other common platforms (and its functionality is
	provided on two more), providing it is worthwhile for compat.
	-F and -O are really just aliases to other options
	so trivial to add, and probably worthwhile for compatibility.

	Interface / functionality notes:

	There is a slight divergence between -n implementations.
	There was already a difference between FreeBSD and i18n, and
	we've aligned with the more sensible FreeBSD implementation.
	Note the i18n -n implementation is otherwise buggy in any case,
	so I doubt this will be a practical compatibility concern.
	Actually -n is specified by POSIX, and it matches FreeBSD.
	Specifically our -n will not output a character unless the
	byte range encompasses _the end_ of the multi-byte character.
	I.e. the -b is a limit that is not passed, and thus ensures
	we don't output overlapping characters for separate cut
	invocations that do not have overlapping byte ranges.

	-d <regex> from toybox is not implemented.
	That's edge case functionality IMHO and not well suited to cut(1).
	This functionality is supported by awk, and regex functionality
	is best restricted to awk I think.

	cut is a significant part of the i18n patch, so it will be good
	to avoid that downstream divergence.  Unfortunately there were
	no tests with the cut i18n implementation.
	Note the i18n cut implementation used fread() as so was
	not reponsive to new data < BUFSIZ, whereas this implementation
	uses read() and thus is responsive to data as it becomes available.

	= Performance =

	General performance notes:

	We prefer byte searching (with -d) as that can be much faster
	than character by character processing, and it's supported
	on single byte and UTF-8 charsets.  We also use byte searching
	with -w on uni-byte locales.
	This was seen to give up to 100x perf increase over the i18n patch.

	Where we do use per character processing, we avoid conversion to
	wide char when processing ASCII data (mcel provides this optimization).
	This was seen to give a 14x performance increase over the i18n patch.

	We prefer memchr() and strstr() as these are tuned for specific
	platforms on glibc, even if memchr2() or memmem()
	are algorithmically better.

	We maintain the important memory behavior
	of only buffering when necessary.

	Performance testing:

	There are _lots_ of combinations and optimziation opportunities.
	I performance tested this patch set with the following setup:

	$ yes | head -n10M > sl.in
	$ yes $(yes eeeaae | head -n10K | paste -s -d,) | head -n10K > ll.in
	$ yes $(yes eeeaae | head -n9 | paste -s -d,) | head -n1M > as.in
	$ yes $(yes éééááé | head -n9 | paste -s -d，) | head -n1M \
	  > mb.in

	$ for type in sl ll as mb; do
	    cat $type.in >/dev/null;
	    for imp in '' src/; do  # '' maps to the system i18n ver on Fedora
	      echo ============ "${imp:-i18n}" $type ==============;
	      for d in -d, -dc -d， -dç -w -b -c; do
	        fields='-f1 -f10 -f100'
	        test "$d" = "-b" && { fields='-b1 -b10 -b100'; d=''; }
	        test "$d" = "-c" && { fields='-c1 -c10 -c100'; d=''; }
	        for f in $fields; do
	          for loc in C C.UTF-8; do
	            # SKip -b for UTF-8 as no different
	            test "$loc" = C.UTF-8 && echo "$f" | grep -q -- -b \
	             && continue
	            # Skip multi-byte delimiter for C and not allowed
	            test "$loc" = C && test $(echo -n "$d" | wc -c) -ge 4 \
	             && continue
	            LC_ALL=$loc ${imp}cut $f $d /dev/null 2>/dev/null &&
	            hyperfine -m2 -M4 \
	             "LC_ALL=$loc ${imp}cut $f $d $type.in >/dev/null" ||
	            printf 'Benchmark 1: %s\n  unsupported\n\n' \
	             "LC_ALL=$loc ${imp}cut $f $d $type.in >/dev/null"
	          done;
	        done;
	      done;
	    done;
	  done

	After a little post-processing of the results, we get:

	-- cut-i18n

	| command         |       sl |       ll |       as |       mb |
	| --------------- | -------- | -------- | -------- | -------- |
	| C -f1 -d,       |  66.3 ms |  1.605 s | 145.9 ms | 366.4 ms |
	| UTF8 -f1 -d,    |  65.8 ms |  1.593 s | 145.8 ms | 370.0 ms |
	| C -f10 -d,      | 301.4 ms |  1.590 s | 161.8 ms | 126.7 ms |
	| UTF8 -f10 -d,   | 303.5 ms |  1.599 s | 161.8 ms | 124.6 ms |
	| C -f100 -d,     | 300.6 ms |  1.596 s | 162.1 ms | 126.7 ms |
	| UTF8 -f100 -d,  | 301.3 ms |  1.595 s | 162.0 ms | 124.9 ms |
	| C -f1 -dc       |  66.6 ms |  1.845 s | 179.1 ms | 365.7 ms |
	| UTF8 -f1 -dc    |  73.8 ms |  1.878 s | 179.1 ms | 363.1 ms |
	| C -f10 -dc      | 300.7 ms | 349.8 ms |  76.0 ms | 125.3 ms |
	| UTF8 -f10 -dc   | 300.4 ms | 347.2 ms |  75.7 ms | 124.8 ms |
	| C -f100 -dc     | 300.1 ms | 348.1 ms |  76.5 ms | 125.5 ms |
	| UTF8 -f100 -dc  | 300.8 ms | 348.7 ms |  76.4 ms | 125.8 ms |
	| UTF8 -f1 -d，   | 563.5 ms | 21.775 s |  1.963 s |  1.665 s |
	| UTF8 -f10 -d，  | 833.6 ms | 20.504 s |  2.022 s |  1.612 s |
	| UTF8 -f100 -d， | 825.2 ms | 20.448 s |  2.009 s |  1.616 s |
	| UTF8 -f1 -dç    | 563.7 ms | 21.827 s |  1.964 s |  2.319 s |
	| UTF8 -f10 -dç   | 825.3 ms | 21.713 s |  2.011 s |  2.248 s |
	| UTF8 -f100 -dç  | 831.6 ms | 20.505 s |  2.019 s |  2.276 s |
	| C -f1 -w        |        - |        - |        - |        - |
	| UTF8 -f1 -w     |        - |        - |        - |        - |
	| C -f10 -w       |        - |        - |        - |        - |
	| UTF8 -f10 -w    |        - |        - |        - |        - |
	| C -f100 -w      |        - |        - |        - |        - |
	| UTF8 -f100 -w   |        - |        - |        - |        - |
	| C -b1           |  60.8 ms |  1.596 s | 154.8 ms | 313.7 ms |
	| C -b10          |  51.6 ms |  1.594 s | 154.3 ms | 310.8 ms |
	| C -b100         |  51.4 ms |  1.594 s | 153.0 ms | 312.2 ms |
	| C -c1           |  60.7 ms |  1.597 s | 153.8 ms | 313.0 ms |
	| UTF8 -c1        | 526.5 ms | 14.662 s |  1.362 s |  1.573 s |
	| C -c10          |  51.8 ms |  1.591 s | 153.3 ms | 311.4 ms |
	| UTF8 -c10       | 436.9 ms | 14.450 s |  1.336 s |  1.563 s |
	| C -c100         |  51.0 ms |  1.593 s | 152.7 ms | 313.2 ms |
	| UTF8 -c100      | 426.7 ms | 14.429 s |  1.344 s |  1.551 s |

	-- src/cut

	| command         |       sl |       ll |       as |       mb |
	| --------------- | -------- | -------- | -------- | -------- |
	| C -f1 -d,       |   4.6 ms | 108.2 ms |  45.4 ms |  24.2 ms |
	| UTF8 -f1 -d,    |   4.8 ms | 108.4 ms |  45.4 ms |  24.5 ms |
	| C -f10 -d,      |   4.5 ms | 109.3 ms | 123.7 ms |  24.3 ms |
	| UTF8 -f10 -d,   |   4.9 ms | 114.1 ms | 124.1 ms |  24.5 ms |
	| C -f100 -d,     |   4.7 ms | 119.2 ms | 124.1 ms |  24.5 ms |
	| UTF8 -f100 -d,  |   4.8 ms | 120.0 ms | 125.1 ms |  24.5 ms |
	| C -f1 -dc       |   4.4 ms | 120.5 ms |  11.9 ms |  24.1 ms |
	| UTF8 -f1 -dc    |   4.9 ms | 120.5 ms |  12.1 ms |  24.6 ms |
	| C -f10 -dc      |   4.7 ms | 125.3 ms |  11.8 ms |  24.1 ms |
	| UTF8 -f10 -dc   |   4.8 ms | 126.7 ms |  12.0 ms |  24.4 ms |
	| C -f100 -dc     |   4.6 ms | 127.0 ms |  11.9 ms |  24.3 ms |
	| UTF8 -f100 -dc  |   4.7 ms | 126.4 ms |  12.0 ms |  24.4 ms |
	| UTF8 -f1 -d，   |   6.0 ms | 169.4 ms |  15.6 ms |  67.4 ms |
	| UTF8 -f10 -d，  |   6.1 ms | 173.9 ms |  15.6 ms | 237.2 ms |
	| UTF8 -f100 -d， |   6.1 ms | 174.0 ms |  15.6 ms | 237.8 ms |
	| UTF8 -f1 -dç    |   6.3 ms | 170.8 ms |  15.7 ms |  32.2 ms |
	| UTF8 -f10 -dç   |   6.0 ms | 172.9 ms |  15.9 ms |  32.1 ms |
	| UTF8 -f100 -dç  |   6.7 ms | 173.1 ms |  15.5 ms |  32.3 ms |
	| C -f1 -w        | 159.6 ms | 170.1 ms |  69.1 ms |  98.9 ms |
	| UTF8 -f1 -w     | 128.1 ms |  2.525 s | 246.5 ms |  1.086 s |
	| C -f10 -w       | 183.3 ms | 199.2 ms |  74.6 ms | 105.0 ms |
	| UTF8 -f10 -w    | 130.3 ms |  2.659 s | 276.5 ms |  1.099 s |
	| C -f100 -w      | 183.8 ms | 202.5 ms |  74.1 ms | 103.6 ms |
	| UTF8 -f100 -w   | 130.1 ms |  2.663 s | 276.6 ms |  1.097 s |
	| C -b1           |  65.0 ms | 110.2 ms |  22.4 ms |  35.6 ms |
	| C -b10          |  48.7 ms | 109.6 ms |  24.2 ms |  36.7 ms |
	| C -b100         |  48.7 ms | 110.6 ms |  19.0 ms |  36.6 ms |
	| C -c1           |  65.8 ms | 109.5 ms |  22.4 ms |  35.6 ms |
	| UTF8 -c1        |  63.2 ms |  1.130 s | 116.9 ms | 610.2 ms |
	| C -c10          |  48.7 ms | 109.8 ms |  24.3 ms |  36.8 ms |
	| UTF8 -c10       |  39.7 ms |  1.133 s | 118.7 ms | 610.0 ms |
	| C -c100         |  48.3 ms | 110.7 ms |  18.9 ms |  36.7 ms |
	| UTF8 -c100      |  39.4 ms |  1.141 s | 115.0 ms | 598.8 ms |

	In summary, compared to the i18n patch we're now as fast in all cases,
	and much faster in most cases.

	We can see the -f byte searching performing well,
	being 120x faster in the no matching delimiter case,
	to at least 3x faster in the matching delimiter case.

	When we resort to per character processing we also compare well,
	being 14x faster in the ASCII processing case
	(due to mcel short-circuiting the wide char conversion).
	Note the processing mb.in results above also show a 2x win
	in per character processing cases, but the i18n patch would have
	also picked that win up as it's achieved separately to this patch set:
	https://lists.gnu.org/r/coreutils/2026-03/msg00117.html

2026-04-06  Pádraig Brady  <P@draigBrady.com>

	tests: cut: add remaining tests to ensure 100% coverage
	* tests/cut/cut.pl: Add new tests to ensure
	`make coverage` shows 100% coverage for cut.c.

	tests: cut: expand GB18030 tests
	* tests/cut/mb-non-utf8.sh: Add more test cases.

2026-04-06  Paul Eggert  <eggert@cs.ucla.edu>

	maint: cut: refactor delimiter handling
	* src/cut.c: Use mcel_scanz() to parse in all cases,
	and avoid redundant storage of delimiter_length and
	the single byte delim.

2026-04-06  Pádraig Brady  <P@draigBrady.com>

	cut: -f: fix handling of multi-byte delimiters that span buffers
	* src/cut.c (cut_fields_bytesearch): Ensure up to delim_bytes -1
	is left for the next refill.
	* tests/cut/cut.pl: Add a test case.

	cut,fold,expand,unexpand: ensure we process all available characters
	* gl/lib/mbbuf.h: Adjust mbbuf_fill() to process full characters
	in the slop at the end of a read().  Previously valid characters
	in the last MCEL_LEN_MAX bytes were ignored until the next read().
	* src/cut.c (cut_fields_bytesearch): Adjust to the new naming.
	* NEWS: Mention the fold(1) responsiveness fix, which was
	improved with the change from fread() to read(),
	and completed with this patch.

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: -b: avoid function calls in hot loop
	  $ time LC_ALL=C src/cut-before -b1 sl.in >/dev/null
	  real	0m0.115s

	  $ time LC_ALL=C src/cut-after -b1 sl.in >/dev/null
	  real	0m0.076s

	* src/cut.c (cut_bytes): Hoist the fileno() invariant outside the loop.
	Avoid memchr for very short lines.
	(search_bytes): Similar to copy_bytes() and write_bytes() helpers.
	Note adding code to probe 3 or 4 bytes resulted in worse register
	allocation.  I.e. slower operation even if the input was only 2 bytes.

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: fix logic issue with field delim in last byte of buffer
	With field delimiter = line delimiter we need to know
	if there is any more data to be read, as field delimiter
	in the last byte of the file is treated differently.
	So reiterate the loop to ensure enough read()s to make
	the appropriate determination.

	cut: ensure responsive input processing
	* gl/lib/mbbuf.h (fill_buf): Switch from fread() to read()
	as the former retries read() internally to fill the buffer.
	* src/cut.c: Adjust accordingly, and avoid getc() interface entirely.
	* bootstrap.h: Depend explicitly on fseterr.  This is already depended
	on transitively, so should not introduce new build portability issues.

	maint: cut: rename line_in to bytes_in
	* src/cut.c: We're not reading a line, rather a buffer of bytes.
	Suggested by Collin Funk.

	tests: cut: add more multi-byte tests
	* tests/cut/cut.pl: Add more multi-byte combinations.

	cut: make the dependency on memchr2 explicit
	* bootstrap.conf: Remove now unused getndelim2, add memchr2.
	* src/cut.c: Remove now unused getndelim2.h.

	cut: combine cut_bytes_no_split and cut_characters
	per character based so merge.

	doc: cut: clarify that combining characters are not treated specially
	This is for consistency with other implementations and since the
	interface separates -b and -c it might in future support -g (graphemes).
	Normalizing content with a filter seems like the most appropriate
	approach anyway, as there are various normalizations possible including
	case etc. rather than baking that into every tool

	maint: cut: various code cleanups and comments
	* src/cut.c: Document some functions, and remove extraneous
	 abstractions.

	cut: support no delimiter match fast path with -s
	* src/cut.c (cut_fields_bytesearch): Just skip the data with -s.

	doc: cut: resintate and expand -d info
	* doc/coreutils.texi (cut invocation): Add back the -d description,
	and adjust for multi-byte support, and expand on specifying a NUL
	delimitier, and detail the behavior when the delimiter matches
	the line delimiter.

	maint: cut: cleanup context management for byte search
	* src/cut.c: Hoist at_eof into context so we're not
	querying it multiple times.  Also add a helper
	to explicitly init bytesearch_context.

	cut: optimize UTF-8 input with 0xF5-0xFF delimiters
	* src/cut.c (bytesearch_field_delim_ok): Expand the range
	of bytes that can be simply searched for. 0xF5-0xFF can't
	appear in valid UTF-8 characters, and so may be used as
	delimiters in UTF-8 input, so it's worth optimizing for.
	* tests/cut/cut.pl: Add a test case (mainly as documentation).

	doc: cut: clarify that -s suppressed lines with only trimmed spaces
	* doc/coreutils.texi (cut invocation): State explicitly that
	-s --whitespace-delimited=trimmed will suppress lines that
	do not have field separating blanks.

	doc: cut: mention the default -O used with -w
	* doc/coreutils.texi (cut invocation): Mention the default
	--output-delimiter is a TAB when matching runs of blanks in the input.

	maint: cut: simplify mbbuf_fill
	We can only byte search with uni-byte or utf-8.
	utf-8 implicitly can't false match a delimiter at buffer boundary.
	So don't worry about finding the exact utf8 boundary at end of buffer,
	rather just ensuring the buffer always starts with a valid character
	(by ensuring MCEL_LEN_MAX-1 moved to start of buffer on each refill).

	maint: refactor is_utf8_charset helper to system.h
	* src/cut.c: Move from here.
	* src/numfmt.c: Likeise.
	* src/system.h: To here.

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: optimize per character memcpy
	$ time src/cut-before -f10 -w ll.in >/dev/null
	real	0m4.309s

	$ time src/cut-after -f10 -w ll.in >/dev/null
	real	0m3.136s

	* src/cut.c (cut_bytes): Add a new helper that avoids
	the memcpy call in the common case of adding characters to a buffer.

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: refactor skip_line_remainder logic
	Simplify and optimize field exhaustion logic:

	$ time LC_ALL=C src/cut-before -f1 -dc as.in >/dev/null
	real	0m0.057s

	$ time LC_ALL=C src/cut-after -f1 -dc as.in >/dev/null
	real	0m0.023s

	* src/cut.c (cut_fields_bytesearch): Refactor.

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	maint: cut simplify cut_fields_bytesearch
	refactor line delimiter output,
	and resetting of parse record state.

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: enable fast path for all delimiter lengths
	1. Removed !have_pending_line from the fast path condition.
	This is safe because:
	  - field_1_n_bytes == 0 already ensures we haven't started
	    buffering field 1 content
	  - The fast path correctly continues any pending partial line
	    by writing raw bytes including the completing \n
	2. Added have_pending_line = false after the fast path write,
	since all lines up to the last \n are now complete.

	$ time src/cut.before -f1 -dç sl.in >/dev/null
	real	0m0.081s
	$ time src/cut.after -f1 -dç sl.in >/dev/null
	real	0m0.012s

	$ time src/cut.before -f10 -dç sl.in >/dev/null
	real	0m0.081s
	$ time src/cut.after -f10 -dç sl.in >/dev/null
	real	0m0.012s

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: optimize -f with -d longer than lines
	$ time src/cut.before -f1 -dç sl.in >/dev/null
	real	0m0.157s

	$ time src/cut.after -f1 -dç sl.in >/dev/null
	real	0m0.084s

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: optimize -b for short lines
	For a 40% performance increase it's worth reinstating the simple
	original cut_bytes() which avoids data copying and function calls.
	Once a longer line is encountered we defer to the buffered variant.

	$ time src/cut.before -b2 sl.in  >/dev/null
	real	0m0.101s

	$ time src/cut.after -b2 sl.in  >/dev/null
	real	0m0.060s

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: optimize per character field scanning
	Use specialized loops rather than branching per character,
	giving a 28% increase.

	$ time src/cut -f1 -w ll.in >/dev/null
	real	0m7.199s

	$ time src/cut -f1 -w ll.in >/dev/null
	real	0m5.204s

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: prefer c_isblank() to c32issep()
	12% perf increase with:

	$ time src/cut -f2 -w ll.in >/dev/null
	real	0m6.469s

	$ time src/cut -f2 -w ll.in >/dev/null
	real	0m5.689s

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: avoid fwrite calls for smaller amounts of data
	This is quite significant:

	yes abcdfeg | head -n1MB > big-file

	$ time src/cut-before -b1,3 big-file >/dev/null
	real	0m0.050s

	$ time src/cut-after -b1,3 big-file >/dev/null
	real	0m0.029s

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: optimize -b by avoiding per byte iteration
	Always memchr(line_delim) which is fast and allows:

	- skipping whole segments when the next selected byte is beyond them
	- skipping unselected prefixes in bulk
	- writing contiguous selected spans in bulk

	This wins for lines >= 4 characters,
	but is slower lines <= 3 characters, especially if selecting bytes 1-3.
	That is unusual though.

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: optimize when no delimiter in input
	This is about 20x faster.
	Note we only do the delimiter search once per chunk,
	and it's usually quick as delimiters wouldn't be too far
	into the a chunk if present, so we don't bother
	to cache the found delimiter.

	tests: cut: ensure multi-byte delimiter is rejected in uni-byte locales
	tests/cut/cut.pl: Check the appropriate diagnostic is presented.

	cut: optimize -w for uni-byte case
	* src/cut.c: Limit search to SPACE and TAB

	doc: cut: reorder -s in texi
	Keep in alphabetical order.

	doc: cut: document the -w option
	* src/cut.c (usage): Mention blank characters are used to separate.
	* doc/coreutils.texi (cut invocation): Likewise.  Also describe
	the 'trimmed' argument and the relation to -F.

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: refactor find_bytesearch_field_terminator to be stateful
	Allows better/simpler avoidance of repeated line/delim scans

	TODO: speed up our really slow cut_fields_mb_any.
	Compare for example:
	  time src/cut -w  -f1 ll.in >/dev/null #14s
	  time src/cut -d, -f1 ll.in >/dev/null #.1s
	Could adjust so that LC_ALL=C does memchr2(space,tab) ?

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: avoid repeated searchs for line_delim in the multi-byte delim case
	TODO: Refactor all this into find_bytesearch_field_terminator.
	Also handle in the delim_length==1 case.

	cut: refactor all byte search to find_bytesearch_field_terminator
	TODO: Perhaps also add search only fields mode
	to avoid rescans of very long lines

	cut: optimize -f when finished processing fields for a line
	TODO: simplify and compare perf

	cut: optimize -f for fhe common case of single byte delimiters
	* TODO: perf comparison

	cut: optimize -d '?' in UTF-8 case
	ensure all ascii delims are processed with byte search in UTF-8

	cut: merge cut_fields and cut_fields_bytesearch
	TODO: See why this is much slower:
	time LC_ALL=C.UTF-8 src/cut -f1 -dc as.in > /dev/null

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: refactor -f to byte search and character processing
	Not sure about this at all.
	Only worthwhile if can also remove cut_fields_line_delim.

	Refactored src/cut.c so the old UTF-8 byte-search path is now the
	general byte-search field engine for all safe byte-search cases:
	ordinary single-byte delimiters and valid UTF-8 delimiters. The old
	cut_fields path did not go away completely; it is now
	cut_fields_line_delim and is used only when the field delimiter equals
	the record delimiter, because -d $'\n' and -z -d '' have different
	semantics from normal line-based field splitting.

	As part of that, I also folded the duplicated “start selected field”
	logic into a shared helper, and renamed the byte-search helpers to match
	their broader use. The current dispatcher in src/cut.c is now:
	whitespace parser, then line- delimiter field mode, then byte-search
	field mode, then the decoded multibyte parser.

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: fix 25% perf regression mentioned in previous change
	* src/cut.c: Prefer strstr() over memmem() as the former is
	optimized per platforma on GLIBC, where as the latter is only
	optimized for S390 as of glibc-2.42

	TODO: look at merging cut_fields and cut_fields_mb_utf8
	as they're both byte search

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: use bounded memory in utf8 mode when possible
	TODO: See why a bit slower than old code

	$ time src/cut.old -f1 -dç mb.in >/dev/null
	real	0m0.136s
	user	0m0.096s
	sys	0m0.039s

	$ time src/cut.new -f1 -dç mb.in >/dev/null
	real	0m0.170s
	user	0m0.139s
	sys	0m0.030s

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: add utf8 helper to mbbuf
	* gl/lib/mbbuf.h: To safely search a bounded buffer,
	without needed to have unbounded memory with getndelim2.

	TODO: rename mbbuf_utf8_safe_prefix to mbbuf_fill_utf8

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: faster utf8 processing
	TODO: improve to use bounded memory where possible

	cut: support -F as an alias for -f -w -O ' '
	To improve compatibility with toybox/busybox scripts.

	maint: cut: refactor buffered and ordinary field scanning
	* src/cut.c: Merge scan_mb_field and read_mb_field_to_buffer

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: support --whitespace-delimited=trimmed
	Support ignoring leading and trailing whitespace.
	E.g. this matches awk's default field splitting mode.

	* src/cut.c
	* tests/cut/cut.pl: Add test cases.

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: support -O as an alias for --output-delimiter
	To improve compatibility with toybox/busybox scripts.

	* doc/coreutils.texi (cut invocation): Add -O description.
	* src/cut.c: Support -O as well as --output-delimiter
	* tests/cut/cut.pl: Adjust one case to use -O.

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	doc: cut: adjust for multi-byte support
	* doc/coreutils.texi (cut invocation): Remove the note about
	-c being the same as -b.

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: refactor multi-byte updates
	* src/cut.c: 160 fewer lines

	Helpers extracted (replacing repeated inline patterns):
	- write_line_delim(), write_pending_line_delim(), reset_item_line()
	  - line boundary code used by cut_bytes{,no_split}, cut_characters
	- write_selected_item()
	  - output-delimiter + write logic used by all three byte/char functions
	- reset_field_line()
	  - field line reset used by cut_fields_mb_any

	Field functions unified via cut_fields_mb_any(stream, whitespace_mode):
	- struct mbfield_parser encapsulates the whitespace vs.
	  fixed-delimiter state (saved char, mode flag)
	- mbfield_get_char() - dispatches to saved-char or direct read
	- mbfield_terminator()
	  - returns FIELD_{DATA,DELIMETER,LINE_DELIMITER} based on mode
	- read_mb_field_to_buffer()
	  - replaces the two duplicated first-field buffering loops
	- scan_mb_field(mbbuf, parser, pending, write_field)
	  - replaces the four duplicated field scan loops
	  (print+skip × two modes) with a single function and a write_field bool
	- cut_fields_mb and cut_fields_ws are now trivial wrappers

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: implement -n to avoid outputting partial characters
	Both the i18n patch and FreeBSD/macOS support this option.
	They do differ in behavior somewhat as the i18n patch
	may output more bytes than requested.

	  $ printf '\xc3\xa9b\n' | i18n-cut -n -b1
	  é

	There is also a bug in the i18n patch with multi-byte
	at the start of a line:

	  $ printf '\xc3\xa9b\n' | i18n-cut -n -b1-2
	  éb

	We follow the FreeBSD behavior since it seems more
	useful to have -b be a hard limit, rather than a soft limit.
	This also reduces the possibility of duplicate character output
	with separate cut invocations with non overlapping byte ranges.

	* src/cut.c (cut_bytes_no_split): A new function
	similar to cut_characters, to handle multi-byte characters
	with byte limit semantics.
	* tests/cut/cut.pl: Add test cases.

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	tests: cut: add a test for divergence from i18n patch
	* tests/cut/cut.pl: We don't fall back to byte mode
	upon invalid uni-byte delimiter.

	tests: cut: add case currently failing for coreutils-i18n patch
	* tests/cut/cut.pl: Test for extraneous character output with:
	printf 'aéb\n' | cut -s -d 'é' -f1 | od -tx1

	tests: cut: check multi-byte output delimiter
	* tests/cut/cut.pl: Add a test case.

	cut: adjust error message to be less specific
	* src/cut.c (main): Cater for both misplaced -w and -d.

	cut: implement -w,--whitespace-delimited
	* src/cut.c (cut_fields_ws): A new function handling both
	uni-byte and multi-byte cases.
	* tests/cut/cut.pl: Add a test cases.

	cut: support single byte -d with GB18030 input
	* src/cut.c
	* tests/cut/mb-non-utf8.sh
	* tests/local.mk

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: support single byte -d that may be part of multi-byte
	Note this is a slight divergence from the i18n patch
	as that switched to uni-byte for any single byte delimiter
	that is not valid multi-byte.

	That results in possibly splitting in the middle of
	a valid multi-byte character.

	Instead we only split on a single byte when they're
	not part of a multi-byte character.

	* src/cut.c

2026-04-05  Pádraig Brady  <P@draigBrady.com>

	cut: support multi-byte field delimiters
	* src/cut.c
	* tests/cut/cut.pl

	cut: support multi-byte input with -c
	* src/cut.c
	* tests/cut/cut.pl

	maint: cut: refactor output calls
	* src/cut.c (cut_fields): Refactor calls to fwrite() and putchar()

	tests: cut: ensure no unecessary buffering
	* tests/misc/write-errors.sh: Ensure we write output when possible.

	doc: cut: reorder --complement alphabetically in help
	* src/cut.c (usage): Move placement of --comlement description.
	* doc/coreutils.texi (cut invocation): Likewise.

	doc: cut: clarify description of -b and -c
	* src/cut.c (usage): State the arguments are positions,
	in case users may think they were values.

	build: update to latest gnulib
	Pick up mbrto{c32,wc} optimizations on UTF-8 on GLIBC.
	Note configure.ac defines the required GNULIB_WCHAR_SINGLE_LOCALE.
	This speeds up wc -m by 2.6x, when processing non ASCII chars,
	and will similarly speed up per character processing
	in the impending cut multi-byte implementation.
	* NEWS: Mention the wc -m speed improvement.

2026-04-04  Collin Funk  <collin.funk1@gmail.com>

	basename: avoid duplicate strlen calls on the suffix
	    $ ltrace -c ./src/basename-prev -s a $(seq 100000) > /dev/null
	    % time     seconds  usecs/call     calls      function
	    ------ ----------- ----------- --------- --------------------
	     50.00   30.030316          75    400000 strlen
	    [...]
	    $ ltrace -c ./src/basename -s a $(seq 100000) > /dev/null
	    % time     seconds  usecs/call     calls      function
	    ------ ----------- ----------- --------- --------------------
	     42.88   22.413953          74    300001 strlen
	    [...]

	* src/basename.c (remove_suffix, perform_basename): Add a length
	argument for the suffix and use it instead of strlen.
	(main): Calculate the suffix length. Refactor code to avoid calling
	perform_basename in multiple places.

2026-04-03  Paul Eggert  <eggert@cs.ucla.edu>

	date: simplify -u by not calling putenv
	* src/date.c (TZSET): Remove; no longer needed.
	(main): Simplify -u’s implementation by passing "UTC0" to tzalloc,
	rather than by setting TZ in the environment and then calling getenv.
	The old way of doing things dates back to before we had tzalloc.
	* configure.ac (LOCALTIME_CACHE): Remove; no longer needed.

2026-04-01  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

	maint: avoid sigaction lock overhead
	* configure.ac (GNULIB_SIGACTION_SINGLE_THREAD):
	Define to avoid unnecessary locking in Gnulib sigaction.  See:
	https://lists.gnu.org/r/bug-gnulib/2026-04/msg00008.html

	maint: avoid Gnulib modules mbiter, mbiterf
	* bootstrap.conf (avoided_gnulib_modules): Avoid mbiter and
	mbiterf, for the same reason we avoid mbuiter and mbuiterf: these
	modules are not needed because (due to mcel-prefer) we use mcel in
	preference to mbiter/mbiterf/mbuiter/mbuiterf.

	build: update gnulib submodule to latest

2026-04-01  oech3  <79379754+oech3@users.noreply.github.com>

	tests: dd: ensure memory exhaustion is handled gracefully
	* tests/dd/no-allocate.sh: Ensure we exit 1 upon mem allocation failure.
	Also check other buffer size edge cases.
	https://github.com/uutils/coreutils/issues/11436
	https://github.com/uutils/coreutils/issues/11580
	https://github.com/coreutils/coreutils/pull/235

2026-04-01  Pádraig Brady  <P@draigBrady.com>

	tests: dd: avoid false failure with no controlling terminal
	* tests/dd/misc.sh: test -w /dev/tty is not a strong enough check,
	we need to actually open /dev/tty to ensure it's available.
	It's not available under setsid for example.

2026-03-31  oech3  <79379754+oech3@users.noreply.github.com>

	tests: dd: check that erroneous seeks are not done in output
	* tests/dd/misc.sh: Add test case for of=/dev/tty.
	The same occurs for /dev/stdout, but that varies
	in the test hardness so is best avoided.
	https://github.com/coreutils/coreutils/pull/234

2026-03-30  oech3  <79379754+oech3@users.noreply.github.com>

	tests: coreutils: ensure empty arg is diagnosed
	* tests/misc/coreutils.sh: Add a test case.
	https://github.com/coreutils/coreutils/pull/232

2026-03-29  Collin Funk  <collin.funk1@gmail.com>

	date: avoid calling putenv multiple times unnecessarily
	Adding environment variables can become quite expensive in some
	admittedly unlikely situations.

	    $ for i in $(seq 10000); do export A$i=A$i; done
	    $ time ./src/date-prev -u $(yes -- -u | head -n 100000)
	    Sun Mar 29 01:59:49 AM UTC 2026

	    real	0m3.753s
	    user	0m3.684s
	    sys	0m0.050s
	    $ time ./src/date -u $(yes -- -u | head -n 100000)
	    Sun Mar 29 02:00:00 AM UTC 2026

	    real	0m0.061s
	    user	0m0.022s
	    sys	0m0.045s

	* src/date.c (main): Only add TZ=UTC0 to the environment once.

2026-03-28  Collin Funk  <collin.funk1@gmail.com>

	maint: remove unnecessary return statements
	* src/env.c (initialize_signals): Remove return at the end of the
	function.
	* src/who.c (print_runlevel): Likewise.

	who: avoid locking standard output for each user with the -q option
	* src/who (list_entries_who): Prefer putchar and fputs to printf.
	Simplify separator tracking.

	doc: tty: mention the removal of the -s option from POSIX
	* doc/coreutils.texi (tty invocation): Mention that POSIX.1-2001 removed
	the -s option and that portable scripts can redirect standard out to
	/dev/null instead.

2026-03-27  oech3  <79379754+oech3@users.noreply.github.com>

	tests: env/env.sh: improve portability
	* tests/env/env.sh: Make more portable by avoiding references to our
	build dir,  and avoiding names that may cause false matches in
	multi-call binaries.
	https://github.com/coreutils/coreutils/pull/216

2026-03-25  Pádraig Brady  <P@draigBrady.com>

	od: suppress address output on read error
	We don't output an address for `od missing` or `od --strings .`,
	so be consistent and suppress the address for `od .`.

	* src/od.c (dump): Only output an address if no errors
	or the offset is non zero.

2026-03-25  oech3  <79379754+oech3@users.noreply.github.com>

	tests: od: ensure -j1 /dev/null succeeds
	Users may be using this to convert bases.

	* tests/od/od-j.sh: Add a test case.
	https://github.com/coreutils/coreutils/pull/228

2026-03-25  Collin Funk  <collin.funk1@gmail.com>

	tests: truncate: don't rely on errno being EISDIR
	* tests/truncate/multiple-files.sh: Only check that an error is printed
	instead of an exact message.
	Reported by Bruno Haible.

2026-03-24  oech3  <79379754+oech3@users.noreply.github.com>

	tests: yes: support more zero-copy related syscalls
	* tests/misc/yes.sh: Disable other related zero-copy syscalls
	to ensure better testing of future or other implementations.
	https://github.com/coreutils/coreutils/pull/227

2026-03-24  Collin Funk  <collin.funk1@gmail.com>

	maint: remove some unnecessary casts
	* src/sort.c (begfield, limfield): Remove size_t casts.

2026-03-23  Sylvestre Ledru  <sylvestre@debian.org>

	tests: cut: add test for -z with NUL delimiter and -s flag
	* tests/cut/cut.pl (zerot-7): New test.
	Identified https://github.com/uutils/coreutils/pull/11394
	https://github.com/coreutils/coreutils/pull/226

	tests: tr: add test for invalid character class name
	* tests/tr/tr.pl (invalid-class): New test.
	Identified : https://github.com/uutils/coreutils/pull/11398
	https://github.com/coreutils/coreutils/pull/225

2026-03-23  Chris Down  <chris@chrisdown.name>

	sort: speed up keyed field sorting significantly using memchr
	When sort is invoked with an explicit field separator with `-t SEP`,
	begfield() and limfield() scan for the separator to locate boundaries.
	Right now the implementation there uses a loop that iterates over bytes
	one by one, which is not ideal since we must scan past many bytes of
	non-separator data one byte at a time.

	Let's replace each of these loops with memchr(). On glibc systems,
	memchr() uses SIMD to scan 16 bytes per step (NEON on aarch64) or 32
	bytes per step (AVX2 on x86_64), rather than 1 byte at a time, so any
	field longer than a handful of bytes stands to benefit quite
	significantly.

	Using the following input data:

	  awk 'BEGIN {
	      srand(42)
	      for (i = 1; i <= 500000; i++)
	          printf "%*d,%*d,%d\n", 4+int(rand()*9), 0,
	                                 4+int(rand()*9), 0, int(rand()*10000)
	  }' > short_csv_500k

	  awk 'BEGIN {
	      for (i = 1; i <= 500000; i++)
	          printf "%100d,%100d,%d\n", 0, 0, int(rand()*10000)
	  }' > wide_csv_500k

	One can benchmark with:

	  hyperfine --warmup 10 --runs 50 \
	    "LC_ALL=C sort_before -t, -k3,3n short_csv_500k > /dev/null" \
	    "LC_ALL=C sort_after -t, -k3,3n short_csv_500k > /dev/null"

	  hyperfine --warmup 10 --runs 50 \
	    "LC_ALL=C sort_before -t, -k3,3n wide_csv_500k > /dev/null" \
	    "LC_ALL=C sort_after -t, -k3,3n wide_csv_500k > /dev/null"

	  hyperfine --warmup 10 --runs 50 \
	    "LC_ALL=C sort_before wide_csv_500k > /dev/null" \
	    "LC_ALL=C sort_after wide_csv_500k > /dev/null"

	The results on i9-14900HX x86_64 with -O2:

	  sort -t, -k3,3n (500K lines, 4-12 byte short fields):
	    Before: 123.1 ms    After: 108.1 ms    (-12.2%)

	  sort -t, -k3,3n (500K lines, 100 byte wide fields):
	    Before: 243.5 ms    After: 165.9 ms    (-31.9%)

	  sort (default, no -k, 500K lines):
	    Before: 141.6 ms    After: 141.8 ms    (unchanged)

	And on M1 Pro aarch64 with -O2:

	  sort -t, -k3,3n (500K lines, 4-12 byte short fields):
	    Before: 98.0 ms     After: 92.3 ms     (-5.8%)

	  sort -t, -k3,3n (500K lines, 100 byte wide fields):
	    Before: 240.8 ms    After: 183.0 ms    (-24.0%)

	  sort (default, no -k, 500K lines):
	    Before: 145.6 ms    After: 145.6 ms    (unchanged)

	Looking at profiling, the improvement is larger on x86_64 in these runs
	because glibc's memchr uses AVX2 to scan 32 bytes per step versus 16
	bytes per step with NEON on aarch64.

2026-03-22  Collin Funk  <collin.funk1@gmail.com>

	maint: fix an incomplete sentence
	* tests/pwd/argument.sh: Fix the test description.
	Reported by G. Branden Robinson.

	tests: pwd: test the behavior when given an argument
	* tests/pwd/argument.sh: New file.
	* tests/local.mk (all_tests): Add the new test.

2026-03-21  Collin Funk  <collin.funk1@gmail.com>

	tac: avoid unnecessary standard output buffering
	This has removes a tiny amount of overhead:

	    $ seq 10000000 > input
	    $ perf stat -e cpu-clock --repeat 1000 taskset 1 ./src/tac \
	        input 2>&1 > /dev/null | grep -F 'seconds time'
	              0.095707 +- 0.000223 seconds time elapsed  ( +-  0.23% )
	    $ perf stat -e cpu-clock --repeat 1000 taskset 1 ./src/tac-prev \
	        input 2>&1 > /dev/null | grep -F 'seconds time'
	             0.1009378 +- 0.0000995 seconds time elapsed  ( +-  0.10% )

	* src/tac.c (output): Use full_write instead of fread since we already
	buffer the output ourselves.

2026-03-21  Collin Funk  <collin.funk1@gmail.com>

	tests: rm: fix a test that would sometimes hang
	* tests/rm/dash-hint.sh: Add the file name argument to grep, as I
	intended when adding this test.

2026-03-21  Collin Funk  <collin.funk1@gmail.com>

	tac: promptly diagnose write errors
	This patch also fixes a bug where 'tac' would print a vague error on
	some inputs:

	    $ seq 10000 | ./src/tac-prev > /dev/full
	    tac-prev: write error
	    $ seq 10000 | ./src/tac > /dev/full
	    tac: write error: No space left on device

	In this case ferror (stdout) is true, but errno has been set back to
	zero by a successful fclose (stdout) call.

	* src/tac.c (output): Call write_error() if fwrite fails.
	* tests/misc/io-errors.sh: Check that 'tac' prints a detailed write
	error.
	* NEWS: Mention the improvement.

2026-03-21  Pádraig Brady  <P@draigBrady.com>

	tests: support checking for specific write errors
	* tests/misc/io-errors.sh: Support checkout for a specific error
	in commands that don't run indefinitely.  Currently all the explicitly
	listed commands output a specific error and do not need to be tagged.

2026-03-21  Collin Funk  <collin.funk1@gmail.com>

	tests: nl: check that all files are processed
	* tests/nl/multiple-files.sh: New file.
	* tests/local.mk (all_tests): Add the new test.

2026-03-20  Collin Funk  <collin.funk1@gmail.com>

	test: truncate: improve the test added in the previous commit
	* tests/truncate/multiple-files.sh: Check that nothing is printed to
	standard output and that standard error has the correct error.

	tests: truncate: check that all files are processed
	* tests/truncate/multiple-files.sh: New file.
	* tests/local.mk (all_tests): Add the new test.

2026-03-18  Collin Funk  <collin.funk1@gmail.com>

	sort,split,yes: ensure pipe and pipe2 don't open standard descriptors
	* bootstrap.conf (gnulib_modules): Add pipe2-safer.
	* cfg.mk (sc_require_unistd_safer): New rule for 'make syntax-check'.
	* gl/lib/fd-reopen.c: Include unistd--.h instead of unistd.h.
	* src/sort.c: Include unistd--.h.
	* src/split.c: Likewise.
	* src/yes.c: Likewise.

2026-03-16  Pádraig Brady  <P@draigBrady.com>

	tests: dd: fix false failure on NetBSD 10
	* tests/dd/partial-write.sh: Skip the test if
	nothing written at all, as was seen on NetBSD 10.
	Reported by Bruno Haible.

	tests: ls: fix false failure on FreeBSD
	* tests/ls/non-utf8-hidden.sh: Avoid sorting in ls, to avoid:
	ls: cannot compare file names ...: Illegal byte sequence
	seen on FreeBSD 14.
	Reported by Bruno Haible.

2026-03-16  Collin Funk  <collin.funk1@gmail.com>

	maint: tee: remove an affirm call to silence coverity
	* src/iopoll.c (write_wait): Don't check that an unsigned integer is
	always great than or equal to zero since that is always true.

	wc: make sure input buffer for neon 'wc -l' is aligned
	* src/wc_neon.c (wc_lines_neon): Use alignas.

2026-03-15  Collin Funk  <collin.funk1@gmail.com>

	tee: prefer file descriptors over streams
	We disable buffering on the streams anyways, so we were effectively
	calling the write system call previously despite using streams.

	* src/iopoll.h (fclose_wait, fwrite_wait): Remove declarations.
	(close_wait, write_wait): Add declarations.
	* src/iopoll.c (fwait_for_nonblocking_write, fclose_wait, fwrite_wait):
	Remove functions.
	(wait_for_nonblocking_write): New function based on
	fwait_for_nonblocking_write.
	(close_wait): New function based on fclose_wait.
	(write_wait): New function based on fwrite_wait.
	* src/tee.c: Include fcntl--.h. Don't include stdio--.h.
	(get_next_out): Operate on file descriptors instead of streams.
	(fail_output): Likewise. Remove clearerr call since we no longer call
	fwrite on stdout.
	(tee_files): Operate on file descriptors instead of streams. Remove
	calls to setvbuf.

2026-03-14  Collin Funk  <collin.funk1@gmail.com>

	timeout: don't exit immediately if the parent is the init process
	* src/timeout.c (main): Save the process ID before creating a child
	process. Check if the result of getppid is different than the saved
	process ID instead of checking if it is 1.
	* tests/timeout/init-parent.sh: New file.
	* tests/local.mk (all_tests): Add the new test.
	* NEWS: Mention the bug fix. Also mention that this change allows
	'timeout' to work when reparented by a subreaper process instead of
	init.

2026-03-13  Pádraig Brady  <P@draigBrady.com>

	doc: fix missing '=' in texi option descriptions
	* doc/coreutils.texi (cut invocation, fold invocation):
	Fix missing '=' before option parameters.

2026-03-12  Pádraig Brady  <P@draigBrady.com>

	dd: always diagnose partial writes on write failure
	* src/dd.c (dd_copy): Increment the partial write count upon failure.
	* tests/dd/partial-write.sh: Add a new test.
	* tests/local.mk: Reference the new test.
	* NEWS: Mention the bug fix.
	Fixes https://bugs.gnu.org/80583

	doc: clarify a recent NEWS item
	* NEWS: It was ambiguous as to whether we quoted a range of
	observered throughputs.  Clarify this was the old and new
	throughput on a single test system.

2026-03-11  Collin Funk  <collin.funk1@gmail.com>

	doc: NEWS: adjust 'wc -l' aarch64 benchmark after recent commit
	After commit e0190a9d1 (wc: improve aarch64 Neon optimization for
	'wc -l', 2026-03-09), on a Ampere eMAG machine:

	    $ yes | head -n 10000000000 > input
	    $ (time ./src/wc -l input)
	    10000000000 input

	    real	0m3.447s
	    user	0m1.533s
	    sys	0m1.913s
	    $ (export GLIBC_TUNABLES='glibc.cpu.hwcaps=-ASIMD,-AVX2,-AVX512F'; \
	       time ./src/wc -l input)
	    10000000000 input

	    real	0m15.758s
	    user	0m14.039s
	    sys	0m1.720s

	* NEWS: Mention the improved benchmark.

2026-03-11  Collin Funk  <collin.funk1@gmail.com>

	tests: rm: check for hints when running 'rm -foo'
	* tests/rm/dash-hint.sh: New file.
	* tests/local.mk (all_tests): Add the new test.

2026-03-10  Pádraig Brady  <P@draigBrady.com>

	maint: adjust to placate coverity
	* src/system.h (c32issep): Adjust to more standard layout.

2026-03-10  Pádraig Brady  <P@draigBrady.com>

	yes: use a zero-copy implementation via (vm)splice
	A good reference for the concepts used here is:
	https://mazzo.li/posts/fast-pipes.html
	We don't consider huge pages or busy loops here,
	but use vmsplice(), and splice() to get significant speedups:

	  i7-5600U-laptop $ taskset 1 yes | taskset 2 pv > /dev/null
	  ... [4.98GiB/s]
	  i7-5600U-laptop $ taskset 1 src/yes | taskset 2 pv > /dev/null
	  ... [34.1GiB/s]

	  IBM,9043-MRX $ taskset 1 yes | taskset 2 pv > /dev/null
	  ... [11.6GiB/s]
	  IBM,9043-MRX $ taskset 1 src/yes | taskset 2 pv > /dev/null
	  ... [175GiB/s]

	Also throughput to file (on BTRFS) was seen to increase significantly.
	With a Fedora 43 laptop improving from 690MiB/s to 1.1GiB/s.

	* bootstrap.conf: Ensure sys/uio.h is present.
	This was an existing transitive dependency.
	* m4/jm-macros.m4: Define HAVE_SPLICE appropriately.
	We assume vmsplice() is available if splice() is as they
	were introduced at the same time to Linux and glibc.
	* src/yes.c (repeat_pattern): A new function to efficiently
	duplicate a pattern in a buffer with memcpy calls that double in size.
	This also makes the setup for the existing write() path more efficient.
	(pipe_splice_size): A new function to increase the kernel pipe buffer
	if possible, and use an appropriately sized buffer based on that (25%).
	(splice_write): A new function to call vmplice() when outputting
	to a pipe, and also splice() if outputting to a non-pipe.
	* tests/misc/yes.sh: Verify the non-pipe output case,
	(main): Adjust to always calling write on the minimal buffer first,
	then trying vmsplice(), then falling back to write from bigger buffer.
	and the vmsplice() fallback to write() case.
	* NEWS: Mention the improvement.

2026-03-10  Pádraig Brady  <P@draigBrady.com>

	all: use more consistent blank character determination
	* src/system.h (c32issep): A new function that is essentially
	iswblank() on GLIBC platforms, and iswspace() with exceptions elsewhere.
	* src/expand.c: Use it instead of c32isblank().
	* src/fold.c: Likewise.
	* src/join.c: Likewise.
	* src/numfmt.c: Likewise.
	* src/unexpand.c: Likewise.
	* src/uniq.c: Likewise.
	* NEWS: Mention the improvement.

2026-03-10  Pádraig Brady  <P@draigBrady.com>

	cksum: fix tagged output on 32 bit platforms
	Fix an unreleased issue due to the recent change
	to using idx_t in commit v9.10-91-g02983e493

	* src/cksum.c (output_file): Cast the idx_t before passing to printf.

2026-03-10  Collin Funk  <collin.funk1@gmail.com>

	wc: improve aarch64 Neon optimization for 'wc -l'
	    $ yes abcdefghijklmnopqrstuvwxyz | head -n 200000000 > input
	    $ time ./src/wc-prev -l input
	    200000000 input

	    real	0m1.240s
	    user	0m0.456s
	    sys	0m0.784s
	    $ time ./src/wc -l input
	    200000000 input

	    real	0m0.936s
	    user	0m0.141s
	    sys	0m0.795s

	* configure.ac: Use unsigned char for the buffer to avoid potential
	compiler warnings. Check for the functions being used in src/wc_neon.c
	after this patch.
	* src/wc_neon.c (wc_lines_neon): Use vreinterpretq_s8_u8 to convert 0xff
	into -1 instead of bitwise AND instructions into convert it into 1.
	Perform the pairwise addition and lane extraction once every 8192 bytes
	instead of once every 64 bytes.
	Thanks to Lasse Collin for spotting this and reviewing a draft of this
	patch.

2026-03-09  Pádraig Brady  <P@draigBrady.com>

	tests: expand: fix false failure on various systems
	* tests/expand/mb.sh: Use $LOCALE_FR_UTF8 rather than
	hardcoding "en_US.UTF-8".
	* tests/unexpand/mb.sh: Likewise.
	Reported by Bruno Haible.

	build: update to latest gnulib
	* src/ls.c: Adjust for renamed acl permissions member.

2026-03-08  Collin Funk  <collin.funk1@gmail.com>

	maint: remove duplicate names from THANKS
	* .mailmap: Prefer the most recently used email address from each commit
	author.

2026-03-08  Collin Funk  <collin.funk1@gmail.com>

	maint: prefer memset_explicit to explicit_bzero
	The explicit_bzero function is a common extension, but memset_explicit
	was standardized in C23. It will likely become more portable in the
	future, and Gnulib provides an implementation if needed.

	* bootstrap.conf (gnulib_modules): Add memset_explicit. Remove
	explicit_bzero.
	* gl/lib/randint.c (randint_free): Use memset_explicit instead of
	explicit_bzero.
	* gl/lib/randread.c (randread_free_body): Likewise.

2026-03-07  Lukáš Zaoral  <lzaoral@redhat.com>

	expand,unexpand: support multi-byte input
	* src/expand.c: Use mbbuf to support multi-byte input.
	* src/unexpand.c: Likewise.
	* tests/expand/mb.sh: New multi-byte test.
	* tests/unexpand/mb.sh: Likewise.
	* tests/local.mk: Reference new tests.
	* NEWS: Mention the improvement.

2026-03-07  Weixie Cui  <cuiweixie@gmail.com>

	maint: shred: fix typo in comment
	* src/shred.c: Fix "then" -> "than" in comment.

2026-03-06  Weixie Cui  <cuiweixie@gmail.com>

	maint: dd: fix typo in comment
	* src/dd.c: Fix "that that" -> "that the" in comment.

2026-03-06  Collin Funk  <collin.funk1@gmail.com>

	build: update gnulib submodule to latest

	build: update gnulib submodule to latest

2026-03-05  Collin Funk  <collin.funk1@gmail.com>

	maint: touch: reduce variable scope
	* src/touch.c (main): Declare variables where they are used instead of
	at the start of the function.

	maint: chown,chgrp: reduce variable scope
	* src/chown-core.c (describe_change, restricted_chown)
	(change_file_owner, chown_files): Declare variables where they are used
	instead of at the start of the function.
	* src/chown.c (main): Likewise.

	install: allow the combination of --compare and --preserve-timestamps
	* NEWS: Mention the improvement.
	* src/install.c (enum copy_status): New type to let the caller know if
	the copy was performed or skipped.
	(copy_file): Return the new type instead of bool. Reduce variable scope.
	(install_file_in_file): Only strip the file if the copy was
	performed. Update the timestamps if the copy was skipped.
	(main): Don't error when --compare and --preserve-timestamps are
	combined.
	* tests/install/install-C.sh: Add some test cases.

2026-03-04  Pádraig Brady  <P@draigBrady.com>

	cksum: use more defensive escaping for --check
	cksum --check is often the first interaction
	users have with possibly untrusted downloads, so we should try
	to be as defensive as possible when processing it.

	Specifically we currently only escape \n characters in file names
	presented in checksum files being parsed with cksum --check.
	This gives some possibilty of dumping arbitrary data to the terminal
	when checking downloads from an untrusted source.
	This change gives these advantages:

	  1. Avoids dumping arbitrary data to vulnerable terminals
	  2. Avoids visual deception with ansi codes hiding checksum failures
	  3. More secure if users copy and paste file names from --check output
	  4. Simplifies programmatic parsing

	Note this changes programmatic parsing, but given the original
	format was so awkward to parse, I expect that's extremely rare.
	I was not able to find example in the wild at least.
	To parse the new format from from shell, you can do something like:

	  cksum -c checksums | while IFS= read -r line; do
	    case $line in
	      *': FAILED')
	        filename=$(eval "printf '%s' ${line%: FAILED}")
	        cp -v "$filename" /quarantine
	        ;;
	    esac
	  done

	This change also slightly reduces the size of the sum(1) utility.
	This change also apples to md5sum, sha*sum, and b2sum.

	* src/cksum.c (digest_check): Call quotef() instead of
	cksum(1) specific quoting.
	* tests/cksum/md5sum-bsd.sh: Adjust accordingly.
	* doc/coreutils.texi (cksum general options): Describe the
	shell quoting used for problematic file names.
	* NEWS: Mention the change in behavior.
	Reported by: Aaron Rainbolt

2026-03-04  Pádraig Brady  <P@draigBrady.com>

	maint: tests: refactor uses of bad_unicode()
	* init.cfg: Use 0xFF rather than 0xC3 everywhere.
	* tests/fold/fold-characters.sh: Reuse bad_unicode().
	* tests/tac/tac-locale.sh: Likewise.

2026-03-04  Pádraig Brady  <P@draigBrady.com>

	fold: fix output truncation with 0xFF bytes in input
	On signed char platforms, 0xFF was converted to -1
	which matches MBBUF_EOF, causing fold to stop processing.

	* NEWS: Mention the bug fix.
	* gl/lib/mbbuf.h: Avoid sign extension on signed char platforms.
	* tests/fold/fold-characters.sh: Adjust test case.
	Reported at https://src.fedoraproject.org/rpms/coreutils/pull-request/20

2026-03-04  Sylvestre Ledru  <sylvestre@debian.org>

	tests: date: add timezone conversion test
	*tests/date/date.pl: Add the test case.
	Add test case for https://github.com/uutils/coreutils/issues/10800
	to verify `date -u -d '10:30 UTC-05'` converts to 15:30 UTC.

	tests: date: add edge cases for modifiers
	* tests/date/date.pl: Add the test case.
	Add test cases for https://github.com/uutils/coreutils/issues/10957

	tests: cut: add test case for newline delimiter with -s flag
	* tests/cut/cut.pl: Add a new test case.
	https://github.com/coreutils/coreutils/pull/211

2026-03-03  oech3  <79379754+oech3@users.noreply.github.com>

	tests: mktemp: ensure mktemp does not depend on getrandom and ASLR
	* tests/mktemp/mktemp-misc.sh: Add new test.
	* tests/local.mk: Reference new test.
	https://github.com/coreutils/coreutils/pull/206

2026-03-03  Pádraig Brady  <P@draigBrady.com>

	maint: tests: decouple debug output determination
	* tests/misc/warning-errors.sh: Simply check there is output
	to stderr before checking that output induces an error.

2026-03-03  Collin Funk  <collin.funk1@gmail.com>

	tests: avoid false test failure when using address sanitizer
	* tests/misc/warning-errors.sh: Skip commands which have been built with
	sanitizers, since standard error will not be closed and checked for
	errors.
	Reported by Bruno Haible.

	tests: avoid failure on systems without an optimized 'cksum' or 'wc -l'
	* tests/misc/warning-errors.sh: Expect 'wc' and 'cksum' to exit
	successfully if there is not an optimized 'wc -l' implementation or
	CRC32 implementation.
	Reported by Bruno Haible.

2026-03-02  oech3  <79379754+oech3@users.noreply.github.com>

	tests: shuf: ensure memory exhaustion is handled gracefully
	* tests/shuf/shuf.sh: Ensure we exit 1 upon failure
	to allocate memory.
	https://github.com/uutils/coreutils/issues/11170
	https://github.com/coreutils/coreutils/pull/209

2026-03-02  Sylvestre Ledru  <sylvestre@debian.org>

	test: cp: add test for non-UTF8 directory names
	Missing test identified here:
	 https://github.com/uutils/coreutils/pull/11148

	* tests/cp/non-utf8-name.sh: Add a new test to cover this case.
	https://github.com/coreutils/coreutils/pull/207

2026-03-01  Paul Eggert  <eggert@cs.ucla.edu>

	du: fflush after outputting a line
	* src/du.c (print_size): Resurrect the fflush call, since there
	can be significant delay between output lines.

2026-03-01  Collin Funk  <collin.funk1@gmail.com>

	tests: wc,du: add additional --files0-from test cases
	* tests/wc/wc-files0-from.pl ($limits): New variable.
	(@Tests): Prefer the error strings from getlimits over writing them by
	hand. Add test cases for --files0-from listing missing files and
	duplicate files.
	* tests/du/files0-from.pl ($limits): New variable.
	(@Tests): Prefer the error strings from getlimits over writing them by
	hand. Add test cases for --files0-from listing missing files. Add tests
	for --files0-from listing duplicate files with and without the -l option
	also in use.

2026-02-28  Collin Funk  <collin.funk1@gmail.com>

	build: update gnulib submodule to latest
	* po/POTFILES.in: Remove recently added lib/cygpath.c dependency after
	gnulib commit 2a893de047 (filesystem-remote: New module., 2026-02-28).

2026-02-28  Sylvestre Ledru  <sylvestre@debian.org>

	tests: ls: treat invalid UTF-8 paths starting with a dot as hidden
	* tests/ls/non-utf8-hidden.sh: Add the test case.
	https://github.com/uutils/coreutils/pull/11135
	https://github.com/coreutils/coreutils/pull/202

2026-02-28  Sylvestre Ledru  <sylvestre@debian.org>

	tests: ln: verify that -f and -i override each other
	Identified here:
	<https://github.com/uutils/coreutils/pull/11129>

	* tests/ln/misc.sh: Add the check.
	 https://github.com/coreutils/coreutils/pull/199

2026-02-28  Sylvestre Ledru  <sylvestre@debian.org>

	test: ln: verify backup suffix path traversal prevention
	missing test detected thanks to:
	https://github.com/uutils/coreutils/pull/11149

	* tests/ln/backup-suffix-traversal.sh: Add a test.
	https://github.com/coreutils/coreutils/pull/208

2026-02-28  Pádraig Brady  <P@draigBrady.com>

	maint: fix typo in previous test
	* tests/shuf/shuf.sh: Use non varying $ret rather than $?

2026-02-28  oech3  <79379754+oech3@users.noreply.github.com>

	tests: shuf: ensure we handle unsupported getrandom syscall gracefully
	* tests/shuf/shuf.sh: Check we fail normally or succeed where
	the getrandom syscall is not available.
	https://github.com/coreutils/coreutils/pull/205

2026-02-28  Pádraig Brady  <P@draigBrady.com>

	build: update gnulib to latest
	* NEWS: Mention the more encompassing remoteness check for df.
	* po/POTFILES.in: Add new lib/cygpath.c dependency.

2026-02-28  Collin Funk  <collin.funk1@gmail.com>

	du: avoid locking and flushing standard output
	This results in a noticeable increase in performance:

	    $ yes /dev/null | head -n 10000000 | tr '\n' '\0' \
	        | time --format=%E ./src/du-prev -l --files0-from=- > /dev/null
	    0:20.40
	    $ yes /dev/null | head -n 10000000 | tr '\n' '\0' \
	        | time --format=%E ./src/du -l --files0-from=- > /dev/null
	    0:16.57

	* src/du.c (print_size): Prefer putchar and fputs which may be unlocked
	unlike printf. Prefer ferror to fflush.

2026-02-28  Paul Eggert  <eggert@cs.ucla.edu>

	stat: handle %%%N too
	* src/stat.c (main): Fix incorrect counting of '%'s before 'N'.
	* tests/stat/stat-fmt.sh: Test for the bug.

	id: avoid unnecessary buffer flushing
	* src/groups.c (main):
	* src/id.c (main, print_stuff):
	Don’t flush stdout before testing for write error.
	Do the test only when in a loop, as a one-shot will
	test for write error soon anyway.

	cksum: prefer signed int
	* src/cksum.c (min_digest_line_length, digest_hex_bytes)
	(digest_length, md5_sum_stream, sha1_sum_stream)
	(sha224_sum_stream, sha256_sum_stream, sha384_sum_stream)
	(sha512_sum_stream, sha2_sum_stream, sha3_sum_stream)
	(blake2b_sum_stream, sm3_sum_stream, problematic_chars)
	(filename_unescape, valid_digits, bsd_split_3)
	(algorithm_from_tag, split_3, digest_file, output_file)
	(b64_equal, hex_equal, digest_check, main):
	* src/cksum_avx2.c (cksum_avx2):
	* src/cksum_avx512.c (cksum_avx512):
	* src/cksum_crc.c (cksum_fp_t, cksum_slice8, crc_sum_stream)
	(crc32b_sum_stream, output_crc):
	* src/cksum_pclmul.c (cksum_pclmul):
	* src/cksum_vmull.c (cksum_vmull):
	* src/sum.c (bsd_sum_stream, sysv_sum_stream, output_bsd, output_sysv):
	Prefer signed to unsigned int where either will do.
	This allows better checking with -fsanitize=undefined.
	It should also help simplify future patches, so that they
	needn’t worry whether comparisons like ‘i < len - 2’ will misbehave.

2026-02-27  Collin Funk  <collin.funk1@gmail.com>

	stat: don't check QUOTING_STYLE when --printf %%N is used
	* NEWS: Mention the fix.
	* src/stat.c (main): Only check QUOTING_STYLE if there is a %N that is
	not preceded by a percentage sign.
	* tests/stat/stat-fmt.sh: Add some test cases.

	id: promptly diagnose write errors
	* NEWS: Mention the improvement.
	* src/id.c (print_stuff): Call fflush for each listed user to check for
	write errors.
	* tests/misc/io-errors.sh: Add an invocation of 'id'.

	groups: promptly diagnose write errors
	* NEWS: Mention the improvement.
	* src/groups.c (main): Call fflush for each listed user to check for
	write errors.
	* tests/misc/io-errors.sh: Add an invocation of 'groups'.

2026-02-26  Pádraig Brady  <P@draigBrady.com>

	tests: ensure failure to write warnings is handled gracefully
	* tests/misc/warning-errors.sh: Add a new test to ensure
	failure to write warnings is diagnosed in the exit status.
	* tests/local.mk: Reference the new test.

2026-02-26  oech3  <79379754+oech3@users.noreply.github.com>

	tests: shuf: ensure randomization doesn't depend solely on ASLR
	* tests/shuf/shuf.sh: Use setarch --addr-no-randomize to disable
	ASLR, and show the output is still random.
	https://github.com/coreutils/coreutils/pull/198

2026-02-26  Pádraig Brady  <P@draigBrady.com>

	maint: fix description of tests/misc/io-errors.sh
	* tests/misc/io-errors.sh: Promptness is checked in
	write-errors.sh, not this test.

2026-02-25  oech3  <79379754+oech3@users.noreply.github.com>

	tests: nice: ensure a particular adjustment is disallowed
	* tests/nice/nice-fail.sh: Ensure "1+2-3" is disallowed.
	https://github.com/coreutils/coreutils/pull/197

2026-02-25  Pádraig Brady  <P@draigBrady.com>

	tests: factor,numfmt: verify embedded NUL handling
	* tests/factor/factor.pl: Verify that embedded NULs
	on stdin terminate the _number_.
	* tests/numfmt/numfmt.p: Verify that embedded NULs
	on stdin terminate the _line_.
	https://github.com/coreutils/coreutils/pull/196

2026-02-24  Pádraig Brady  <P@draigBrady.com>

	tests: fix "Hangup" termination of non-interactive runs
	This avoids the test harness being terminated like:
	  make[1]: *** [Makefile:24419: check-recursive] Hangup
	  make[3]: *** [Makefile:24668: check-TESTS] Hangup
	  make: *** [Makefile:24922: check] Hangup
	  make[2]: *** [Makefile:24920: check-am] Hangup
	  make[4]: *** [Makefile:24685: tests/misc/usage_vs_refs.log] Error 129
	  ...

	This happened sometimes when the tests were being run non interactively.
	For example when run like:

	  setsid make TESTS="tests/timeout/timeout.sh \
	   tests/tail/overlay-headers.sh" SUBDIRS=. -j2 check

	Note the race window can be made bigger by adding a sleep
	after tail is stopped in overlay-headers.sh

	The race can trigger the kernel to induce its job control
	mechanism to prevent stuck processes.
	I.e. where it sends SIGHUP + SIGCONT to a process group
	when it determines that group may become orphaned,
	and there are stopped processes in that group.

	* tests/tail/overlay-headers.sh: Use setsid(1) to keep the stopped
	tail process in a separate process group, thus avoiding any kernel
	job control protection mechanism.
	* tests/timeout/timeout.sh: Use setsid(1) to avoid the kernel
	checking the main process group when sleep(1) is reparented.
	Fixes https://bugs.gnu.org/80477

2026-02-23  Collin Funk  <collin.funk1@gmail.com>

	doc: tee: avoid the use of gpg cleartext signatures in an example
	Cleartext signatures have many gotchas. Therefore, the use of detached
	signatures is recommended where possible. See:
	<https://gnupg.org/blog/20251226-cleartext-signatures.html>.

	* doc/coreutils.texi (tee invocation): Adjust gpg invocation to produce
	a detached signature.

2026-02-23  oech3  <79379754+oech3@users.noreply.github.com>

	tests: whoami, logname: verify error handling
	* tests/df/no-mtab-status-masked-proc.sh: Tweak unshare check.
	* tests/local.mk: Reference new test.
	* tests/misc/user.sh: Add new test using unshare -U, to verify
	that whoami and logname diagnose failure correctly.
	https://github.com/coreutils/coreutils/pull/195

2026-02-22  Collin Funk  <collin.funk1@gmail.com>

	doc: stty: mention the -g does not save the terminal window size
	* doc/coreutils.texi (stty invocation): Mention that 'stty -g' does not
	save the terminal window size as allowed by POSIX.1-2024.

	tests: shuf: check that write errors are promptly diagnosed
	* tests/misc/write-errors.sh: Add a shuf invocation that would run
	forever if write errors weren't diagnosed.

2026-02-22  Collin Funk  <collin.funk1@gmail.com>

	shuf: avoid locking standard output when using --input-range
	Here is the throughput before this patch:

	    # write_permuted_numbers
	    $ ./src/shuf-prev -i 0-100000000 | pv -r > /dev/null
	    [ 153MiB/s]

	    # write_random_numbers
	    $ timeout 10 ./src/shuf-prev -i 0-100000 -r | pv -r > /dev/null
	    [78.6MiB/s]

	Here is the throughput after this patch:

	    # write_permuted_numbers
	    $ timeout 10 ./src/shuf -i 0-100000000 | pv -r > /dev/null
	    [ 308MiB/s]

	    # write_random_numbers
	    $ timeout 10 ./src/shuf -i 0-100000 -r | pv -r > /dev/null
	    [ 196MiB/s]

	* NEWS: Mention the performance improvement.
	* src/shuf.c (write_permuted_numbers, write_random_numbers): Prefer
	fputs and fputc which may be unlocked over printf which locks standard
	output.

2026-02-21  Collin Funk  <collin.funk1@gmail.com>

	tests: chmod: test that chmod(2) is always called
	* tests/chmod/only-op.sh: New file.
	* tests/local.mk (all_test): Add the new test.

2026-02-20  Collin Funk  <collin.funk1@gmail.com>

	maint: printf: prefer static initialization
	* src/printf.c (main): Remove unnecessary initialization.

	maint: fmt: prefer static initialization
	* src/fmt.c (prefix, max_width): Initialize variables.
	(main): Remove unnecessary initializations.

	maint: sort: prefer static initialization
	* src/sort.c (main): Remove unnecessary initialization.

	maint: df: prefer static initialization
	* src/df.c (human_output_opts, grand_fsu): Initialize variables.
	(main): Remove unnecessary initializations.

	maint: split: prefer static initialization
	* src/split.c (outbase, infile): Initialize variables.
	(main): Remove unnecessary initializations.

	maint: tail: prefer static initialization
	* src/tail.c (count_lines, line_end): Initialize variables.
	(main): Remove unnecessary initializations.

	maint: csplit: prefer static initialization
	* src/csplit.c (prefix, remove_files): Initialize variables.
	(main): Remove unnecessary initializations.

	maint: comm: prefer static initialization
	* src/comm.c (only_file_1, only_file_2, both): Initialize variables.
	(main): Remove unnecessary initializations.

	maint: wc: prefer static initialization
	* src/wc.c (main): Remove unnecessary initializations.

	maint: tac: prefer static initialization
	* src/tac.c (separator, separator_ends_record, sentinel_length):
	Initialize variables.
	(main): Remove unnecessary initializations.

	maint: join: prefer static initialization
	* src/join.c (print_pairables): Initialize variable.
	(main): Remove unnecessary initializations.

	maint: cut: prefer static initialization
	* src/cut.c (main): Remove unnecessary initializations.

	maint: seq: prefer static initialization
	* src/seq.c (separator): Initialize variable.
	(main): Remove unnecessary initializations.

	maint: paste: prefer static initialization
	* src/paste.c (main): Remove unnecessary initializations.

	maint: install: prefer static initialization
	* src/install.c (main): Remove unnecessary initializations.

	maint: chmod: prefer static initialization
	* src/chmod.c (main): Remove unnecessary initializations.

	maint: head: prefer static initialization
	* src/head.c (line_end): Initialize variable.
	(main): Remove unnecessary initializations.

	maint: ln: prefer static initialization
	* src/ln.c (main): Remove unnecessary initializations.

	maint: nl: prefer static initialization
	* src/nl.c (main): Remove unnecessary initialization.

	maint: touch: prefer static initialization
	* src/touch.c (main): Remove unnecessary initializations.

	maint: fold: prefer static initialization
	* src/fold.c (main): Remove unnecessary initializations.

	maint: tee: prefer static initialization
	* src/tee.c (main): Remove unnecessary initializations.

	maint: rmdir: prefer static initialization
	* src/rmdir.c (main): Remove unnecessary initialization.

	maint: tty: prefer static initialization
	* src/tty.c (main): Remove unnecessary initialization.

2026-02-19  Pádraig Brady  <P@draigBrady.com>

	maint: tests: DRY a recent change
	* tests/pwd/pwd-long.sh: Adjust so complicated command is not repeated.

2026-02-19  Collin Funk  <collin.funk1@gmail.com>

	wc: add aarch64 Neon optimization for wc -l
	Here is an example of the performance improvement:

	    $ yes abcdefghijklmnopqrstuvwxyz | head -n 100000000 > input
	    $ time ./src/wc-prev -l < input
	    100000000

	    real	0m0.793s
	    user	0m0.630s
	    sys	0m0.162s
	    $ time ./src/wc -l < input
	    100000000

	    real	0m0.230s
	    user	0m0.065s
	    sys	0m0.164s

	* NEWS: Mention the performance improvement.
	* gnulib: Update to the latest commit.
	* configure.ac: Check the the necessary intrinsics and functions.
	* src/local.mk (noinst_LIBRARIES) [USE_NEON_WC_LINECOUNT]: Add
	src/libwc_neon.a.
	(src_libwc_neon_a_SOURCES, wc_neon_ldadd, src_libwc_neon_a_CFLAGS)
	[USE_NEON_WC_LINECOUNT]: New variables.
	(src_wc_LDADD) [USE_NEON_WC_LINECOUNT]: Add $(wc_neon_ldadd).
	* src/wc.c [USE_NEON_WC_LINECOUNT]: Include sys/auxv.h and asm/hwcap.h.
	(neon_supported) [USE_NEON_WC_LINECOUNT]: New function.
	(wc_lines) [USE_NEON_WC_LINECOUNT]: Use neon_supported and
	wc_lines_neon.
	* src/wc.h (wc_lines_neon): Add declaration.
	* src/wc_neon.c: New file.
	* doc/coreutils.texi (Hardware Acceleration): Document the "-ASIMD"
	hwcap and the variable used in ./configure to override detection of Neon
	instructions.
	* tests/wc/wc-cpu.sh: Also add "-ASIMD" to disable the use of Neon
	instructions.

2026-02-18  Pádraig Brady  <P@draigBrady.com>

	tests: use system ENOTEMPTY message
	* tests/mv/dir2dir.sh: Map system specific messages.
	* tests/rm/d-2.sh: Likewise.

	maint: tests: avoid ERANGE specific handling
	* tests/fmt/base.pl: Verify ERANGE is diagnosed.
	* tests/od/od.pl: Adjust determination of ERANGE.

	maint: tests: avoid ELOOP specific handling
	* tests/du/long-sloop.sh: Adjust determination of ELOOP.

	maint: tests: avoid ENOSPC specific handling
	* tests/csplit/csplit-io-err.sh: Adjust determination of ENOSPC.
	* tests/csplit/split-io-err.sh: Likewise.
	* tests/fold/fold-zero-width.sh: Verify full ENOSPC message.
	* tests/tac/tac-continue.sh: Likewise.
	* tests/misc/io-errors.sh: Likewise.
	* tests/misc/write-errors.sh: Likewise.

	tests: use system ENOSPC message
	* tests/head/head-write-error.sh: Verify ENOSPC is output.
	* tests/misc/yes.sh: Likewise.

	tests: use system ENOTSUP message
	* tests/cp/cp-mv-enotsup-xattr.sh: Don't hardcode "Operation not
	supported".
	* tests/cp/cp-a-selinux.sh: Likewise.

	maint: tests: avoid ENOTSUP specific handling
	* tests/mv/mv-exchange.sh: Use ENOTSUP rather than
	transforming variations.

	tests: use system EACCES message
	* tests/chgrp/no-x.sh: Don't harcode "Permission denied".
	* tests/chmod/no-x.sh: Likewise.
	* tests/du/inacc-dest.sh: Likewise.
	* tests/du/no-x.sh: Likewise.
	* tests/misc/nohup.sh: Likewise.
	* tests/mv/part-fail.sh: Likewise.
	* tests/mv/perm-1.sh: Likewise.
	* tests/rm/fail-eacces.sh: Likewise.
	* tests/rm/rm1.sh: Likewise.
	* tests/rm/rm2.sh: Likewise.
	* tests/rm/unread2.sh: Likewise.
	* tests/rm/unreadable.pl: Likewise.

	maint: tests: avoid AIX specific EACCES handling
	* tests/rm/inaccessible.sh: Remove AIX specific handling.
	* tests/cp/fail-perm.sh: Likeise.  Also remove confusing
	EPERM/HPUX mentions.
	* tests/misc/sync.sh: Don't hardcode EISDIR and EACCES.

	maint: tests: avoid EPERM/EACCES specific handling
	* tests/Coreutils.pm: Remove associated comment.
	* tests/mv/sticky-to-xpart.sh: Use $EACCES and $EPERM.
	* tests/rm/fail-2eperm.sh: Likewise.
	* tests/touch/not-owner.sh: Likewise.

	maint: tests: avoid EPERM specific handling
	* tests/dd/fail-ftruncate-fstat.sh: Use $EPERM rather than
	mapping specific strings to the Linux $EPERM.
	* tests/mkdir/smack-no-root.sh: Use $EPERM rather than hardcoding.

2026-02-18  Collin Funk  <collin.funk1@gmail.com>

	maint: expr: reduce variable scope
	* src/expr.c (mbs_logical_cspn, main, trace, docolon, eval7, eval6)
	(eval5, eval4, eval3, eval2, eval1, eval): Declare variables where they
	are used instead of at the start of the function.

2026-02-17  Pádraig Brady  <P@draigBrady.com>

	tests: pwd: ensure our getcwd fallback is tested
	* tests/pwd/pwd-long.sh: Avoid the getcwd syscall,
	to ensure our fallback getcwd code is exercised.
	* NEWS: Mention the recent bug fix in pwd.

2026-02-16  Chris Down  <chris@chrisdown.name>

	pwd: fix heap buffer overflow in file_name_prepend
	file_name_prepend works by right-aligning path data in a growing buffer.
	When the buffer is too small, it then allocates a new buffer via
	xpalloc() and copies existing data to the end of the new buffer.

	Unfortunately, the memcpy destination is computed as buf + p->n_alloc -
	n_free, but xpalloc has already updated p->n_alloc to the new (larger)
	allocation size while n_free still reflects the old state. This places
	the data at too high an offset, writing past the end of the buffer.

	Update to properly calculate the destination offset.

	Fixes: v9.5-171-g61ab25c35 ("pwd: prefer xpalloc to xnrealloc")

2026-02-15  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2026-02-14  Collin Funk  <collin.funk1@gmail.com>

	maint: seq,who: prefer xasprintf
	* src/seq.c (main): Use xasprintf instead of asprintf followed by a
	check if the allocation fails.
	* src/who.c (print_line): Likewise.

	maint: seq: reduce variable scope
	* src/seq.c (long_double_format, print_numbers, main): Declare variables
	where they are used instead of at the start of the function.

	tests: date: check that options can follow the format string
	* tests/date/date.pl (@Tests): Add the test case.

2026-02-12  Pádraig Brady  <P@draigBrady.com>

	doc: relax github issue/pull-request instructions
	Be more accepting of github issues and pull-requests.
	Be a bit less verbose in info provided.

2026-02-12  oech3  <79379754+oech3@users.noreply.github.com>

	tests: sort: ensure --batch-size=(rlimit+1) fails
	* tests/sort/sort-merge-fdlimit.sh: Add test case.
	https://github.com/coreutils/coreutils/pull/182

	tests: coreutils: remove redundant validity check
	* tests/misc/coreutils.sh: Remove the check for non-empty coreutils.h,
	as the existing `print_ver_ coreutils` is sufficient to determine
	support for single binary mode.
	https://github.com/coreutils/coreutils/pull/189

	tests: cp: ensure --debug output failure is diagnosed
	* tests/cp/debug.sh: cp diagnostics are written to stdout,
	so ensure output errors are diagnosed.
	https://github.com/coreutils/coreutils/pull/192

	tests: arch: add option parsing check
	* tests/misc/arch.sh: Ensure -- to indicate end of options is accepted.
	https://github.com/coreutils/coreutils/pull/191

2026-02-12  Pádraig Brady  <P@draigBrady.com>

	tests: date: check dotted EU dates in combination
	* tests/date/date.pl: Add other date elements
	to ensure abbreviated dotted dates are parsed appropriately.
	Corresponds to gnulib commit 451042cb76

	build: update gnulib to latest

2026-02-10  Pádraig Brady  <P@draigBrady.com>

	tests: determine errno string more efficiently
	* tests/misc/read-errors.sh: Use getlimits_ determined EIO error string,
	rather than inferring the string from bash's output.
	See https://bugs.gnu.org/80353

	tests: getlimits: output error strings
	* src/getlimits.c (main): Iterate over defined errnos,
	and output shell compatible error strings.
	* tests/Coreutils.pm: Adjust so shell quotes are stripped.

2026-02-10  Collin Funk  <collin.funk1@gmail.com>

	maint: pinky: reduce variable scope
	* src/pinky.c (create_fullname, idle_string, print_entry)
	(print_long_entry, main): Declare variables where they are used instead
	of at the start of the function. Initialize variables where they are
	declared.

2026-02-09  Pádraig Brady  <P@draigBrady.com>

	maint: remove extraneous code from test
	* tests/misc/usage_vs_refs.sh: Remove copy and paste slop.
	* tests/local.mk: Fix indentation.

2026-02-09  Collin Funk  <collin.funk1@gmail.com>

	nl: support multi-byte section delimiters
	* NEWS: Mention the improvement.
	* src/nl.c: Include mcel.h.
	(DEFAULT_SECTION_DELIMITERS): Resize to fit 2 multi-byte characters.
	(section_del_len): New variable.
	(check_section): Compare against section_del_len instead of 2.
	(main): Support multi-byte characters for the -d option.
	* tests/nl/multibyte.sh: New file.
	* tests/nl/nl.sh: New file, moved from tests/misc/nl.sh.
	* tests/local.mk (all_tests): Add the new test. Adjust the existing
	tests file name.
	* cfg.mk (exclude_file_name_regexp--sc_space_tab): Adjust Adjust the
	existing tests file name.

2026-02-08  Pádraig Brady  <P@draigBrady.com>

	tests: fix false failure with dash or ksh
	* tests/misc/read-errors.sh: Avoid dash or ksh as they
	do _not_ print an error message upon EIO from read.
	Fixes https://bugs.gnu.org/80353

2026-02-08  Gabriel  <gnu@gabriels.cloud>

	date: add tests and NEWS for dd.mm.yy support
	* NEWS: Mention the new feature.
	* tests/date/date.pl: Add test cases.

2026-02-08  Pádraig Brady  <P@draigBrady.com>

	build: update to latest gnulib
	* gnulib: Update to pick up support for dd.mm.yy format
	in parse-datetime.

2026-02-08  Sam James  <sam@gentoo.org>

	build: fix --enable-single-binary=hardlinks with dash
	With dash as /bin/sh, you get the error
	```
	checking for sys/capability.h... yes
	./configure: 95775: test: no: unexpected operator
	checking for working fork... yes
	```

	* configure.ac: Use '=' in test for equality, not '==',
	for POSIX shell compatibility.
	* NEWS: Mention the build fix.

2026-02-07  oech3  <79379754+oech3@users.noreply.github.com>

	tests: ptx: ensure bad unicode is supported
	* tests/ptx/ptx-overrun.sh: Ensure bad_unicode() is processed.

2026-02-07  Sylvestre Ledru  <sylvestre@debian.org>

	tests: cp: ensure read-only dir perms preserved
	* tests/cp/readonly-dir.sh: Add new test.
	* tests/local.mk: Reference new test.
	Identified here https://github.com/uutils/coreutils/issues/7961

2026-02-07  Collin Funk  <collin.funk1@gmail.com>

	doc: NEWS: mention the recent kill documentation fix
	* NEWS: Mention that the kill documentation now has the anchors expected
	by 'kill --help'.

2026-02-06  Collin Funk  <collin.funk1@gmail.com>

	tests: fold: check that all files are processed
	* tests/fold/multiple-files.sh: New file.
	* tests/local.mk (all_tests): Add the test.

	tests: nl: check that all files are processed
	* tests/misc/nl.sh: Add a test case.

2026-02-06  Dr. David Alan Gilbert  <dave@treblig.org>

	maint: unexpand: remove dead store
	The assign to next_tab_column in the backspace branch is never
	read; in fact it's always written and then read solely inside the
	blank branch.

	Move the declaration of 'next_tab_column' down into the blank
	branch, and remove its assignment in the backspace branch.

	Spotted by the 'infer' static checker.

	* src/unexpand.c (unexpand): Remove dead store of next_tab_column.

2026-02-06  oech3  <79379754+oech3@users.noreply.github.com>

	tests: ptx: add a robustness test case
	* tests/ptx/ptx-overrun.sh: Ensure input is processed without issue.
	https://github.com/coreutils/coreutils/pull/184

2026-02-06  Pádraig Brady  <P@draigBrady.com>

	doc: pr: use -COLS consistently
	Help this back from release as would break a couple of translations.

	* src/pr.c: Use COLS rather than COLUMN consistently
	in comments and usage().

2026-02-06  Collin Funk  <collin.funk1@gmail.com>

	doc: kill: adjust documentation to produce html anchors for --help
	* doc/coreutils.texi (kill invocation): Adjust documentation to use the
	@optItem macros.
	Fixes https://bugs.gnu.org/80339
	Fixes https://github.com/coreutils/coreutils/issues/185

2026-02-05  Pádraig Brady  <P@draigBrady.com>

	maint: remove local maintainer-makefile adjustment
	* gl/top/maint.mk.diff: Remove as the fix is now in gnulib.
	* gl/local.mk: Remove the diff reference.

	maint: update gnulib to latest

2026-02-05  Pádraig Brady  <P@draigBrady.com>

	build: propagate $SHELL to makeinfo-wrapper.sh
	A user that had an environment with SHELL=/usr/bin/fish
	reported the following when trying to build info docs:

	  build-aux/missing (line 4): Unsupported use of '='. In fish

	* doc/local.mk: Propagate make's SHELL to our
	makeinfo wrapper, so that the substituted ${SHELL}
	uses a compatible shell from the Makefile.

2026-02-05  Collin Funk  <collin.funk1@gmail.com>

	tests: df: check that --sync always calls sync before statfs
	* tests/df/sync.sh: New file.
	* tests/local.mk (all_tests): Add the test.

	stat,df: remove an unnecessary alloca
	* src/find-mount-point.c (find_mount_point): Don't call ASSIGN_STRDUPA
	on the result of dir_name.

2026-02-04  Pádraig Brady  <P@draigBrady.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 9.10
	* NEWS: Record release date.

2026-02-02  Pádraig Brady  <P@draigBrady.com>

	maintainer-makefile: propagate MAKEINFO to gendocs
	Make this change temporarily in coreutils.
	Move to gnulib after v9.10 is released.

	* top/maint.mk (web-manual): Propagate MAKEINFO explicitly,
	rather than requiring it exported in the environment,
	which can be awkward on Solaris make for example.

2026-02-02  Pádraig Brady  <P@draigBrady.com>

	tests: avoid false failure sync'ing busy systems
	* tests/misc/sync.sh: Increase the timeout to 60s,
	and restrict the case to when RUN_VERY_EXPENSIVE_TESTS=yes.

2026-01-31  Pádraig Brady  <P@draigBrady.com>

	doc: improve highlighting of dd --help translations
	* src/system.h (oputs_): Ensure we're not matching '-' in
	translated descriptions.  Also support highlighting only
	dd "foo=bar" when the description is separated with a single space.

2026-01-30  Pádraig Brady  <P@draigBrady.com>

	maint: avoid prohibit-const-char syntax check failure
	* src/copy.c: Avoid prohibit-const-char failure,
	newly triggered by the (correct) recent adjustment.

	doc: move xgettext: hint to the correct translated string
	* src/fmt.c (usage): Move comment down to the newly separated string.
	Discussed in https://github.com/coreutils/coreutils/issues/178

2026-01-28  Paul Eggert  <eggert@cs.ucla.edu>

	maint: space between ‘char’ and ‘*’

2026-01-28  Collin Funk  <collin.funk1@gmail.com>

	tests: date: test that %% in the string is not replaced
	* tests/date/percent-percent.sh: New file.
	* tests/local.mk (all_tests): Add it.

2026-01-27  Pádraig Brady  <P@draigBrady.com>

	doc: improve highlighting of single spaced translations
	* src/system.h (oputs_): Translations sometimes use a single space
	between an option and its description.  They only do this though
	for long options since they result in less available screen space.
	Therefore be more strict with option matching once we've encountered
	a long option, which supports the more varied formats often
	associated with short options.

2026-01-27  Collin Funk  <collin.funk1@gmail.com>

	maint: avoid syntax-check failure
	* man/date.x: Add a copyright header to fix sc_copyright_check.
	Reported by Bruno Haible.

	tests: tac: test --regex with anchors in the separator
	* tests/tac/tac.pl (@Tests): Add a few test cases.

2026-01-26  Paul Eggert  <eggert@cs.ucla.edu>

	doc: fit in 80 columns

	doc: fix date(1) synopses etc
	Font problem reported by Michael Aramini via Alejandro Colomar
	<https://bugs.gnu.org/80258>.  This patch also fixes some
	longstanding confusion with date synopses.
	* src/date.c (usage): Do not imply that only -u can be used with
	MMDDhhmm..., and do not put misleading brackets around the latter.

2026-01-25  Collin Funk  <collin.funk1@gmail.com>

	tests: mktemp: export LC_ALL
	* tests/mktemp/bad-unicode.sh: Run this test case using multiple
	locales.

2026-01-25  Pádraig Brady  <P@draigBrady.com>

	doc: support TAB as a delimiter between --option and description
	* src/system.h (oputs_): Treat a single TAB as an option delimiter.
	Some zh translations use this delimiter format.

2026-01-24  Collin Funk  <collin.funk1@gmail.com>

	tests: chgrp: allow a numeric user id to be printed
	* tests/chgrp/from.sh: If 'id' cannot find a user name for user id 1,
	expect the user id to be printed in the message of 'chgrp'.
	Reported by Bruno Haible.

2026-01-24  Pádraig Brady  <P@draigBrady.com>

	tail: fix EINTR handling on older systems
	tail(1) could fail with an "Interrupted system call"
	diagnostic, on some systems like Centos 5 (Linux 2.6.18).
	This was seen with tests/tail/overlay-headers.sh
	which sends SIGCONT, which should not induce a failure.

	* src/tail.c (tail_forever_inotify): Retry the poll()
	upon receiving a non terminating signal, and the syscall
	is not automatically restarted by the system.
	* NEWS: Mention the bug fix.
	Reported by Bruno Haible.

2026-01-24  Collin Funk  <collin.funk1@gmail.com>

	tests: avoid failures if 'ulimit -n' cannot set file descriptor limits
	This fixes test failures seen on Haiku.

	* tests/ls/recursive.sh: Run 'ls' even if ulimit fails.
	* tests/split/r-chunk.sh: Run 'split' even if ulimit fails.
	* tests/sort/sort-merge-fdlimit.sh: Skip test if 'ulimit -n' cannot set
	file descriptor limits.
	Reported by Bruno Haible.

2026-01-24  Pádraig Brady  <P@draigBrady.com>

	tests: dd: avoid EPERM false failure on Solaris
	* tests/dd/fail-ftruncate-fstat.sh: Also map the "Not owner"
	error for EPERM seen on earlier Solaris 11 releases.
	Reported by Bruno Haible.

	doc: nproc: mention OpenMP env vars in --help
	* src/nproc.c (usage): Clarify the impact of 'OMP_NUM_THREADS'
	and 'OMP_THREAD_LIMIT' in --help and the man page.
	Also mention that nproc(1) will always return > 0.
	Fixes https://bugs.gnu.org/80243

	build: update to latest gnulib
	* gnulib:
	  - getdelim, getline: Don't replace these functions on glibc
	  - selinux: fix link errors with termux

2026-01-24  Bruno Haible  <bruno@clisp.org>

	tests: recognize SELinux support on Android
	* init.cfg (require_selinux_): Also try to see if 'mount' lists the
	selinuxfs.

2026-01-24  Pádraig Brady  <P@draigBrady.com>

	tests: stty: avoid false failure if resizing terminal
	* tests/stty/stty-row-col.sh: Skip the test if we detect terminal
	resizing.  Also more robustly restore the original size.

2026-01-24  Collin Funk  <collin.funk1@gmail.com>

	tests: readlink: avoid a false failure on Haiku
	* tests/readlink/readlink-posix.sh: Allow the "A" in "Argument" to be
	capitalized in return value of strerror (EINVAL).

	doc: NEWS: add a missing quotation mark
	* NEWS: Add a closing quotation mark.

2026-01-23  Pádraig Brady  <P@draigBrady.com>

	tests: usage_vs_refs.sh: fix false failure with Alpine
	* tests/misc/usage_vs_refs.sh: Fix missing escape on literal {,
	required by busybox grep.
	Reported by Bruno Haible.

2026-01-22  Egmont Koblinger  <egmont@gmail.com>

	doc: dir,vdir: add dircolors(1) reference to man pages
	* man/dir.x: Add dircolors(1) to "SEE ALSO" section.
	* man/vdir.x: Likewise.

2026-01-22  Pádraig Brady  <P@draigBrady.com>

	doc: dir,vdir: fix anchor refs from --help
	* src/system.h (oputs_): Map from dir,vdir to ls.

2026-01-22  Egmont Koblinger  <egmont@gmail.com>

	doc: stat: fix highlighting of --format
	* src/stat.c (usage): Add missing comma after -c.

2026-01-22  Pádraig Brady  <P@draigBrady.com>

	doc: NEWS: minor adjustments
	* NEWS: Fix typos, and move item to more appropriate section.

	doc: pr: fix --help output output
	* src/pr.c (usage): Use consistent alignment with -J,
	and highlight --pages using oputs().

	doc: help2man: handle leading '+' in options
	* man/help2man: Fix indentation of options with leading '+'.

	tests: fix false failure with pr -COLS
	* tests/misc/usage_vs_getopt.sh: Fix false failure induced
	by commit v9.9-239-ga06f0cf67

2026-01-22  Pádraig Brady  <P@draigBrady.com>

	doc: use TERM=dumb rather than HELP_NO_MARKUP to disable markup
	This is a more standard mechanism to disable markup.

	* src/system.h (oputs_): Logic change to honor TERM=dumb,
	rather than HELP_NO_MARKUP=something.
	* doc/coreutils.texi: Adjust the description for --help.
	* man/local.mk: Ensure TERM is set to something,
	so that man pages have links included.
	* man/viewman: Just honor users $TERM.
	* tests/misc/getopt_vs_usage.sh: Remove env var complication,
	as TERM is unset automatically.
	* tests/misc/usage_vs_refs.sh: Likewise.
	* NEWS: Adjust the change in behavior note.

2026-01-21  Pádraig Brady  <P@draigBrady.com>

	tests: avoid false failure with non standard path
	* tests/misc/usage_vs_refs.sh: Properly quote arguments
	to avoid false failure with paths containing spaces etc.

	tests: avoid infinite loop in dd failure edge case
	* tests/tee/tee.sh: If dd failed, then tee would spin
	writing to the fifo forever, so add a timeout protection.
	This was noticed with `export LD_PRELOAD=libasan.so.8`
	with a non ASAN build, which induced a failure in dd invocations.

	tests: avoid false failure with sanitizer builds
	* init.cfg (sanitizer_build_): Add a helper to detect if a program
	is built against a sanitizer.
	* tests/df/no-mtab-status-masked-proc.sh: Skip if a sanitizer build.

	stat,tail: sync with latest Linux file systems
	* src/stat.c (human_fstype): Add "guest-memfd".
	* NEWS: Mention the improvement.

	tests: avoid false failure on setgid dir
	* tests/misc/mknod.sh: Skip a portion of the test
	in the edge case of setgid directories.

2026-01-21  Pádraig Brady  <P@draigBrady.com>

	ls: --hyperlink: switch to more standard delimiters
	* src/ls.c (quote_name): Use ST (ESC \) rather than BEL,
	as that's the only terminator mentioned in at least
	ECMA-48, DEC STD 070, and EK-VT520-RM.
	* NEWS: Mention the change in behavior.
	* tests/ls/hyperlink.sh: Adjust accordingly.

	Suggested by Egmont Koblinger.

2026-01-21  Pádraig Brady  <P@draigBrady.com>

	tests: ensure there is an anchor for each --help option
	* tests/misc/usage_vs_refs.sh: A new test to correlation options
	listed in --help, and anchors referenced in the texinfo (html) manual.
	* tests/local.mk: Add the new test.

	doc: NEWS: describe the --help markup configuration options
	* NEWS: Mention build and runtime config options.

	doc: adjust --help hyperlinks to more standard format
	* src/system.h (oputs_): Use ST rather than BEL.

	doc: add commentary on details of --help references
	* src/system.h: Mention why we don't bother with (the overhead of)
	hostnames in these URLs, and why --help,--version link are special.

	doc: cp: group related -HLP descriptions
	* src/cp (usage): The -HLP options are close
	in functionality and close alphabetically, so describe together.
	* doc/coreutils.texi (cp invocation): Likewise.

	doc: cp: document --keep-directory-symlink in correct location
	* src/cp.c (usage): Move to alphabetically in list.
	* doc/coreutils.texi (mv invocation): Move description from here ...
	(cp invocation): ... to here.

	doc: ls: document --block-size in the manual
	* doc/coreutils.texi (ls invocation): Document --block-size

	doc: who: document --users in manual
	* doc/coreutils.texi (who invocation): Mention that --users
	is equivalent to -u.
	* src/who.c (usage): Mention -u shows idle time.

	doc: id: document -a in manual
	* doc/coreutils.texi (id invocation): Mention this option is ignored.

	doc: more indexing fixes in manual
	* doc/coreutils.texi: Add missing anchors.
	* src/pr.c (Usage): Adjust to use -COLS, to avoid a clash
	with the additional anchor added to the manual.
	Also markup the --columns option as done for other options.
	* tests/split/line-bytes.sh: Also fix --lines-bytes typo here.

2026-01-21  Egmont Koblinger  <egmont@gmail.com>

	doc: tty: fix indexing in texinfo
	* doc/coreutils.texi: Fix recently introduced typo.
	* THANKS.in: Remove as now committed to the repo.

2026-01-21  Pádraig Brady  <P@draigBrady.com>

	doc: make legacy digest utility --help reference cksum nodes
	* src/system.h (oputs_): Map md5sum etc. to cksum urls,
	as we only have cksum anchors in the manual to avoid
	creating anchors for all of the legacy digest utilities.

	doc: tweak tests to avoid false failure with --help
	* tests/df/df-output.sh: Use a more relaxed match.
	* tests/du/inodes.sh: Likewise.

	doc: all: use option highlighting and more standard alignment
	Adjust all utils to:
	  - Have a separate translation per option
	  - Use either oputs() or oprintf(), instead of fputs() or printf().
	  - Use more standard alignment as discussed in previous commits.
	  - Various tweaks to descriptions.

	doc: readlink: improve option ordering in texinfo
	* doc/coreutils.texi (readlink invocation): Order -q,-s alphabetically.

	doc: chcon: use more standard -HLP desciptions
	* src/chcon.c (usage): Use emit_symlink_recurse_options ("-P").

	doc: highlight -HLP options
	* src/system.h (emit_symlink_recurse_options): Highlight -HLP,
	for chmod, chcon etc.

	doc: put --help and --version descriptions on separate line
	* src/system.h: This aligns the output with the option
	description format used in most commands

	doc: ls: put option description on separate line to option
	* src/ls.c (usage): This is less constrained when writing comments,
	and more consistent in output alignment.  There is less delineation
	between options and descripts, but given options are highlighted
	by default now, this is a more appropriate format to use.
	Note consistently showing description on the line following the option,
	avoids any issue with the user needing to visually line up
	the option with a description far to the right.
	Note this format more closely aligns with that used in man pages.

2026-01-21  Pádraig Brady  <P@draigBrady.com>

	doc: viewman: a new helper to quickly view formatted man pages
	Use like: man/viewman ls

	* man/viewman: Generate man page on the fly, and view.

2026-01-21  Pádraig Brady  <P@draigBrady.com>

	doc: help2man: account for undisplayed markup in indenting calculations
	* man/help2man: This is significant with the indented line
	following the dd bs=BYTES "option" at least.

	doc: help2man: convert all hyperlinks, not just ones in --options
	* man/help2man: Make the (--?) part of the match optional.
	Note we still extract the dashes, to support the existing
	option matching logic in help2man.

	doc: help2man: support alternate format OSC hyperlinks
	* man/help2man: The BEL terminator format was already supported.
	Add support for ESC + backslash terminator.  Also split out
	and document the regular expression.

	doc: help2man: convert OSC hyperlinks
	* man/help2man: Convert OSC hyperlinks to roff \X escapes,
	which will be converted back to OSC hyperlinks when
	the man page is displayed on the terminal.
	Note formatting is removed from hyperlinked text by default,
	thus relying on how the terminal highlights hyperlinks,
	but --bold-refs is honored in this case, in which hyperlinked
	text will be marked up as bold, which matches the default
	markup used for non hyperlinked options.

	doc: help2man: recognise option description with smaller indent
	* man/help2man: Allow for a smaller indented option description.
	This smaller indentation is present in timeout --help output,
	so now the line spacing in timeout.1 is more consistent.
	Also having the description on a separate line with
	a smaller indentation, is a more general way to present
	option descriptions (and what the man page formatting uses already).
	We'll be changing many utilities, especially with longer multi-line
	descriptions to this new format.

	doc: help2man: strip ANSI codes
	* man/help2man: With these ANSI codes, output is corrupted,
	so it's best to strip these, which allows --help to
	outputting formatting and hyperlinks by default.

	doc: support highlighting printf formatted options
	* src/system.h (oprintf): Add a printf wrapper that
	calls oputs_() to markup the formatted text.

	doc: support more general option matching
	* src/system.h: Support "-p DIR, --tmpdir[=DIR]" option.
	Previously only the "-p" was highlighted.
	Support highlighting dd option syntax (no '-').
	Support test(1) "FILE1 -nt FILE2" syntax.

	doc: parse any whitespace as an option/description delimiter
	* src/system.c (oputs_): Use isspace() rather than hardcoding.
	Note we don't use c_isspace() as we need to support anything
	coming from translations.

	doc: optimize logic to disable SGR output in --help
	* src/system.h (oputs_): Simplify processing if neither
	MANUAL_URL or BOLD_MAN_REFS is defined.  Also ensure
	we only lookup the HELP_NO_MARKUP env var once per process.

	doc: move oputs() to system.h to support all commands
	* src/ls.c: Move non ls specific helper to ...
	* src/system.h: ... here.

	doc: support a configurable manual url
	* configure.ac: Support ./configure --enable-manual-url=...
	* src/ls.c (oputs): Adjust accordingly.

	doc: --help: --disable-bold-man-page-references configures bold refs
	* configure.ac: Adjust help text for --disable-bold-man-page-references,
	and also define BOLD_MAN_REFS.
	* src/ls.c (oputs): Output bold iff BOLD_MAN_REFS is defined.

	doc: ls: support styling and links in --help output
	* src/ls.c (oputs): A new function that wraps puts(),
	but also highlights the --option-text portion, and
	adds links to the appropriate part of the online manual.
	(usage): Call oputs() rather than puts().
	* doc/coreutils.texi (--help): Document new HELP_NO_MARKUP env var,
	which can be used in the edge case one wants to suppress ansi escapes.
	* tests/misc/getopt_vs_usage.sh: Use HELP_NO_MARKUP to ensure the
	test continues to pass.

	tests: test: ensure whitespace ignored when parsing numbers
	* tests/test/test.pl: Add a test case.

2026-01-21  Pádraig Brady  <P@draigBrady.com>

	cksum: use more accurate program name in single binary mode
	Following commit v9.9-109-gcd5229222

	* src/cksum.c (PROGRAM_NAME): In legacy mode, i.e., when built
	as a single binary, set the PROGRAM_NAME dynamically based on
	the selected digest type.  This is significant in --help
	to ensure the correct texinfo node is referenced, and in
	--version to ensure the correct utility name is output.

2026-01-20  Collin Funk  <collin.funk1@gmail.com>

	tests: dd: avoid a false test failure on Solaris 11.4
	* tests/dd/fail-ftruncate-fstat.sh: Replace the message used by Solaris
	11.4 for strerror (EPERM) with the one we expect.

2026-01-19  Collin Funk  <collin.funk1@gmail.com>

	tests: sync: check that all files are processed even when errors occur
	* tests/misc/sync.sh: Add the test case.

	tests: sync: also test that -d and -f don't block on a FIFO
	* tests/misc/sync.sh: Check 'sync fifo' with no arguments, -d, and -f
	separately. Only perform the check for -f if RUN_EXPENSIVE_TESTS=yes
	since it may be expensive.

2026-01-19  Pádraig Brady  <P@draigBrady.com>

	build: update to latest gnulib
	* gnulib: Update to latest.
	* NEWS: Mention the bug fix.
	https://github.com/coreutils/coreutils/issues/176

2026-01-18  oech3  <79379754+oech3@users.noreply.github.com>

	tests: env.sh: avoid multi-call binary considerations
	A simpler fix than commit v9.9-4-g3b6efd555
	which is less dependent on the exact behavior
	of a multi-call binary.

	* tests/env/env.sh: Use a local script rather than 'true'.
	which may be a symlinked multi-call binary.
	https://github.com/coreutils/coreutils/pull/174

2026-01-18  Collin Funk  <collin.funk1@gmail.com>

	doc: post process html with non-GNU make programs
	* .gitignore (/build-aux/makeinfo-wrapper.sh):
	* Makefile.am (EXTRA_DIST): Remove build-aux/makeinfo-wrapper.sh.
	* build-aux/makeinfo-wrapper.sh.in: New file, renamed from
	build-aux/makeinfo-wrapper.sh and modified to use @MAKEINFO@ instead of
	makeinfo.
	* cfg.mk (MAKEINFO): Remove variable.
	* configure.ac: Add build-aux/makeinfo-wrapper.sh as a configure file.
	* doc/local.mk (MAKEINFO): Define to
	$(abs_top_builddir)/build-aux/makeinfo-wrapper.sh.
	(AM_MAKEINFOFLAGS): Move over some values from the previous MAKEINFO
	definition.

2026-01-18  Pádraig Brady  <P@draigBrady.com>

	tests: strace: consider splice a "read" syscall
	* tests/cksum/cksum-c.sh: Add 'splice' to the injection set.
	* tests/misc/read-errors.sh: Likewise.
	From https://github.com/coreutils/coreutils/pull/167

2026-01-18  Pádraig Brady  <P@draigBrady.com>

	maint: prefer NULL to nullptr
	NULL is best for C as discussed at:
	https://bugs.gnu.org/66221#53

	* bootstrap.conf: Remove dependency on nullptr.
	* s/nullptr/NULL/.

2026-01-18  Pádraig Brady  <P@draigBrady.com>

	doc: add more redirections from legacy *sum to cksum
	*  doc/coreutils.texi (md5sum invocation, sha1sum invocation,
	b2sum invocation, sha2 utilities): Mention these are legacy interfaces,
	and reference 'cksum invocation'.
	*  src/cksum.c (usage): Likewise.
	*  man/md5sum.x: Redirect to cksum, rather than individual utils.
	*  man/sha1sum.x: Likewise.

	tests: use `command -v` to identify binary
	* tests/misc/coreutils.sh: Be more flexibile by using `command -v`
	to identify the binary to be executed, rather than linking
	directly to the built binary.

2026-01-18  Collin Funk  <collin.funk1@gmail.com>

	build: fix error building html documentation from tarball
	Reported by Egmont Koblinger <egmont@gmail.com> in
	<https://lists.gnu.org/r/coreutils/2026-01/msg00111.html>.

	* Makefile.am (EXTRA_DIST): Add build-aux/makeinfo-wrapper.sh.

2026-01-17  Collin Funk  <collin.funk1@gmail.com>

	tests: avoid a test hang on AIX
	* init.cfg (uses_strace_): New function.
	(require_strace_): Use it.
	tests/cksum/cksum-c.sh: Likewise.
	tests/misc/read-errors.sh: Likewise.

	build: update gnulib submodule to latest

2026-01-17  Pádraig Brady  <P@draigBrady.com>

	maint: remove sc_prohibit_NULL syntax check
	* cfg.mk: NULL is fine and good in C as per:
	https://bugs.gnu.org/66221#53

	build: update gnulib submodule to latest

2026-01-17  Collin Funk  <collin.funk1@gmail.com>

	maint: pacify another gcc -Wzero-as-null-pointer-constant warning
	* src/uptime.c (print_uptime): Add a timezone_t cast to zero. Don't use
	nullptr since timezone_t is not a standardized and may be defined to
	something other than a pointer.

2026-01-16  Paul Eggert  <eggert@cs.ucla.edu>

	maint: spelling fixes

	build: update gnulib submodule to latest

	maint: pacify gcc -Wzero-as-null-pointer-constant
	* src/basenc.c (long_options):
	* src/chcon.c (change_file_context):
	* src/copy.c (is_ancestor):
	* src/env.c (build_argv):
	* src/expr.c (nomoreargs):
	* src/factor.c (mp_no_factors):
	* src/ls.c (long_options, main):
	* src/selinux.c (defaultcon, restorecon_private):
	* src/shred.c (dopass):
	* src/shuf.c (long_opts):
	* src/tac.c (output):
	* src/test.c (term):
	* src/uniq.c (check_file): Do not use ‘0’ as a null pointer
	constant.  Although it is typically valid C, there are exceptions
	(e.g., stdarg) and it a bit cleaner to be consistent.  This patch
	uses NULL, not nullptr, as I have second thoughts about nullptr;
	see <https://bugs.gnu.org/66221#53>.

2026-01-16  Collin Funk  <collin.funk1@gmail.com>

	build: fix link errors with multi-call binary and 'cksum' excluded
	* src/local.mk (src_ls_LDADD, src_seq_LDADD, src_md5sum_LDADD)
	(src_sha1sum_LDADD, src_sha224sum_LDADD, src_sha256sum_LDADD)
	(src_sha384sum_LDADD, src_sha512sum_LDADD): Set to
	$(src_cksum_LDADD).
	Reported at https://github.com/coreutils/coreutils/issues/172

2026-01-15  Pádraig Brady  <P@draigBrady.com>

	all: with multi-call binary, only process options for known names
	Setup
	  $ ln -nsf src/coreutils foo

	Before
	  $ ./foo; echo $?
	  foo: unknown program ‘foo’
	  Try './foo --help' for more information.
	  1
	  ./foo --version; echo $?
	  coreutils (GNU coreutils) 9.9.172-01993
	  0

	After
	  $ ./foo; echo $?
	  coreutils: unknown program 'foo'
	  1
	  $ ./foo --version; echo $?
	  coreutils: unknown program 'foo'
	  1

	* src/coreutils.c (main): Don't process options if
	we don't know they're intended for the multi-call binary.
	Otherwise `foo --version` would return true, even though
	foo was symlinked to the multi-call binary, but not supported.
	* tests/misc/coreutils.sh: Add test cases.
	* NEWS: Mention the change in behavior.

2026-01-15  Pádraig Brady  <P@draigBrady.com>

	doc: paste: give a CSV generation example
	* doc/coreutils.texi (paste invocation): Provide an example
	to comma separate data.

2026-01-14  Pádraig Brady  <P@draigBrady.com>

	build: paste: fix build failure with C99
	GCC 10.2 gave the following error:
	"error: a label can only be part of a statement
	 and a declaration is not a statement"

	* src/fold.c (fold_file): Add a ";" to avoid C2X specific syntax.

2026-01-14  Collin Funk  <collin.funk1@gmail.com>

	maint: avoid syntax-check failure from previous commit
	* src/copy-file-data.c (sparse_copy): Use nullptr instead of NULL.

2026-01-13  Paul Eggert  <eggert@cs.ucla.edu>

	cat: don’t treat copy_file_range EFBIG as fatal
	* src/cat.c (copy_cat):
	* src/copy-file-data.c (sparse_copy):
	Don’t treat EFBIG as a reportable error from copy_file_range.
	If the input is at EOF and the output position is 2**63 - 1,
	copy_file_range (ifd, NULL, ofd, NULL, 2146435072, 0)
	incorrectly fails with EFBIG.  Problem observed on Ubuntu 25.10
	x86-64 with Linux kernel 6.17.0-8-generic #8-Ubuntu.
	I am too lazy to report this kernel bug or add a coreutils test case.

	build: update gnulib submodule to latest

	cp: copy-file-data.c commentary fixes
	* src/copy-file-data.c: Update commentary to match code better.

2026-01-13  Pádraig Brady  <P@draigBrady.com>

	tests: ensure utilities correctly diagnose read errors
	* tests/misc/read-errors.sh: Ensure each utility calls a
	read system call as requested.  Not doing so (say by avoiding
	reading from a directory) is a layering violation.
	Also ensure we diagnose the particular error encountered.

	fmt: correctly diagnose read errors
	* src/fmt.c (fmt): Pass errno to error() so that
	the particular error is diagnosed.
	* NEWS: Mention the improvement.

	paste: support multi-byte delimiters
	* src/paste.c (collapse_escapes): This is the central --delimiters
	parsing function, so adjust to handle multi-byte chars with
	mcel_scanz().  Populate a delimiters length array to support
	characters of differing lengths.
	(paste_serial): Use the delimiters length array to output
	the appropriate delimiter.
	(paste_parallel): Likewise.
	* tests/paste/multi-byte.sh: A new test.
	* tests/local.mk: Reference the new test.
	* NEWS: Mention the improvement.

2026-01-13  oech3  <79379754+oech3@users.noreply.github.com>

	tests: nice: ensure large values are clamped
	* tests/nice/nice.sh: Ensure integers > UINTMAX_MAX are supported.
	From https://github.com/coreutils/coreutils/pull/170

2026-01-13  Collin Funk  <collin.funk1@gmail.com>

	maint: ptx: place long options without short options after CHAR_MAX
	* src/ptx.c (FORMAT_OPTION): New constant.
	(long_options): Use FORMAT_OPTION instead of 10.
	(main): Likewise.

2026-01-12  Dmitry V. Levin  <ldv@altlinux.org>

	tests: cksum: use more general strace syscall injection
	* tests/cksum/cksum-c.sh: Match "read" with a regex
	to match any of the read syscall variants.

2026-01-12  Pádraig Brady  <P@draigBrady.com>

	tests: paste -d: test supported escape sequences
	* tests/misc/paste.pl: Test all supported POSIX and GNU
	backslash escape sequences.

	doc: paste: add more detail on operation and options
	* src/paste.c (usage): Mention how lines are processed
	with and without the -s option.  Also mention that -d
	supports backslash escapes.
	* doc/coreutils.texi (paste invocation): Likewise.
	Also detail the backslash escapes, noting which are non-POSIX.

2026-01-12  Collin Funk  <collin.funk1@gmail.com>

	maint: ptx: reuse octhexdigits macros instead of redefining them
	* src/ptx.c: Include octhexdigits.h.
	(HEXTOBIN, ISODIGIT, OCTTOBIN): Remove macros.
	(unescape_string): Use the macros from octhexdigits.h instead of the
	removed macros.

2026-01-11  Pádraig Brady  <P@draigBrady.com>

	tests: date: test nested parenthesis comment handling
	* tests/date/date.pl: Add test cases.
	Suggested by Sylvestre Ledru.

	doc: runcon: use more accurate synopsis format
	* src/runcon.c (usage): Align synopsis with format
	used in other commands.
	* doc/coreutils.texi (runcon invocation): Likewise.

2026-01-11  oech3  <79379754+oech3@users.noreply.github.com>

	tests: cksum: ensure --check handles I/O errors
	* tests/cksum/cksum-c.sh: Use strace to inject EIO upon read(),
	and verify it's handled appropriately.
	From https://github.com/coreutils/coreutils/pull/167

2026-01-11  Pádraig Brady  <P@draigBrady.com>

	tests: cksum: ensure --check diagnoses read errors
	* tests/misc/read-errors.sh: Add a test case.
	Discussed in https://github.com/coreutils/coreutils/pull/167

2026-01-11  Pádraig Brady  <P@draigBrady.com>

	build: support 'dist' and 'syntax-check' targets without libselinux
	Following on from commit v9.8-60-g8ba47d09a ...
	Without libselinux installed, runcon and chcon stub binaries
	will not be built by default.  We separate these utilities out
	to a separate "not built unless appropriate" class, so that
	we can add these to EXTRA_MANS so that the 'check-x-vs-1'
	target doesn't fail, and the 'dist' target includes
	these man pages.

	* build-aux/gen-lists-of-programs.sh: Separate out
	build_if_appropriate_progs, and propagate that through
	to no_install_progs_default which populates EXTRA_MANS.
	* src/local.mk: Separate out build_if_appropriate__progs
	for clarity and consistency.

2026-01-11  Pádraig Brady  <P@draigBrady.com>

	build: update gnulib submodule to latest
	* gnulib: Update to latest mainly to pull in selinux module fixes.
	* NEWS: Mention the build fix to honor --with-selinux building
	stub chcon and runcon binaries on systems without libselinux.

2026-01-10  Collin Funk  <collin.funk1@gmail.com>

	cksum: promptly diagnose write errors
	* src/cksum.c (output_file, digest_check): Check if standard output has
	it's error flag set after printing.
	* tests/misc/write-errors.sh: Add a test case that would previously run
	forever.
	* NEWS: Mention the improvement. Reorder alphabetically.

2026-01-10  Pádraig Brady  <P@draigBrady.com>

	maint: remove redundant processing in a test
	* tests/misc/write-errors.sh: This was a no-op anyway
	due to inadequate escaping.  Also document the escaping requirement.

	du: promptly diagnose write errors
	* src/du.c (print_size): Call write_error() if can't flush.
	* tests/misc/write-errors.sh: Add a test case.
	* NEWS: Mention the improvement.

	wc: promptly diagnose write errors
	* src/wc.c (write_counts): Call write_error() if any pending errors.
	* tests/misc/write-errors.sh: Add a test case.
	* NEWS: Mention the improvement.

2026-01-09  Collin Funk  <collin.funk1@gmail.com>

	readlink,realpath: promptly diagnose write errors
	The 'readlink' and 'realpath' programs have an uncommon case where they
	can run for a very long time. When canonicalizing file names longer than
	PATH_MAX, we have to call 'openat' for each directory up the tree until
	we reach root which takes a long time. Here is an example of the current
	behavior:

	    $ mkdir -p $(yes a/ | head -n $((32 * 1024)) | tr -d '\n')
	    $ while cd $(yes a/ | head -n 1024 | tr -d '\n'); do :; \
	        done 2>/dev/null
	    $ pwd | tr '/' '\n' | wc -l
	    32771
	    $ env time --format=%E readlink -f $(yes . | head -n 5) > /dev/full
	    readlink: write error: No space left on device
	    Command exited with non-zero status 1
	    0:59.72
	    $ env time --format=%E realpath $(yes . | head -n 5) > /dev/full
	    realpath: write error: No space left on device
	    Command exited with non-zero status 1
	    1:00.32

	It is better to exit as soon as there is an error writing to standard
	output:

	    $ env time --format=%E readlink -f $(yes . | head -n 5) > /dev/full
	    readlink: write error: No space left on device
	    Command exited with non-zero status 1
	    0:11.88
	    $ env time --format=%E realpath $(yes . | head -n 5) > /dev/full
	    realpath: write error: No space left on device
	    Command exited with non-zero status 1
	    0:12.04

	* src/readlink.c (main): Check if standard output has it's error flag
	set after printing a file name.
	* src/realpath.c (process_path): Likewise.
	* NEWS: Mention the improvement.

2026-01-08  Pádraig Brady  <P@draigBrady.com>

	cksum: validate options more consistently
	We disallow `cksum --tag --check` which is fine,
	but the error should be consistent with md5sum,
	and less confusing, as it currently mentions
	"--binary" and "--text" which weren't specified.

	We disallow `cksum --tag --text` which is fine,
	but we should also disallow `cksum --text --tag`.

	We should honor an explicit --binary (output *)
	with this combination of options:
	cksum --binary --tag --untagged -a md5 /dev/null

	Note this also makes both of `cksum -a md5` and
	`cksum --tag -a md5` consistently use binary mode
	when reading from a tty on systems like MinGW
	where O_BINARY is set.

	* src/cksum.c (main): Adjust --text,--binary
	and --tag,--untagged option processing.
	* tests/cksum/cksum-a.sh: Add test cases.
	* tests/cksum/cksum-c.sh: Likewise.
	* NEWS: Mention the improvement.
	Fixes https://github.com/coreutils/coreutils/issues/163

2026-01-08  Pádraig Brady  <P@draigBrady.com>

	tests: chmod: fix false failure in recent test
	* tests/chmod/partial-fail.sh: Test readablility of mode 0 files
	independently, to avoid false failure, e.g., when run as root.
	Reported by Bruno Haible.

2026-01-08  Pádraig Brady  <P@draigBrady.com>

	tests: tail/overlay-headers.sh: fix various issues
	* tests/tail/overlay-headers.sh (cleanup_): Ensure we send SIGCONT
	to the tail process, otherwise we would hang if the test is terminated
	while the tail process is in stopped state.
	(wait4stopped_): A new function to ensure tail is in the stopped state
	before we start writing to the monitored files.
	Also remove "---disable-inotify" from $fastpoll so we actually
	test the inotify code (where supported).
	Also remove the timeout(1) wrapper, so we actually suspend tail(1).

	Reported by Bruno Haible on macOS 26

2026-01-08  Pádraig Brady  <P@draigBrady.com>

	fmt: interpret -w as an inclusive maximum
	This aligns with `fold -w` and BSD `fmt` implementations.

	* src/fmt.c (fmt_paragraph): Check len <= max_width.
	* tests/fmt/width.sh: Add a new test.
	* tests/local.mk: Reference the new test.
	* NEWS: Mention the change in behavior.
	Addresses part of https://bugs.gnu.org/79497

2026-01-08  Sylvestre Ledru  <sylvestre@debian.org>

	tests: date: test parenthesis comment handling
	* tests/date/date.pl: Add the check.

2026-01-07  Collin Funk  <collin.funk1@gmail.com>

	maint: organize mktemp tests in a subdirectory
	* tests/misc/mktemp.pl: Moved to tests/mktemp/mktemp.pl.
	* tests/local.mk (all_tests): Adjust the file name.

	tests: mktemp: add tests for invalid Unicode options
	* init.cfg (bad_unicode): New function, copied from
	tests/fold/fold-characters.sh with the NUL removed.
	* tests/fold/fold-characters.sh (bad_unicode): Rename to
	bad_unicode_with_nul. Reformat long line.
	* tests/mktemp/bad-unicode.sh: New test.
	* tests/local.mk (all_tests): Add the new test.

2026-01-06  Pádraig Brady  <P@draigBrady.com>

	copy: protect against infinite loop due to pathological race
	Consider:

	1. In infer_scantype():
	    - SEEK_DATA returns 0
	      - hole punched at 0
	    - SEEK_HOLE returns 0 (now a hole)
	    - Cache scan_inference->hole_start = 0
	2. In lseek_copy():
	      - data written at 0
	    - ext_start = 0, use cached hole_start = 0
	    - ext_len = 0
	    - now loop doesn't progress

	* src/copy-file-data.c (lseek_copy): Apply a more defensive check
	to ensure we only use the cached offsets in SCAN_INFERENCE once.
	This protects against an infinite loop where an extent (at SRC_POS)
	flip flops between data and hole extent while infer_scantype()
	and lseek_copy() are inspecting it.  I.e. ensure we use SEEK_HOLE
	to progress the copy.

2026-01-06  Pádraig Brady  <P@draigBrady.com>

	tests: cp: fix always skipped nfs-removal-race.sh
	* tests/cp/nfs-removal-race.sh: This test was invalid since v8.32
	as we now use fstatat() rather than stat().  Also since commit
	v9.0-66-ge2daa8f79 we leverage the errno from open(O_DIRECTORY)
	to avoid a stat, so pass --no-target-directory to ensure fstatat()
	is called.
	Discussed in https://github.com/coreutils/coreutils/pull/161

2026-01-06  Christopher Illarionova  <drydench@amazon.com>

	tests: cp: support glibc 2.33+ in nfs-removal-race test
	glibc 2.33 removed __xstat, making stat() a direct symbol. This test
	previously only intercepted __xstat, causing it to skip on modern glibc
	with 'LD_PRELOAD was ineffective'.

	Changes:
	- Intercept both __xstat (glibc < 2.33) and stat (glibc >= 2.33)
	- Only mark 'preloaded' when stat is called on destination 'd',
	  ensuring the test verifies cp actually stats the destination

2026-01-06  Pádraig Brady  <P@draigBrady.com>

	doc: tr: warn about shell quoting [:classes:]
	* src/tr.c (usage): Warn about avoiding shell globbing.
	* doc/coreutils.texi (character arrays): Likewise.
	Suggested by Daniel Dallos.

2026-01-05  Pádraig Brady  <P@draigBrady.com>

	ptx: implement -t to change default width to 100
	Align the -t implementation with the Heirloom project.

	* src/ptx.c (usage): Describe -t, and also mention
	the default width is 72 when not used.
	* doc/coreutils.texi (ptx invocation): Likewise.
	(main): Override the default width if -t is specified.
	* tests/ptx/ptx.pl: Add test cases.
	* NEWS: Mention the change in behavior.

2026-01-05  Christopher Illarionova  <drydench@amazon.com>

	tests: stty: add require_controlling_input_terminal_ to bad-speed test
	The bad-speed test runs 'stty ispeed 9600' without a --file argument,
	which requires a controlling terminal. Without it, stty fails early with
	'Inappropriate ioctl for device' before reaching cfsetispeed, causing
	the test to skip with a misleading 'LD_PRELOAD interception failed'
	message.

	* tests/stty/bad-speed.sh: Add require_controlling_input_terminal_
	to match the other stty tests (stty.sh, stty-pairs.sh, stty-row-col.sh,
	stty-invalid.sh) which all require a controlling terminal.
	From https://github.com/coreutils/coreutils/pull/160

2026-01-04  Collin Funk  <collin.funk1@gmail.com>

	maint: mknod: reduce variable scope
	* src/mknod.c (main): Declare variables where they are used instead of
	at the start of a block. Prefer signed integers to unsigned integers.

	maint: mkfifo: reduce variable scope
	* src/mkfifo.c (main): Declare variables where they are used instead of
	at the start of a block.

2026-01-04  Pádraig Brady  <P@draigBrady.com>

	copy: fix possible infinite loop with SEEK_HOLE
	Commit v9.8-95-g4c0cf3864 intended to initialize
	ext_start to src_pos, as was described at:
	https://lists.gnu.org/r/coreutils/2025-11/msg00035.html
	However ipos was inadvertently used, which is only
	valid the first time through the loop.

	* src/copy-file-data.c (lseek_copy): Use scan_inference->hole_start
	only with the initial offset passed to lseek_copy().
	* NEWS: Mention the bug fix.
	Reported at https://github.com/coreutils/coreutils/issues/159

2026-01-03  Pádraig Brady  <P@draigBrady.com>

	tests: chmod: ensure failure upon partial success
	* tests/chmod/partial-fail.sh: Add new test.
	* tests/local.mk: Reference new test.
	Discussed at https://github.com/uutils/coreutils/issues/9790

2026-01-03  oech3  <79379754+oech3@users.noreply.github.com>

	tests: split: ensure directories not replaced
	* tests/split/split-io-err.sh: Add a test case.
	From https://github.com/coreutils/coreutils/pull/158

2026-01-03  Collin Funk  <collin.funk1@gmail.com>

	doc: NEWS: mention du performance improvement on the Lustre file system
	Reported by Tim Day <timday@amazon.com> in
	<https://bugs.gnu.org/80106>.

	* NEWS: Mention the improvement after gnulib commit 578b8d7dc5.

2026-01-02  Collin Funk  <collin.funk1@gmail.com>

	build: update gnulib submodule to latest
	* bootstrap: Update using './bootstrap --bootstrap-sync'.
	* tests/sample-test: Adjust to use the single most recent year.

	maint: prefer c_isblank to an equivalent macro
	* src/cksum.c (ISWHITE): Remove macro.
	(bsd_split_3, algorithm_from_tag, split_3): Use c_isblank instead of
	ISWHITE.

	tests: df: don't depend on bash
	* tests/df/no-mtab-status-masked-proc.sh: Invoke $SHELL instead of
	'bash'.

2026-01-01  Collin Funk  <collin.funk1@gmail.com>

	maint: run 'make update-copyright'

2026-01-01  Sylvestre Ledru  <sylvestre@debian.org>

	tests: mv: check broken symlink cross-filesystem move
	Identified here:
	<https://github.com/uutils/coreutils/issues/8586>

	* tests/mv/mv-special-2.sh: Add the check.

2026-01-01  oech3  <79379754+oech3@users.noreply.github.com>

	tests: df: hide /proc without using LD_PRELOAD
	* tests/df/no-mtab-status-masked-proc.sh: A new test similar
	to no-mtab-status.sh but should work with static builds.
	* tests/local.mk: Reference the new test.
	https://github.com/coreutils/coreutils/pull/156

	tests: add LD_PRELOAD free alternative for nproc-quota.sh
	* tests/nproc/nproc-quota-systemd.sh: Add a new root test.
	* tests/local.mk: Reference the new test.

	tests: extend csplit-io-err.sh for directory
	* tests/csplit/csplit-io-err.sh: Add a test case
	to ensure a directory is _not_ replaced.

2025-12-31  Sylvestre Ledru  <sylvestre@debian.org>

	tests: du: check -l (--count-links) without -a flag
	Identified here:
	<https://github.com/uutils/coreutils/issues/9871>

	* tests/du/hard-link.sh: Add the check.

2025-12-30  Collin Funk  <collin.funk1@gmail.com>

	tests: env: check that real-time signals can be ignored
	* tests/env/env-signal-handler.sh: Test that --ignore-signal with no
	options also ignores real-time signals. Test that real-time signals can
	be ignored by explicitly listing them.

2025-12-28  Collin Funk  <collin.funk1@gmail.com>

	tests: kill: check that real-time signals are listed
	* tests/misc/kill.sh: Call getlimits_. Check for RTMIN and RTMAX in the
	output of 'kill -l' if the system defines SIGRTMIN and SIGRTMAX.

	getlimits: print SIGRTMIN and SIGRTMAX
	* src/getlimits.c (SIGRTMIN): Define to zero if signal.h does not define
	this constant.
	(SIGRTMAX): Define to SIGRTMIN - 1 if signal.h does not define this
	constant.
	(main): Print SIGRTMIN and SIGRTMAX.

	maint: commit-msg: add 'getlimits' as a supported tag
	* scripts/git-hooks/commit-msg (@valid): Add getlimits.

2025-12-27  oech3  <79379754+oech3@users.noreply.github.com>

	tests: split: verify operation in the presence of I/O errors
	* tests/split/split-io-err.sh: A new test to verify that with I/O
	errors, we leave existing files but don't continue.
	* tests/local.mk: Reference the new test.

2025-12-27  Pádraig Brady  <P@draigBrady.com>

	tests: check I/O error handling with /dev/full and closed pipes
	* tests/misc/io-errors.sh: Verify that all commands diagnose write
	errors, and handle a closed pipe appropriately.
	* tests/local.mk: Reference the new test.

	sort: fix SIGPIPE handling
	* src/sort.c (main): Don't override handler for SIGPIPE
	(which we did since commit v9.9-34-ge63131b32),
	since we've explicit handling for SIGPIPE.
	Also move ignoring of SIGPIPE until after
	--help and --version are processed.

2025-12-27  oech3  <79379754+oech3@users.noreply.github.com>

	tests: consolidate csplit-io-err tests
	* tests/csplit/csplit-io-err.sh: Replace this LD_PRELOAD test with...
	* tests/csplit/csplit-io-err-2.sh: This more general test,
	that leverages /dev/full.
	* tests/local.mk: Remove tests/csplit/csplit-io-err-2.sh.

2025-12-26  oech3  <79379754+oech3@users.noreply.github.com>

	tests: csplit: check writing to /dev/full
	* tests/csplit/csplit-io-err-2.sh: Add a new test.
	* tests/local.mk: Reference new test.

2025-12-25  Collin Funk  <collin.funk1@gmail.com>

	dd: don't continue copying when ftruncate fails using seek= and of=
	* src/dd.c (main): Reduce the scope of exit_status. Exit immediately if
	ftruncate fails.
	* tests/dd/fail-ftruncate-fstat.sh: New test.
	* tests/local.mk (all_tests): Add the new test.
	* NEWS: Mention the bug fix.

2025-12-25  Pádraig Brady  <P@draigBrady.com>

	doc: document the date(1) bug with empty format directives
	* NEWS: Mention the bug fix.

	build: update gnulib to latest

2025-12-25  Collin Funk  <collin.funk1@gmail.com>

	tests: date: improve locale tests
	* tests/date/date-locale-hour.sh: Test that the default format of 10
	random supported locales is the same as 'locale date_fmt'.

2025-12-22  Pádraig Brady  <P@draigBrady.com>

	tests: avoid false failure due to ulimit on aarch64
	* tests/cut/cut-huge-range.sh: Add an extra 1MiB headroom,
	which was seen with aarch64.
	Reported at https://bugzilla.redhat.com/2424302

	maint: tests/cut/cut-huge-range.sh: remove stale comment
	* tests/cut/cut-huge-range.sh: expr supports bignums,
	so remove stale comment relating to previous non expr adjustment.

	numfmt: fix dropped custom suffix when failing to parse
	* src/numfmt.c (process_suffixed_number): Restore custom suffix
	upon failure to parse number.
	* tests/numfmt/numfmt.pl: Add test cases.
	* NEWS: Mention the bug fix.
	Fixes https://bugs.debian.org/1094581

2025-12-21  Collin Funk  <collin.funk1@gmail.com>

	maint: prefer enums over macros for sources used for multiple programs
	* src/chown.h (enum chown_modes): New type.
	(CHOWN_CHOWN, CHOWN_CHGRP): Define as an enum instead of a macro.
	* src/chown-chgrp.c (chown_mode): Use "enum chown_modes" instead of
	"int".
	* src/chown-chown.c (chown_mode): Likewise.
	* src/ls.h (enum ls_modes): New type.
	(LS_LS, LS_MULTI_COL, LS_LONG_FORMAT): Define as an enum instead of a
	macro.
	* src/ls-dir.c (ls_mode): Use "enum ls_modes" instead of "int".
	* src/ls-ls.c (ls_mode): Likewise.
	* src/ls-vdir.c (ls_mode): Likewise.
	* src/uname.h (enum uname_modes): New type.
	(UNAME_UNAME, UNAME_ARCH): Define as an enum instead of a macro.
	* src/uname-arch.c (uname_mode): Use "enum uname_modes" instead of
	"int".
	* src/uname-uname.c (uname_mode): Likewise.

2025-12-20  Collin Funk  <collin.funk1@gmail.com>

	doc: prefer UTF-8 characters in texinfo sources
	* doc/coreutils.texi (Introduction): Use ç instead of @,{c}.
	(Character arrays): Use ö instead of @"o. Use Ł instead of @L{}.
	(Formatting file timestamps): Use ä instead of @"a.

2025-12-20  Pádraig Brady  <P@draigBrady.com>

	doc: ls: fix recent typo for -F option in texinfo
	* doc/coreutils.texi (ls invocation): Add a missing hyphen
	that was inadvertently dropped in the recent adjustments.

	tests: runcon: avoid false success
	* tests/runcon/runcon-compute.sh: Ensure runcon runs,
	since the main test is a negative one.

2025-12-19  Pádraig Brady  <P@draigBrady.com>

	doc: split,tac: document $TMPDIR usage
	Following commit v9.3-92-g1b86b70dd
	$TMPDIR is part of the interface and an important behavioral
	characteristic of a command, which should be documented.

	* doc/coreutils.texi (split invocation): Mention $TMPDIR is honored.
	(tac invocation): Likewise.
	* src/split.c (usage): Likewise.
	* src/tac.c (usage): Likewise.

2025-12-17  Collin Funk  <collin.funk1@gmail.com>

	doc: tee: prefer cksum in examples
	* doc/coreutils.texi (tee invocation): Use 'cksum' with '-a sha2' and
	'-a sha3' instead of md5sum and sha1sum in examples.

2025-12-16  Pádraig Brady  <P@draigBrady.com>

	tests: mv: check moving named sockets is supported
	* tests/mv/mv-special-2.sh: Use python to create a named socket,
	and ensure it's copied across file systems.

2025-12-15  Collin Funk  <collin.funk1@gmail.com>

	tests: date: add another locale test case
	On a GNU/Linux system, we have the following:

	    $ LC_ALL=en_US.UTF-8 date -u -d 1:00
	    Sun Dec 14 01:00:00 AM UTC 2025
	    $ LC_ALL=en_US.UTF-8 locale date_fmt
	    %a %b %e %r %Z %Y
	    $ LC_ALL=en_US.UTF-8 locale t_fmt_ampm
	    %I:%M:%S %p

	    $ LC_ALL=nl_NL.UTF-8 date -u -d 1:00
	    zo 14 dec 2025  1:00:00 UTC
	    $ LC_ALL=nl_NL.UTF-8 locale date_fmt
	    %a %e %b %Y %k:%M:%S %Z

	We respect the locales preference for a leading zero or leading space in
	single digit hours.

	* tests/date/date-locale-hour.sh: Check that the locales preference for
	leading zeros or spaces in single digit hours is used.

2025-12-15  Pádraig Brady  <P@draigBrady.com>

	tests: mv: check traversed fifos copy correctly
	* tests/mv/mv-special-1.sh: Add a case also for fifos
	encountered when traversing.

	tests: mv: add timeout protection when moving fifos
	* tests/mv/mv-special-1.sh: Implementations could potentially hang
	interacting with fifos, so wrap with timeout.

2025-12-14  Collin Funk  <collin.funk1@gmail.com>

	doc: dd: document the behavior of conv flags on multibyte characters
	* doc/coreutils.texi (dd invocation): Document the behavior of 'dd' on
	multibyte characters and some unspecified behavior that will be
	documented in a future POSIX release [1].

	[1] https://austingroupbugs.net/view.php?id=1959

2025-12-14  Collin Funk  <collin.funk1@gmail.com>

	tests: ls: use a larger file descriptor limit
	OpenBSD and Alpine Linux /bin/sh cannot handle a file descriptor limit
	of 7.

	* tests/ls/recursive.sh: Create 30 directories and use a file descriptor
	limit of 20. Don't check the output since we have coverage for that
	elsewhere.
	Reported by Bruno Haible.

2025-12-13  Pádraig Brady  <P@draigBrady.com>

	build: reduce size of multi-call binary by reusing cksum logic
	Map md5sum and sha{1,224,256,385,512} to use cksum logic,
	which selects appropriate behavior at runtime, rather than
	separate binaries for each closely related utility.

	$ size src/coreutils  # before
	   text	   data	    bss	    dec	    hex	filename
	1349509	   6812	 619312	1975633	 1e2551	src/coreutils
	$ size src/coreutils  # after
	   text	   data	    bss	    dec	    hex	filename
	1306933	   6748	 619152	1932833	 1d7e21	src/coreutils

	* build-aux/gen-single-binary.sh: Map sha*sum to use cksum.c
	* src/cksum.c: Adjust to behave more like sha*sum,
	when the algorithm to something other than "crc".
	* src/cksum.h: Expose the cksum_algorithm global and enum.
	* src/coreutils-md5sum.c: Set cksum_algorithm and call cksum logic.
	* src/coreutils-sha1sum.c: Likewise.
	* src/coreutils-sha224sum.c Likewise.
	* src/coreutils-sha256sum.c Likewise.
	* src/coreutils-sha384sum.c Likewise.
	* src/coreutils-sha512sum.c Likewise.
	* NEWS: Mention the improvement.

2025-12-12  Pádraig Brady  <P@draigBrady.com>

	doc: expand on shell-escape quoting style
	* doc/coreutils.texi (quotingStyles): Expand on the advantages
	of "shell-escape" quoting, and mention it's the default when
	outputting to a tty. Also mention how it's also useful with
	LC_ALL=C to further disambiguate output.  Also reference the
	separate page detailing various considerations and options
	for file name quoting.  Also move the mention of the default
	quoting style to the top of the page where it's more obvious.

	tests: printf: add case for quoting single quotes
	* tests/printf/printf-quote.sh: Add a test case for
	https://bugs.debian.org/992161 which was fixed with
	gnulib commit v0.1-7339-g07b31a9465

2025-12-12  Collin Funk  <collin.funk1@gmail.com>

	maint: organize tee tests in a subdirectory
	* tests/misc/tee.sh: Moved to tests/tee/tee.sh.
	* tests/local.mk (all_tests): Adjust the file name.

	tests: tee: add a test for --append
	* tests/tee/append.sh: New file.
	* tests/local.mk (all_tests): Add the test.

2025-12-11  Pádraig Brady  <P@draigBrady.com>

	tests: fix recent portability issue with printf
	* tests/sort/sort-locale.sh: Avoid non portable printf \u....
	* cfg.mk (sc_env_printf): Add a new syntax check to flag future cases.

	tests: env: ensure non-utf8 name or value is supported
	* tests/env/env.sh: Add a test case ensuring non-utf8 characters
	in the name or value are supported.

	tests: mv: ensure ownership preserved when copying
	* tests/mv/meta-to-xpart.sh: Add new test.
	* tests/local.mk: Reference new test.

2025-12-11  Collin Funk  <collin.funk1@gmail.com>

	maint: groups: reduce variable scope
	* src/groups.c (main): Declare variables where they are used instead of
	at the start of the function. Convert a comment to GNU style.

	maint: printenv: reduce variable scope
	* src/printenv.c (main): Declare variables where they are used instead
	of at the start of the function. Constify some strings we do not modify.

	maint: rmdir: reduce variable scope
	* src/rmdir.c (remove_parents, main): Declare variables where they are
	used instead of at the start of a block.

	maint: date: reduce variable scope
	* src/date.c (batch_convert, main): Declare variables where they are
	used instead of at the start of the function.

	maint: install: reduce variable scope
	* src/install.c (change_timestamps): Initialize variables where they are
	declared.
	(need_copy, setdefaultfilecon, get_ids, mkancesdirs_safe_wd, main):
	Declare variables where they are used instead of at the start of the
	block.

	maint: cp: reduce variable scope
	* src/cp.c (re_protect): Initialize variables where they are declared.
	(make_dir_parents_private, do_copy, main): Declare variables where they
	are used instead of at the start of the block.

	maint: mv: reduce variable scope
	* src/mv.c (do_move, main): Declare variables where they are used
	instead of at the start of a block.

2025-12-10  Pádraig Brady  <P@draigBrady.com>

	tests: env: add a test for --ignore-signal=PIPE
	* tests/env/env-signal-handler.sh: Add a test for this
	oft interfered with signal.

2025-12-10  Pádraig Brady  <P@draigBrady.com>

	doc: support html post processing in all cases
	Previously the html-local make rule only worked for `make html`.
	Instead add support for `make doc/coreutils.html` or `make web-manual`
	through the use of a makeinfo wrapper.

	* doc/local.mk: Move post processing from here to ...
	* build-aux/makeinfo-wrapper.sh: ... here.
	* cfg.mk: Ensure our wrapper is called with MAKEINFO.
	Also pass --no-node-files so redirection html files
	are not created for each anchor.

2025-12-10  Collin Funk  <collin.funk1@gmail.com>

	doc: printf: mention how to print arguments starting with '-'
	* doc/coreutils.texi (printDash): New macro.
	(printf invocation, yes invocation): Use it.
	Addresses https://bugs.gnu.org/79896

2025-12-09  Pádraig Brady  <P@draigBrady.com>

	doc: fix stale linuxjournal.com link
	* doc/coreutils.texi: Update to working link.
	Fixes https://bugs.gnu.org/79973

2025-12-09  Collin Funk  <collin.funk1@gmail.com>

	doc: html: fix build with parallel make
	* doc/local.mk (html-local): Add html files to prerequisites so they are
	generated before 'sed' is invoked.  Also interate over the already
	populated $(HTMLS) to be more general (to multiple html files),
	and more portable (to non GNU make).

2025-12-08  Pádraig Brady  <P@draigBrady.com>

	tests: fix non-portable use of printf '\x..'
	* tests/dd/conv-case.sh: Use octal instead.
	* tests/ls/hyperlink.sh: Likewise.
	* tests/sort/sort-locale.sh: Likewise.

	doc: fix pdf generation
	* doc/coreutils.texi: Explicitly supply empty arguments to macros,
	as dvi (a required prerequisite to pdf) is more strict in its
	handling of macro arguments.
	* cfg.mk (sc_texi_ensure_empty_option_args): Add a syntax check,
	since this is not verified in the default build.
	Reported by Collin Funk.

2025-12-07  Collin Funk  <collin.funk1@gmail.com>

	maint: env: reduce variable scope
	* src/env.c (extract_varname, parse_signal_action_params)
	(parse_block_signal_params, set_signal_proc_mask)
	(list_signal_handling, main): Declare variables where they are used
	instead of at the start of the function.

	maint: nohup: reduce variable scope
	* src/nohup.c (main): Declare variables where they are used instead of
	at the start of the function.

	maint: sync: reduce variable scope
	* src/sync.c (sync_arg, main): Declare variables where they are used
	instead of at the start of the function.

	maint: pwd: reduce variable scope
	* src/pwd.c (find_dir_entry, robust_getcwd): Declare variables where
	they are used.
	(logical_getcwd, main): Likewise. Constify the result of getenv, since
	the result cannot be modified.

	maint: dirname: reduce variable scope
	* src/dirname.c (main): Declare variables where they are used instead of
	at the start of the function. Prefer idx_t to size_t.

	maint: hostid: reduce variable scope
	* src/hostid.c (main): Declare variables where they are used instead of
	at the start of the function.

	maint: nproc: reduce variable scope
	* src/nproc.c (main): Declare variables where they are used instead of
	at the start of the function.

	maint: whoami: reduce variable scope
	* src/whoami.c (main): Declare variables where they are used instead of
	at the start of the function.

	maint: logname: reduce variable scope
	* src/logname.c (main): Declare variables where they are used instead of
	at the start of the function.

	maint: basename: initialize values while declaring
	* src/basename.c (remove_suffix): Initialize values on the same line as
	their declarations.

2025-12-07  Collin Funk  <collin.funk1@gmail.com>

	shred: use gethrxtime instead of time
	The gethrxtime function uses a monotonic clock if available on the
	system. The effect should be unnoticeable since we print --verbose
	information every 5 seconds, but is more correct and we already do the
	same in 'dd'.

	* src/local.mk (src_shred_LDADD): Add $(GETHRXTIME_LIB).
	* src/shred.c (dopass): Use xtime_t instead of time_t. Use gethrxtime
	instead of time.

2025-12-07  Pádraig Brady  <P@draigBrady.com>

	tests: tac-continue.sh: modernise and always execute as root
	* tests/tac/tac-continue.sh: This test was very awkard to setup,
	and thus always skipped.  Instead move to a root only test
	that creates an almost full partition itself.
	* tests/local.mk: Move test to root only.
	Suggested at https://github.com/uutils/coreutils/pull/9590

2025-12-05  Collin Funk  <collin.funk1@gmail.com>

	pinky: promptly diagnose write errors
	In some cases 'pinky' could run forever until interrupted:

	    $ ln -s /dev/zero ~/.plan
	    $ ln -s /dev/zero ~/.project
	    $ timeout -v 5 pinky -l collin > /dev/full
	    timeout: sending signal TERM to command ‘pinky’

	After this change it will exit upon failing to write to standard output:

	    $ timeout -v 5 ./src/pinky -l collin > /dev/full
	    pinky: write error: No space left on device

	* src/pinky.c: Include fadvise.h, filenamecat.h, full-write.h, and
	ioblksize.h.
	(cat_file): New function.
	(print_entry): Check if standard output has it's error flag set after
	printing a user entry.
	(print_long_entry): Likewise. Use the new cat_file function.
	* NEWS: Mention the improvement.

2025-12-05  Pádraig Brady  <P@draigBrady.com>

	doc: html: reference each command option
	* doc/coreutils.texi: Add anchors to each command option.
	This also has the advantage of removing over 1000 lines,
	through the use of macros.

	doc: html: support defined anchors for command options
	* doc/coreutils.texi (optAnchor): A new macro to output a
	referencable anchor, called from ...
	(optItem): ... here; a new macro to output all index entries
	for each option item.
	(optZero,optZeroTerminated): Show an example of the adjustment
	done to each option description.
	* doc/local.mk (html-local): Post-process the texinfo generated HTML
	(`make html`) to remove our "-option" tag, and replace all
	escaped _002d with a standard hyphen, which is fine in URLs.

2025-12-05  Collin Funk  <collin.funk1@gmail.com>

	tests: ls: check that 'ls -R' doesn't run out of file descriptors
	* tests/ls/recursive.sh: Add a test where the file descriptor limit is
	less than the number of directories we visit recursively.

2025-12-04  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest
	Gnulib issymlinkat change reported by Bruno Haible in:
	https://lists.gnu.org/r/bug-gnulib/2025-12/msg00044.html
	* bootstrap: Update from Gnulib.
	* src/copy.c: Include issymlinkat.h, not issymlink.h.

2025-12-03  Collin Funk  <collin.funk1@gmail.com>

	maint: organize expand and unexpand tests in a subdirectory
	* tests/misc/expand.pl: Move to tests/expand/expand.pl.
	* tests/misc/unexpand.pl: Move to tests/unexpand/unexpand.pl.
	* tests/local.mk (all_tests): Adjust file names.

	tests: expand, unexpand: add a test for bounded memory operation
	* tests/expand/bounded-memory.sh: New file.
	* tests/unexpand/bounded-memory.sh: New file.
	* tests/local.mk (all_tests): Add the tests.

	maint: don't use == on bools
	* src/df.c (filter_mount_list): Adjust comment.
	* src/sync.c (sync_arg): Don't use == on bools.
	* src/pr.c (init_parameters): Likewise.

2025-12-03  Collin Funk  <collin.funk1@gmail.com>

	timeout: print the signal number 0 instead of EXIT
	POSIX.1-2024 added sig2str but leaves the behavior when called with
	signal 0 unspecified. FreeBSD 15.0 does not return the signal name EXIT
	like Gnulib's version causing a test failure. This fixes that and
	changes the behavior to print 0 instead of EXIT, to avoid confusion when
	the program does not exit.

	* NEWS: Mention the change.
	* src/timeout.c (cleanup): Use snprintf instead of sig2str if the signal
	is 0.
	* tests/timeout/timeout.sh: Updated the expected output.

2025-12-02  Pádraig Brady  <P@draigBrady.com>

	timeout: prioritize "timed out" exit status
	* src/timeout.c (cleanup): Reset the default exit status
	to EXIT_TIMEDOUT, if we have in fact received an ALARM.
	Otherwise we would exit with status EXIT_CANCELED if
	there was an issue writing --verbose output for example.
	This also ensures a consistent exit status with ASAN enabled,
	as with ASAN stderr is not explicitly closed by gnulib's
	close_stdout handler.

	tests: ls --hyperlink: add more escaping test cases
	* tests/ls/hyperlink.sh: Add tests for anchors, colons,
	utf8, and invalid utf8 characters.

2025-12-02  Collin Funk  <collin.funk1@gmail.com>

	tests: cut: add a test for bounded memory operation
	* tests/cut/bounded-memory.sh: New file.
	* tests/local.mk (all_tests): Add the test.

2025-12-01  Pádraig Brady  <P@draigBrady.com>

	tests: enable mkdir/writable-under-readonly.sh
	* tests/mkdir/writable-under-readonly.sh: Address FIXMEs and enable.
	Addresses https://github.com/coreutils/coreutils/issues/137

	tests: mv: add checks for cross device handling of special files
	* tests/mv/mv-special-2.sh: Add test to ensure we preserve
	sparse files, character devices, symlinks, when moving across
	file system boundaries.
	Addresses https://github.com/coreutils/coreutils/issues/136

	tests: rm: avoid usually skipped non root test
	* tests/rm/fail-eperm.xpl: Remove this usually skipped non-root test.
	* tests/rm/fail-2eperm.sh: Add the test to this root test instead.
	* tests/local.mk: Remove the reference to *.xpl.

2025-11-30  Collin Funk  <collin.funk1@gmail.com>

	doc: du: mention the behavior when both --threshold and --total are used
	* doc/coreutils.texi (du invocation): Mention that --threshold has no
	effect on the grand total calculated when --total is used.
	Addresses https://bugs.gnu.org/71309

2025-11-30  Pádraig Brady  <P@draigBrady.com>

	tests: copy: reinstate check for symlink xattr copying
	* tests/cp/cp-mv-enotsup-xattr.sh: Use two xattr supporting file
	systems, to verify the propagation of xattrs.

	tests: avoid skip due to missing nouser_xattr support
	* tests/cp/cp-mv-enotsup-xattr.sh: The nouser_xattr option
	is not supported by ext2 since about 2022.  Instead use
	ramfs to ensure xattrs are not supported.  We also remove
	part of the test that relied on partial xattr support.
	Fixes https://github.com/coreutils/coreutils/issues/135

2025-11-29  Pádraig Brady  <P@draigBrady.com>

	maint: commit-msg: remove "digest" as a supported tag
	* scripts/git-hooks/commit-msg: We recently renamed the digest module
	to cksum, so no longer support "digest" as a commit tag.

	maint: commit-msg: fix terminal corruption when re-editing
	* scripts/git-hooks/commit-msg: Explicitly connect the editor to
	/dev/tty, so that it can restore terminal settings appropriately.

2025-11-29  Collin Funk  <collin.funk1@gmail.com>

	maint: remove note about old NEWS files
	* NEWS: Remove mention about old fileutils, textutils, and sh-utils NEWS
	files that were removed in commit 2c64bc872 (doc: only distribute 5
	years of ChangeLogs, 2017-01-31).
	* cfg.mk (old_NEWS_hash): Run 'make update-NEWS-hash'.

2025-11-29  Pádraig Brady  <P@draigBrady.com>

	test: re-enable tests that had a false requirement on coreutils' kill
	Recently we've not built our kill command by default,
	so reduce test dependence on that.

	* tests/sort/sort-compress-proc.sh: `kill -l [exit_status]` is well
	supported, and is a POSIX requirement.
	* tests/timeout/timeout.sh: There were actually no kill invocations
	in this test at all.

2025-11-29  Pádraig Brady  <P@draigBrady.com>

	timeout: ensure we terminate command upon abnormal exit
	* src/timeout.c (main): Use PR_SET_PDEATHSIG to ensure the
	child is terminated even if the parent terminates abnormally.
	* tests/timeout/timeout-group.sh: Add a case to ensure sending
	SIGKILL results in the termination of the monitored command.
	* NEWS: Mention the improvement.

2025-11-29  Collin Funk  <collin.funk1@gmail.com>

	tests: tac: test --separator with invalid UTF-8
	* tests/tac/tac-locale.sh: Test that a string containing invalid UTF-8
	characters can be used for --separator.

2025-11-28  Collin Funk  <collin.funk1@gmail.com>

	du: add the short option -A corresponding to --apparent-size
	The --apparent-size option to 'du' was added in
	coreutils-4.5.8 (2003). FreeBSD 8.0 (2009) added the same functionality
	under the short option -A. This long option previously had no short
	option, so this patch adds -A to be compatible with FreeBSD.

	* NEWS: Mention the new short option.
	* doc/coreutils.texi: Document the short option.
	* src/du.c (usage): Likewise.
	(APPARENT_SIZE_OPTION): Remove definition.
	(EXCLUDE_OPTION): Define to CHAR_MAX + 1.
	(long_options): Use the -A short option for --apparent-size.
	(main): Likewise.
	* tests/du/apparent.sh: Test that '-b', '-A -B 1', and
	'--apparent-size --block-size 1' function the same.

2025-11-28  Collin Funk  <collin.funk1@gmail.com>

	test: tac: test with non-ASCII values for --separator
	* tests/tac/tac-locale.sh: New test.
	* tests/local.mk (all_tests): Add it.

2025-11-28  Pádraig Brady  <P@draigBrady.com>

	doc: touch: man: state in summary that files are created
	* man/touch.x: Creating files is core functionality of touch(1),
	so state this in the summary, so that apropos can be used
	to search for file creation functionality.

	tests: prefer ext4 casefold for case insensitive tests
	* tests/mv/hardlink-case.sh: Try both ext4 casefold and hfsplus,
	as ext4 has better availability.
	Suggested at https://github.com/coreutils/coreutils/issues/133

2025-11-27  Collin Funk  <collin.funk1@gmail.com>

	maint: prefer mcel_eq to mcel_cmp
	* gnulib: Update submodule to latest.
	* bootstrap: Run ./bootstrap --bootstrap-sync
	* src/expr.c (mbs_logical_cspn): Use mcel_eq instead of mcel_cmp.
	* src/join.c (eq_tab, main): Likewise.

	doc: date: mention --file=- reads from standard input
	* src/date.c (usage): Mention that standard input will be read if
	DATEFILE is "-".
	Reported at https://bugs.debian.org/1100395

	doc: du, sort, wc: adjust description of --files0-from
	* src/du.c (usage): Remove an unnecessary "then".
	* src/wc.c (usage): Likewise. Add a comma after "-".
	* src/sort.c (usage): Likewise. Adjust the indentation to match du and
	wc.

2025-11-26  Pádraig Brady  <P@draigBrady.com>

	doc: fold: clarify operation of -s in --help
	* src/fold.c (usage): The description of -s was unclear:
	- State that we can also break within words.
	- State that we split on blanks not spaces.
	- State that we split after the blank, not before.

2025-11-25  Pádraig Brady  <P@draigBrady.com>

	build: kill(1), uptime(1): don't install by default
	* build-aux/gen-lists-of-programs.sh: kill and uptime are not installed
	by arch, debian, fedora, suse at least, so add to disabled list.
	Fixes https://github.com/coreutils/coreutils/issues/132
	* NEWS: Mention the build change.

2025-11-23  Collin Funk  <collin.funk1@gmail.com>

	doc: cksum: document secure hash algorithms
	* doc/coreutils.texi (cksum general options): Mention hash algorithms
	that are currently considered secure against malicious tampering.

2025-11-23  Paul Eggert  <eggert@cs.ucla.edu>

	du,ls: don’t modify getenv strings
	Fix du and ls to conform to the POSIX getenv spec,
	which says you can’t modify strings returned by getenv
	unless you put the string there directly, or used putenv.
	This portability bug was found by strict C23 checking
	using qualifier-generic functions.
	* bootstrap.conf (gnulib_modules): Add xmemdup0.  Sort.
	* src/du.c (main):
	* src/ls.c (decode_switches):
	Don’t modify the string that getenv returns.
	Instead, use xmemdup0 if needed, and include xmemdup0.h.

	numfmt: port to C23 qualifier-generic fns
	* src/numfmt.c (mbsmbchr): Cast results of qualifier-generic functions
	to char *, to port to strict C23.

	build: update gnulib submodule to latest

	cat: refactor struct stat usage
	* src/cat.c (main): Simplify by keeping input and output
	struct stat in separate local vars.

2025-11-23  Pádraig Brady  <P@draigBrady.com>

	maint: use cksum specific checksums in release announcement
	* cfg.mk: Use --cksum-checksums with announce-gen.

	doc: cat -E: mention ^M$ output possibility
	* src/cat.c (usage): Document the ^M$ combination
	which is output for \r\n line endings.
	Fixes https://github.com/coreutils/coreutils/issues/130

2025-11-22  Pádraig Brady  <P@draigBrady.com>

	dd,ls,sort: prefer sigaction over signal
	sigaction() is generally available and if not
	provided by the sigaction gnulib module.

	* src/dd.c [SA_NOCLDSTOP]: Delete workarounds.
	* src/ls.c: Likewise.
	* src/sort.c: Likewise.
	Suggested by Collin Funk.

2025-11-22  Pádraig Brady  <P@draigBrady.com>

	csplit,ls,sort: handle a more complete set of signals
	* src/term-sig.h: A new file defining a TERM_SIG array signals.
	* src/local.mk: Reference the new file.
	* src/csplit.c: Likewise.
	* src/sort.c: Likewise.
	* src/timeout.c: Likewise.
	* src/ls.c: Likewise.  Also handle SIGTSTP separately.
	* NEWS: Mention the improvement.

2025-11-22  Pádraig Brady  <P@draigBrady.com>

	timeout: honor ignored signal dispositions
	This behavior was depended on in our trap_sigpipe_or_skip_ helper,
	and now that we're handling all terminating signals, we should
	consistently honor their ignored signal dispositions.

	* NEWS: Mention the change in behavior, especially in regard
	to shell background jobs.
	* src/timeout.c (sig_needs_handling): A new helper that return TRUE,
	for --signal, SIG_ALRM, or non ignored signals.
	(cleanup_install): Filter handled signals with the helper.
	(block_cleanup_and_chld): Likewise.
	* tests/timeout/timeout-group.sh: Adjust to use the now required
	`env --default-signal=...` wrapper to reset (auto) ignored signals.
	Also change the termination signal from SIGINT to SIGUSR1
	to generalize the test signals not specially handled by the shell,
	and newly handled by timeout(1).
	* tests/timeout/timeout.sh: Add a test case for SIGPIPE
	to ensure the ignored signal disposition is honored.

2025-11-21  Pádraig Brady  <P@draigBrady.com>

	timeout: handle all terminating signals
	* src/timeout.c (term_sig): A new global list of all signals
	whose default disposition is to terminate the process.
	(install_cleanup): Iterate over the TERM_SIG list, rather than
	installing the handler for a specific subset.
	(block_cleanup_and_chld): Likewise.
	* tests/timeout/timeout.sh: Add a test case for SIGPIPE.
	* NEWS: Mention the bug fix.

2025-11-20  Pádraig Brady  <P@draigBrady.com>

	build: remove explicit link to CoreFoundation libs on macOS
	* src/local.mk: No longer explicitly depend on @INTL_MACOS_LIBS@
	as they're no longer implicitly referenced (in LIBINTL) without gettext.
	The old dependency was through localename-unsafe, specifically
	date, du through show-date() (fprintftime), and
	ls, pr, stat, uptime through strftime().
	gnulib commit v1.0-2439-gff4b084a68 removed the localename-unsafe
	dependency on macOS.

	build: update gnulib submodule to latest

2025-11-20  Collin Funk  <collin.funk1@gmail.com>

	maint: add coreutils_hardlinks to src/.gitignore
	* src/.gitignore (coreutils_hardlinks): Ignore this file. It is an empty
	file created when --enable-single-binary=hardlinks is used to ensure
	hardlinks are created after the multicall binary.

	maint: prefer MAYBE_UNUSED to void casts
	* src/copy.c (clone_file, set_author): Use MAYBE_UNUSED in the prototype
	instead of void casting the arguments.

2025-11-19  Pádraig Brady  <P@draigBrady.com>

	build: support --enable-single-binary=hardlinks
	* Makefile.am: Use ln rather than $(LN_S) for hardlinks.
	* configure.ac: Accept --enable-single-binary=hardlinks.
	* man/local.mk: In hardlink mode, explicitly add the
	hardlink creation rule to mandeps.  Given the automake
	generated dependency chain, this ensures that the hardlinks
	are created _after_ the multicall binary, with `make all`
	or `make check` etc.
	* src/local.mk: Define the new src/coreutils_hardlinks rule,
	and only depend on src/coreutils_{symlinks,shebangs} if
	in those modes, so that hardlinks are created _after_
	the multicall binary, and other link types before.
	* NEWS: Mention the new feature.
	Addresses https://github.com/coreutils/coreutils/issues/129

2025-11-18  Collin Funk  <collin.funk1@gmail.com>

	tests: check that mknod, mkfifo, and mkdir handle comma-separated modes
	* tests/misc/mknod.sh: Test that mknod, mkfifo, and mkdir parse
	comma-separated mode strings.

2025-11-18  Sylvestre Ledru  <sylvestre@debian.org>

	tests: install supports comma-separated mode strings
	Identified here:
	<https://github.com/uutils/coreutils/pull/9298>

	* tests/install/basic-1.sh: Add the check.

2025-11-18  Collin Funk  <collin.funk1@gmail.com>

	maint: use C99 initialization syntax for single-variable 'for' loops
	* src/chroot.c (parse_additional_groups): Declare variable in the 'for'
	clause.
	* src/comm.c (compare_files): Likewise.
	* src/cp.c (re_protect): Likewise.
	* src/csplit.c (save_buffer, find_line, write_to_file)
	(split_file, main): Likewise.
	* src/dd.c (apply_translations, translate_buffer)
	(copy_with_block, main): Likewise.
	* src/df.c (selected_fstype, excluded_fstype, filter_mount_list)
	(last_device_for_mount, get_device, get_point, get_all_entries)
	(main): Likewise.
	* src/fmt.c (copy_rest, get_prefix, fmt_paragraph, put_paragraph)
	(put_word): Likewise.
	* src/fold.c (main): Likewise.
	* src/head.c (elide_tail_bytes_pipe, main): Likewise.
	* src/install.c (main): Likewise.
	* src/join.c (prfields, join, main): Likewise.
	* src/kill.c (list_signals): Likewise.
	* src/ls.c (main, decode_switches, parse_ls_color, patterns_match):
	Likewise.
	* src/operand2sig.c (operand2sig): Likewise.
	* src/pathchk.c (no_leading_hyphen, validate_file_name): Likewise.
	* src/pr.c (char_to_clump): Likewise.
	* src/printenv.c (main): Likewise.
	* src/ptx.c (initialize_regex, digest_break_file)
	(find_occurs_in_text, print_field): Likewise.
	* src/remove.c (mark_ancestor_dirs): Likewise.
	* src/seq.c (print_numbers): Likewise.
	* src/shred.c (do_wipefd, main): Likewise.
	* src/sort.c (cleanup, inittables, key_warnings, mergefps)
	(check_ordering_compatibility, main): Likewise.
	* src/split.c (closeout): Likewise.
	* src/stat.c (find_bind_mount, print_it, format_to_mask): Likewise.
	* src/stdbuf.c (set_program_path): Likewise.
	* src/stty.c (apply_settings, display_changed, display_all)
	(recover_mode, sane_mode): Likewise.
	* src/system.h (stzncpy): Likewise.
	* src/tail.c (pipe_lines): Likewise.
	* src/tee.c (tee_files): Likewise.
	* src/tr.c (look_up_char_class, get_spec_stats): Likewise.
	* src/users.c (list_entries_users): Likewise.

2025-11-17  Pádraig Brady  <P@draigBrady.com>

	build: fix make dist failure
	* src/local.mk: s/crc.h/cksum_crc.h/.
	Reported by Bruno Haible.

	tests: use tail --debug to determine inotify support
	* init.cfg (require_inotify_supported_): A new function that
	indicates inotify support for a file in the current directory,
	using tail --debug, rather than awkward strace checks etc.
	* tests/tail/inotify-dir-recreate.sh: Call require_inotify_supported_.
	 tests/tail/inotify-only-regular.sh: Likewise.
	 tests/tail/inotify-race.sh: Likewise.
	 tests/tail/inotify-race2.sh: Likewise.

	tail: add --debug to report the --follow implementation
	* doc/coreutils.texi (tail invocation): Describe --debug.
	* src/tail.c (tail_forever, tail_forever_inotify): Output
	which --follow implementation is being used.
	* tests/tail/debug.sh: Add a new test.
	* tests/local.mk: Reference the new test.
	* NEWS: Mention the new feature.

2025-11-17  Collin Funk  <collin.funk1@gmail.com>

	maint: convert remove a K&R declaration
	This function is hidden unless EVAL_TRACE is defined for debugging.

	* src/expr.c (trace): Convert to a prototype instead of K&R definition
	to avoid -Werror=strict-prototypes. Make the argument const to avoid
	-Werror=discarded-qualifiers.

2025-11-16  Bernhard Voelker  <mail@bernhard-voelker.de>

	du: document the TIME_STYLE env variable in usage
	The impact of the TIME_STYLE environment variable on du(1) was only
	documented in the Texinfo manual.  To avoid surprises for users,
	also mention TIME_STYLE in the usage text, i.e., for --help and man.
	Organize similar as in ls(1), but as du(1) has slightly different
	behavior it would be hard to share the translation.

	* src/du.c (usage): Shorten the description of --time-style, and refer
	to an additional --time-style / TIME_STYLE description below.

2025-11-16  Pádraig Brady  <P@draigBrady.com>

	tests: verify we document all supported options in --help
	* tests/misc/getopt_vs_usage.sh: A new test which checks the
	converse of usage_vs_getopt.sh
	* tests/local.mk: Reference the new test.

	maint: tag supported options not documented in --help

	maint: rearrange cksum modules so main is in cksum.c
	* src/cksum.c: -> src/cksum_crc.c
	* src/cksum.h: -> src/cksum_crc.h
	* src/digest.c: -> src/cksum.c
	* src/local.mk: Adjust accordingly.
	* cfg.mk: Likewise.
	* po/POTFILES.in: Likewise.
	* src/cksum_avx2.c: Likewise.
	* src/cksum_avx512.c: Likewise.
	* src/cksum_pclmul.c: Likewise.
	* src/cksum_vmull.c: Likewise.

	wc: fix missing documentation for the --debug option
	* doc/coreutils.texi (wc invocation): Desscribe --debug.
	* src/wc.c (usage): Likewise.
	* NEWS: Mention the bug fix.

2025-11-15  Sylvestre Ledru  <sylvestre@debian.org>

	tests: install should ignore umask
	Identified here:
	<https://github.com/uutils/coreutils/pull/9254>

	  * tests/install/basic-1.sh: Add the check.

2025-11-15  Collin Funk  <collin.funk1@gmail.com>

	tests: pr: add a test for bounded memory operation
	* tests/pr/bounded-memory.sh: New file.
	* tests/local.mk (all_tests): Add the test.

2025-11-14  Collin Funk  <collin.funk1@gmail.com>

	tests: dd: add tests for conv=lcase and conv=ucase
	* tests/dd/conv-case.sh: New test.
	* tests/local.mk (all_tests): Add it.

2025-11-14  Pádraig Brady  <P@draigBrady.com>

	doc: shred: clarify what --verbose outputs
	* doc/coreutils.texi (shred invocation): Give more details on what
	--verbose outputs, to give some indication of its utility.
	* src/shred.c (usage): Likewise.  Also since we're changing the string,
	split out translations to give translators more granular translations.

2025-11-13  Collin Funk  <collin.funk1@gmail.com>

	tests: test: add test cases for -ef
	* tests/test/test-file.sh: Check that -ef works as expected on files,
	symbolic links, and hard links.

2025-11-12  Collin Funk  <collin.funk1@gmail.com>

	maint: fix a typo in comments
	* tests/date/reference.sh: Fix typo; s/modiication/modification.

	tests: test: add test cases for -nt and -ot
	* tests/test/test-file.sh: Check that -nt and -ot work properly when
	files may or may not exist.

2025-11-12  Pádraig Brady  <P@draigBrady.com>

	sort: avoid pthread calls with --parallel=1
	Before this change there were the following unneeded pthread calls:

	  $ seq 1e6 | ltrace -c -e 'pthread*' sort --parallel=1 | wc -l
	  % time     seconds  usecs/call     calls      function
	  ------ ----------- ----------- --------- --------------------
	   39.13    0.031757          67       468 pthread_mutex_lock
	   37.96    0.030811          65       468 pthread_mutex_unlock
	   13.17    0.010691          65       162 pthread_cond_signal
	    2.15    0.001747          64        27 pthread_mutex_destroy
	    2.00    0.001620          60        27 pthread_mutex_init
	    0.70    0.000565          62         9 pthread_cond_destroy
	    0.64    0.000518          57         9 pthread_cond_init
	  ------ ----------- ----------- --------- --------------------
	  100.00    0.081159                  1170 total

	* src/sort.c (sort): Avoid merge tree overhead when single threaded.

2025-11-12  Pádraig Brady  <P@draigBrady.com>

	md5sum: fix --text with the MSYS2 runtime
	Note the use of "rt" is non-standard, but we're restricting
	its use here to systems that define O_BINARY, which should
	invariably support "rt" mode.

	* src/digest.c (): Where significant, explicitly use "rt" mode
	with --text, as MSYS2 defaults to binary mode for fopen'd files
	(though not for standard streams).
	* NEWS: Mention the bug fix.
	Fixes https://github.com/coreutils/coreutils/issues/123

2025-11-12  Pádraig Brady  <P@draigBrady.com>

	maint: fix comment re PRLFS' remoteness
	* src/stat.c (human_fstype): prlfs is used in a context of
	separate host and guest OS, so should be treated as remote always.

	tests: env --argv0: fix false failure with symlinked single binary
	* tests/env/env.sh: Always pass --coreutils-prog=true so that the
	program to run can be determined with --enable-single-binary=symlinks.
	Also actually verify the expected verbose output.
	Reported by the Alpine Linux project.

2025-11-11  Collin Funk  <collin.funk1@gmail.com>

	maint: fix a comment in the generated src/fs-is-local.h file
	Reported by Bruno Haible in
	<https://lists.gnu.org/r/coreutils/2025-11/msg00113.html>.

	* src/extract-magic ($magic_comment): Mention that the function returns
	1 if the file system is local and 0 if it is remote.

2025-11-11  Pádraig Brady  <P@draigBrady.com>

	tests: add tests for locale ordering
	* tests/sort/sort-locale.sh: Check sort,ls have the same (non C) order.
	* tests/local.mk: Reference the new test.

2025-11-10  Pádraig Brady  <P@draigBrady.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 9.9
	* NEWS: Record release date.

2025-11-10  Collin Funk  <collin.funk1@gmail.com>

	nice: clamp the niceness correctly on GNU/Hurd
	* NEWS: Mention the bug fix.
	* src/nice.c (MIN_ADJUSTMENT): Set to 0 on the Hurd with glibc ≤ 2.42.
	(MAX_ADJUSTMENT): Set to (2 * NZERO - 2) on the Hurd with glibc ≤ 2.42.
	(main): Clamp the niceness to be greater or equal to MIN_ADJUSTMENT and
	less than or equal to MAX_ADJUSTMENT.
	* tests/nice/nice.sh: Add some tests for the Hurd's ranges.

2025-11-08  Collin Funk  <collin.funk1@gmail.com>

	tests: tail: avoid a test failure on GNU/Hurd
	* tests/tail/tail-c.sh: Allow 'tail -c 4096 /dev/urandom' to run forever
	on GNU/Hurd since lseek fails with ESPIPE.

2025-11-08  Pádraig Brady  <P@draigBrady.com>

	chcon: fix memory leak in error path
	* src/chcon.c (change_file_context): If compute_context_from_mask fails,
	free the previously allocated file_context.
	Fixes https://bugs.gnu.org/79780

	tests: avoid false failure due to small timeout
	* tests/tail/tail-c.sh: Tests that fail after a timeout
	should use as least 10s to avoid intermittent failures
	on slow/loaded hosts.

2025-11-08  Collin Funk  <collin.funk1@gmail.com>

	build: update gnulib submodule to latest

2025-11-07  Pádraig Brady  <P@draigBrady.com>

	install: fix crash with --strip and large $PATH on ppc and sparc
	* gnulib: Update to the latest gnulib to pull in the fix
	(v1.0-2406-g89f63027de) to allocate the $PATH processing memory
	before the vfork call, which is required on ppc and sparc.
	* tests/install/basic-1.sh: Ensure posix_spawnp() suports a large $PATH,
	which needs careful handling with vfork() as detailed in gnulib.

2025-11-07  Pádraig Brady  <P@draigBrady.com>

	doc: cksum: clarify support of --text and --binary
	Make the documentation more accurate following v9.3-80-g5e1e0993b

	* doc/coreutils.texi (cksum common options): State that --text and
	--binary are actually supported, but only to support emulation
	of the legacy utils.

2025-11-07  Collin Funk  <collin.funk1@gmail.com>

	tests: wc: protect against a hang on GNU/Hurd
	Reported by Bruno Haible in
	<https://lists.gnu.org/r/coreutils/2025-11/msg00051.html>.

	* tests/wc/wc-total.sh: Skip a test that would exhaust memory on
	GNU/Hurd.

2025-11-05  Pádraig Brady  <P@draigBrady.com>

	gnulib: update to latest
	* NEWS: Mention the nproc build fix for older Android.

2025-11-05  Collin Funk  <collin.funk1@gmail.com>

	doc: mention nanosecond decimal points with --iso-8601=ns
	Many people are used to seeing ISO 8601 dates using a period separating
	seconds and nanoseconds. This behavior seems to be worth documenting
	given the bug reports:
	https://bugs.gnu.org/63119
	https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1118970

	* doc/coreutils.texi (Options for date): Mention that
	'date --iso-8601=ns' uses a comma as a separator, following the
	preference of ISO 8601. Give an example of how to get an ISO 8601 date
	with a period separator.

2025-11-04  Pádraig Brady  <P@draigBrady.com>

	maint: adjust lseek_copy to handle non zero offsets
	* src/copy-file-data.c (lseek_copy): hole_start is initialized
	only when ext_start == ipos.
	(infer_scantype): Update the hole_start initialization to
	the more logically correct POS, even though that init
	is only needed to suppress a -Wmaybe-uninitialized warning.
	Note gcc 15.2 at least doesn't seem to need that suppression.

2025-11-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: avoid skipping of LD_PRELOAD based df tests
	It was seen that gnulib's read_file_system_list may use fopen instead
	of open.  Adjust the df(1) tests to replace both library functions.

	* tests/df/no-mtab-status.sh: Change the shared library code invoked
	via LD_PRELOAD to override both fopen and open.  While at it, perform
	varargs processing only when path is not "/proc/self/mountinfo".
	* tests/df/skip-duplicates.sh: Likewise.

2025-11-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	tests: avoid skipping by fixing build of shared libraries
	Two df(1) tests were skipped (since commit ee367bd38dac), because
	the build of the shared library in those tests failed.

	  + gcc -Wall -shared --std=gnu99 -fPIC -O2 k.c -o k.so -ldl
	  k.c: In function 'open':
	  k.c:37:7: error: implicit declaration of function 'streq'; did you \
	  mean 'strsep'? [-Wimplicit-function-declaration]
	     37 |   if (streq (path, "/proc/self/mountinfo"))
	        |       ^~~~~
	        |       strsep

	Gnulib streq is not available in the tests.

	* tests/df/no-mtab-status.sh: Replace "streq" by "0==strcmp" in the
	shared library source.
	* tests/df/skip-duplicates.sh: Likewise.

2025-11-04  Collin Funk  <collin.funk1@gmail.com>

	tests: date: check that write errors are promptly diagnosed
	This improvement is due to changes to Gnulib's fprintftime module.

	* NEWS: Mention the improvement.
	* src/getlimits.c (OFF64_T_MAX, OFF64_T_MIN): New macros.
	(main): Print them.
	* tests/misc/write-errors.sh: Call getlimits_. Add a date invocation.

2025-11-03  Paul Eggert  <eggert@cs.ucla.edu>

	doc: squashfs issue to be squashed in Linux 6.18

2025-11-03  Pádraig Brady  <P@draigBrady.com>

	tests: truncate: ensure negative args not parsed as options
	* tests/truncate/truncate-parameters.sh: Add a test case.

	date: avoid a duplicated write error diagnotic
	* src/show-date.c (show_date): Only show the fprintftime() diagnostic
	if a further diagnostic will not be shown.

	date: translate/clarify recent error message
	* src/show-date.c (show_date): Flagged by syntax-check.

	date: promptly diagnose write errors with --file
	* src/date.c (batch_convert): Check error state of stdout
	after each date is processed.
	* tests/misc/write-errors.sh: Add a test case.

2025-11-02  Collin Funk  <collin.funk1@gmail.com>

	tests: stty: filter out ispeed and ospeed from boolean options
	* tests/stty/stty-pairs.sh: Also ignore lines starting with ispeed and
	ospeed.
	* tests/stty/stty.sh: Likewise.
	Reported by Bernhard Voelker.

2025-11-02  Paul Eggert  <eggert@cs.ucla.edu>

	date: diagnose fprintftime failure
	* src/show-date.c (show_date): Diagnose fprintftime failure,
	as it need not be an output error.

	pr: improve nstrftime failure check
	* src/pr.c (init_header): Do not report an nstrftime EOVERFLOW
	error as memory exhaustion.  Instead, output the time as an
	integer.  Also, work even if nstrftime (nullptr, SIZE_MAX, ...)
	would return PTRDIFF_MAX which means adding 1 would overflow..

	ls: better nstrftime failure check
	* src/ls.c (print_long_format): Streamline the checking
	for failure of nstrftime.

	build: update gnulib submodule to latest

2025-11-01  Collin Funk  <collin.funk1@gmail.com>

	tests: date: avoid test failure on NetBSD
	* tests/date/date-tz.sh: Allow date to fail with large values for TZ
	since NetBSD's tzalloc function limits them to 256 bytes.

2025-11-01  Pádraig Brady  <P@draigBrady.com>

	build: reduce explicit dependencies on macOS CoreFoundation
	* src/local.mk: Revert v9.7-322-gc2e1816a5, instead relying
	on the more focused v9.8-79-g532cd66af.  When built with
	--disable-nls on macOS this will result in only some commands
	being linked with INTL_MACOSX_LIBS, thus resulting in env(1)
	at least not setting a __CF_USER_TEXT_ENCODING envirnoment variable.

2025-11-01  Grisha Levit  <grishalevit@gmail.com>

	build: fix macOS build without libintl
	A more precise fix than commit v9.7-322-gc2e1816a5

	* configure.ac (USE_NLS): new AM_CONDITIONAL.
	* src/local.mk: add @INTL_MACOSX_LIBS@ to <prog>_LDADD that need it.

2025-11-01  Bruno Haible  <bruno@clisp.org>

	maint: ln: eliminate a clang -Wformat-extra-args warning
	* src/ln.c (do_link): Don't pass unused arguments to error().
	Don't use "%.0s" to consume a string argument without printing it.

	maint: ls: adjust to gnulib nstrftime changes
	* src/ls.c (align_nstrftime): Change return type to ptrdiff_t.
	(print_long_format): Treat a negative return value from align_nstrftime
	as failure.

2025-11-01  Pádraig Brady  <P@draigBrady.com>

	build: update gnulib submodule to latest
	* gnulib: update to latest

	copy: be more defensive/restrictive with posix_fadvise
	* src/copy-file-data.c (copy_file_data): Only give the
	POSIX_FADV_SEQUENTIAL hint when we _know_ we'll definitely
	use a read/write loop to copy the data.  Also only apply
	the hint to the whole file, as we've seen OpenZFS at least
	special case that.
	(sparse_copy): Update stale comment.

	copy: don't avoid copy-offload upon SEEK_HOLE indicating non-sparse
	* src/copy-file-data.c (infer_scantype): Fall back to a plain copy
	if SEEK_HOLE indicates non-sparse, as zero copy avoids copy offload.
	This was seen with transparently compressed files on OpenZFS.
	* tests/cp/sparse-perf.sh: Add a test case even though it might
	only trigger on compressed file systems that don't support reflink.
	* NEWS: Mention the bug fix.
	Addresses https://github.com/coreutils/coreutils/issues/122

	copy: avoid posix_fadvise bypassing copy offload behavior
	* src/copy-file-data.c (): pass 0 to posix_fadvise to indicate to EOF.
	coreutils 9.8 used OFF_T_MAX instead, which triggered OpenZFS 2.2.2
	at least to synchronously (decompress and) populate the page cache.
	Addresses https://github.com/coreutils/coreutils/issues/122

2025-11-01  Collin Funk  <collin.funk1@gmail.com>

	timeout: use fork and execvp instead of posix_spawn
	* NEWS: Remove timeout from the list of programs that use posix_spawn.
	* bootstrap.conf (gnulib_modules): Remove posix_spawnattr_setsigmask.
	* src/timeout.c: Don't include spawn.h.
	(main): Use fork and execvp instead of posix_spawn.

	This reverts commit dac96ce3e3a2424919fea6a17978b6e91e575d86.

2025-10-31  Pádraig Brady  <P@draigBrady.com>

	doc: NEWS: mention that sort --compress=script needs a shebang
	* NEWS: Mention that we don't fall-back to executing /bin/sh <script>
	for malformed scripts that don't start with #!..., or any executable
	that returns ENOEXEC in general.

2025-10-31  Bruno Haible  <bruno@clisp.org>

	sort: optimize the lookups of the --compress-program
	* src/sort.c (get_resolved_compress_program): New function.
	(pipe_child): Use it instead of calling find_in_given_path each time.

2025-10-31  Collin Funk  <collin.funk1@gmail.com>

	maint: avoid syntax-check failure from previous commit
	* src/sort.c (pipe_child): Use nullptr instead of NULL.

2025-10-30  Bruno Haible  <bruno@clisp.org>

	sort: consistently diagnose access issues to --compress-program
	* bootstrap.conf (gnulib_modules): Add findprog-in.
	* src/sort.c: Include findprog.h.
	(pipe_child): Look up the compress_program in $PATH and report errors
	such as ENOENT or EACCES before invoking posix_spawnp.
	This avoids inconsistency on systems that emulate posix_spawn through
	fork/exec, as they would otherwise treat such a failure as a generic
	failure and fail the sort, rather than continuing without compression.

2025-10-29  Pádraig Brady  <P@draigBrady.com>

	sort: fix silent exit upon SIGPIPE from --compress-program
	* src/sort.c (main): Ignore SIGPIPE so we've more control over
	how we handle for stdout and compression programs.
	(sort_die): Handle EPIPE from stdout and mimic a standard SIGPIPE,
	otherwise reverting to a standard exit(SORT_FAILURE);
	* tests/sort/sort-compress-proc.sh: Add a test case.
	* NEWS: Mention the bug fix.

2025-10-29  Collin Funk  <collin.funk1@gmail.com>

	build: update gnulib submodule to latest

2025-10-28  Pádraig Brady  <P@draigBrady.com>

	tests: fix new date/resolution.sh test on macOS
	* tests/date/resolution.sh: Fix comparison on systems with less than
	nano second reslution, where we use sed to discard the redundant
	trailing zeros output by date --resolution.
	Reported by Bruno Haible on macOS.

	numfmt: ensure fields don't split on nbsp
	* src/numfmt.c (newline_or_blank): Explicitly ensure
	we don't match NBSP as on platforms like NetBSD 10 or Solaris 11,
	NBSP is considered a blank character.
	This should have been part of commit v9.8-39-g8bc11f80a
	Solaris 11 test failure reported by Bruno Haible.

2025-10-27  Collin Funk  <collin.funk1@gmail.com>

	maint: prefer FTS_ROOTLEVEL when checking the fts_level of an FTSENT
	* src/chcon.c (process_file): Use FTS_ROOTLEVEL instead of 0.
	* src/chmod.c (process_file): Likewise.
	* src/chown-core.c (change_file_owner): Likewise.

	timeout: use the more efficient posix_spawn to invoke the command
	* NEWS: Mention the improvement. Consolidate the posix_spawn
	improvements into one item.
	* bootstrap.conf (gnulib_modules): Add posix_spawnattr_setsigmask.
	* src/timeout.c: Include spawn.h.
	(main): Setup signals using a posix_spawnattr_t object. Use posix_spawn
	instead of fork and execvp.

	maint: prefer ckd_add for overflow checks
	* src/cksum.c (cksum_slice8, crc32b_sum_stream): Use ckd_add to check
	for overflow.
	* src/cksum_avx2.c (cksum_avx2): Likewise.
	* src/cksum_avx512.c (cksum_avx512): Likewise.
	* src/cksum_pclmul.c (cksum_pclmul): Likewise.
	* src/cksum_vmull.c (cksum_vmull): Likewise.

2025-10-27  Pádraig Brady  <P@draigBrady.com>

	build: don't build chcon or runcon unless selinux is available
	The build can be force enabled with --with-selinux and vice versa.

	* build-aux/gen-lists-of-programs.sh: Move chcon and runcon
	to the list of optional programs.
	* configure.ac: Only enable chcon and runcon if selinux.h is available.
	* NEWS: Mention the Build-related change.
	Fixes https://github.com/coreutils/coreutils/issues/121

2025-10-25  Collin Funk  <collin.funk1@gmail.com>

	sort: use the more efficient posix_spawn to invoke --compress-program
	* NEWS: Mention the improvement. Mention that 'sort' will continue
	without compressing temporary files if the program specified by
	--compress-program cannot be executed.
	* doc/coreutils.texi (sort invocation): Document the behavior when the
	program specified by --compress-program cannot be executed.
	* src/sort.c: Include spawn.h.
	(MAX_FORK_TRIES_COMPRESS, MAX_FORK_TRIES_DECOMPRESS): Remove definition.
	(MAX_TRIES_COMPRESS, MAX_TRIES_DECOMPRESS): New definitions based on
	MAX_FORK_TRIES_COMPRESS and MAX_FORK_TRIES_DECOMPRESS.
	(async_safe_die): Remove function.
	(posix_spawn_file_actions_move_fd): New function.
	(pipe_fork): Remove function.
	(pipe_child): New function based on pipe_fork. Return an error number
	instead of a pid. Use posix_spawnp instead of calling fork and expecting
	the caller to exec.
	(maybe_create_temp): Call pipe_child instead of pipe_fork. Print a
	warning to standard error if --compress-program cannot be executed and
	the error is different than the previous call. Remove code for the child
	process.
	(open_temp): Remove code for the child process. Improve error message.
	* tests/sort/sort-compress.sh: Add a test case for when the program
	specified by --compress-program does not exist.

2025-10-23  Collin Funk  <collin.funk1@gmail.com>

	maint: remove unnecessary ignore_value usage
	* src/install.c: Remove ignore-value.h include.
	(strip): Don't use ignore_value on posix_spawnattr_destroy since it
	isn't declared with the warn_unused_result attribute. Pass the checked
	pointer to posix_spawnattr_destroy instead of the variable it points to.

2025-10-23  Bernhard Voelker  <mail@bernhard-voelker.de>

	install: enhance error diagnostic when running strip fails
	* src/install.c (strip): Mention explicitly that the strip program
	failed in the case the user specified a custom strip program name.

2025-10-23  Collin Funk  <collin.funk1@gmail.com>

	split: cleanup after posix_spawn
	* boostrap.conf (gnulib_modules): Add posix_spawn_file_actions_destroy.
	* src/split.c (cleanup): Call posix_spawnattr_destroy and
	posix_spawn_file_actions_destroy after a successful posix_spawn.

	split: prefer posix_spawn to fork and execl
	* NEWS: Mention the change.
	* bootstrap.conf (gnulib_modules): Add posix_spawn,
	posix_spawnattr_setsigdefault, posix_spawn_file_actions_addclose,
	posix_spawn_file_actions_adddup2, and posix_spawn_file_actions_init.
	* src/split.c: Include spawn.h.
	(create): Use posix_spawn instead of fork and execl.

2025-10-23  Pádraig Brady  <P@draigBrady.com>

	tests: date: test --resolution and %-N
	* tests/date/resolution.sh: New test for --resolution and %-N.
	* tests/local.mk: Reference the new test.

	tests: date: test --reference
	* tests/date/reference.sh: Ensure the -r option is tested.
	* tests/local.mk: Add the test.

2025-10-22  Pádraig Brady  <P@draigBrady.com>

	pr: promptly diagnose write errors
	* src/pr.c (print_page): Exit promptly for `yes | pr`.
	(print_clump): Exit promptly for `pr < /dev/zero`.
	* tests/misc/write-errors.sh: Enable test cases.
	* NEWS: Mention the improvement.

	nl: promptly diagnose write errors
	* NEWS: Mention the improvement.
	* src/nl.c (process_file): Exit if error outputting line.
	* tests/misc/write-errors.sh: Enable the test case.

	fmt: promptly diagnose write errors
	* NEWS: Mention the improvement.
	* src/fmt.c (put_line): Exit if any error writing line.
	(flush_paragraph): Exit if any error writing buffer.
	* tests/misc/write-errors.sh: Enable the (flush_paragraph) test case,
	and add another to check the put_line() case.

	numfmt: promptly diagnose write errors
	* src/numfmt.c (process line): Inspect the stdio error state when
	outputting each line so that we don't have to check each output function
	but do eventually exit upon write error, while also remaining buffered.
	(main): Also check when outputting a header for the edge case
	of very long headers.
	* tests/misc/write-errors.sh: Enable the numfmt test case.
	* NEWS: Mention the improvement, and reorganize all numfmt improvements.

2025-10-22  Collin Funk  <collin.funk1@gmail.com>

	install: prefer posix_spawnp to fork and execlp
	* NEWS: Mention the change.
	* bootstrap.conf (gnulib_modules): Add posix_spawnattr_destroy,
	posix_spawnattr_init, posix_spawnattr_setflags, and posix_spawnp.
	* src/install.c (strip): Use posix_spawnp instead of fork and execlp.

2025-10-20  Collin Funk  <collin.funk1@gmail.com>

	maint: remove a redundant write after mcel_scan returns an error
	* gl/lib/mbbuf.h (mbbuf_get_char): Don't set G.len to 1, since mcel_err
	has already done it.

2025-10-20  Pádraig Brady  <P@draigBrady.com>

	tests: numfmt: add non-utf8 multi-byte test
	* tests/numfmt/mb-non-utf8.sh: Test GB18030 delimiter search.
	* tests/local.mk: Reference the new test, and move
	the existing numfmt.pl test from tests/misc to tests/numfmt.

	numfmt: optimize multi-byte --delimiter search
	* src/numfmt.c (is_utf8_charset): A new function to efficiently
	determine if running with a UTF-8 charset.
	(mbsmbchr): A new function to efficiently search for
	a (multi-byte) character in a multi-byte string.
	(next-field): Use mbsmbchr() rather than mbstr() directly.

	numfmt: support multi-byte --delimiter
	* bootstrap.conf: Depend on mbsstr() to robustly search for a
	multi-byte delimiter character (string) within a multi-byte string.
	* src/numfmt.c (main): Accept a valid multi-byte delimiter character.
	(next_field): Adjust delimiter search from single byte
	to multi-byte aware.  Use mbsstr to find the first match.
	* tests/misc/numfmt.pl: Add test case.
	* NEWS: Mention the improvement.

2025-10-18  Pádraig Brady  <P@draigBrady.com>

	numfmt: use multi-byte aware suffix matching
	* src/numfmt.c (process_suffixed_number): Use gnulib's
	mbs_endswith() helper, which is more robust in non UTF-8 locales.
	Also always output a devmsg if a suffix is specified.

	numfmt: fix issues with multi-byte blanks
	* src/numfmt.c (process_line): Restore byte overwritten with NUL,
	as it may be part of a multi-byte blank.
	(process_suffixed_number): Skip multi-byte blanks,
	and correctly determine width with mbswidth().
	(parse_format_string): Use c_isblank() to explicitly
	indicate that's all the format spec supports.
	* tests/misc/numfmt.pl: Add test cases.
	* NEWS: Mention the bug fix.

2025-10-17  Pádraig Brady  <P@draigBrady.com>

	numfmt: add --unit-separator
	Output, accept, or disallow a string between the number and unit
	as recommended in <https://physics.nist.gov/cuu/Units/checklist.html>
	I.e. support outputting numbers of the form: "1234 M"

	* src/numfmt.c (simple_strtod_human): Skip unit separator if present,
	or disallow a unit separator if empty.
	(double_to_human): Output unit separator if specified.
	(main): Accept --unit-separator.
	* tests/misc/numfmt.pl: Add test cases.
	* doc/coreutils.texi: Describe the new option,
	giving examples of interaction with --delimiter.
	* NEWS: Mention the new feature.
	* THANKS.in: Add Johannes Schauer Marin Rodrigues,
	who provided a preliminary patch.

2025-10-17  Pádraig Brady  <P@draigBrady.com>

	numfmt: support reading numbers with grouping characters
	This does not validate grouping character placement,
	and currently just ignores grouping characters.

	* src/numfmt.c (simple_strtod_int): Skip grouping chars
	that are part of a number.
	* tests/misc/numfmt.pl: Add test cases.
	* NEWS: Mention the improvement.

2025-10-17  Pádraig Brady  <P@draigBrady.com>

	numfmt: support reading numbers with NBSP before unit
	* src/numfmt.c (simple_strtod_human): Accept (multi-byte)
	non-breaking space character between number and unit.
	Note we restrict this to a single character between number
	and unit, to allow less ambiguous parsing if multiple blanks
	are used to delimit fields.
	* tests/misc/numfmt.pl: Add test cases.
	* doc/coreutils.texi (numfmt invocation): Fix stale description
	--delimiter skipping whitespace.
	* NEWS: Mention the improvement.

2025-10-16  Nicolas Boichat  <nicolas@boichat.ch>

	tests: du/bigtime: try harder to find a suitable filesystem
	* tests/du/bigtime.sh: At least on Linux, the ext4 filesystem
	doesn't support such large timestamp, while tmpfs does.  Try a bit
	harder to look for a filesystem with large timestamp support.

2025-10-14  Collin Funk  <collin.funk1@gmail.com>
	    Pádraig Brady  <P@draigBrady.com>

	tests: date: check that the hour format of the current locale is used
	* tests/date/date-locale-hour.sh: New file.
	* tests/local.mk (all_tests): Add the new test.

2025-10-13  Pádraig Brady  <P@draigBrady.com>

	tests: fix false failure in recent memory limit test
	* tests/basenc/bounded-memory.sh: Ensure we skip the test
	upon failure to determine the memory lower bound.
	Reported by Bruno Haible.

2025-10-11  Pádraig Brady  <P@draigBrady.com>

	numfmt: fix buffer over-read (CWE-126)
	* src/numfmt.c (simple_strtod_human): Check for NULL after pointer
	adjustment to avoid Out-of-range pointer offset (CWE-823).
	* NEWS: Mention the fix.

2025-10-11  Pádraig Brady  <P@draigBrady.com>

	tests: basenc: use less redundant naming
	Rename to less redundant names, now that we use
	a separate test directory per util.

	* tests/basenc/basenc-bounded-memory.sh -> .../bounded-memory.sh
	* tests/basenc/basenc-large.sh -> .../large-input.sh
	* tests/local.mk: Reference new names.

2025-10-11  Pádraig Brady  <P@draigBrady.com>

	tests: fix memory limit determination in new test
	* tests/basenc/basenc-bounded-memory.sh: The passed command
	needs to succeed for memory limit determination to work.

2025-10-11  Collin Funk  <collin.funk1@gmail.com>

	tests: basenc: add a test for bounded memory operation
	* tests/basenc/basenc-bounded-memory.sh: New file.
	* tests/local.mk (all_tests): Add the test.

2025-10-10  Sylvestre Ledru  <sylvestre@debian.org>

	tests: ln -f: ensure existing link replaced
	Identified here:
	<https://github.com/uutils/coreutils/issues/8830>

	* tests/ln/misc.sh: Add the check.

2025-10-07  Pádraig Brady  <P@draigBrady.com>

	tests: cksum: add a test case for robust file name parsing
	* tests/cksum/cksum-c.sh: Add a test case where the file name
	contains tagged format delimiter characters.

	maint: cksum: document a base64/hex parsing ambiguity with untagged
	* src/digest.c (split_3): Mention the ambiguity in misinterpreting
	base64 characters as hex is not a practical consideration.
	Also add an example of both tagged formats which makes it
	easier to interpret the parsing logic.

	cksum: fix --check with untagged base64 format with tag matches
	* src/digest.c (split_3): Fallback to untagged matching in the
	case where -a is specified and we have matched a TAG in
	the possibly base64 data.  This might happen in 1 in every 64K files.
	Note we remove the modification of string S (and redundant streq) in
	the tag matching, as that was not needed since v8.32-223-g217cd278e.
	* tests/cksum/cksum-c.sh: Add a test case.
	* NEWS: Mention the bug fix.

	cksum: fix length validation with SHA2- tagged format
	* src/digest.c (sha2_sum_stream): Change from unreachable()
	to affirm() so that we have defined behavior unless
	we configure with --disable-assert.
	(sha3_sum_stream): Likewise.
	(split_3): Validate SHA2-lengths before passing on.
	* tests/cksum/cksum-c.sh: Add a test case.
	* NEWS: Mention the bug fix.

	cksum: fix --check with --algorithm=sha2
	* src/digest.c (split_3): Look up the provided tag with -a sha2
	because there is not a 1:1 mapping between them.
	* tests/cksum/cksum-c.sh: Add a test case.
	* NEWS: Mention the bug fix.

2025-10-06  Paul Eggert  <eggert@cs.ucla.edu>

	rm: remove redundant mark_ancestor_dirs call
	* src/remove.c (rm_fts): Remove unnecessary call.  Since this code
	is executed only when not recursive, there are no ancestors to mark.

	rm: make ‘rm -d DIR’ more like ‘rmdir DIR’
	* src/remove.c (rm_fts): When not recursive,
	arrange for ‘rm -d DIR’ to behave more like ‘rmdir DIR’.
	This works better for Ceph snapshot directories.
	Problem reported by Yannick Le Pennec (bug#78245).

2025-10-05  Collin Funk  <collin.funk1@gmail.com>

	cksum: allow -a {blake2b,sha2,sha3} --check to work on base64
	* NEWS: Mention the bug.
	* src/digest.c (split_3): Check that the base64 digest matches the
	length supported by the algorithm.
	(digest_check): Check that the read digest matches the base64 length of
	the algorithm's digest. The previous condition would not work for
	'cksum -a blake2b -l 8 ...'.
	* tests/cksum/cksum-base64-untagged.sh: New file.
	* tests/local.mk (all_tests): Add the new test.

2025-10-04  Paul Eggert  <eggert@cs.ucla.edu>

	maint: omit trailing white space in config.h
	* configure.ac (FORTIFY_SOURCE): Don’t indent a line
	where the indentation can cause trailing white space in config.h.
	Problem reported by Grisha Levit (Bug#79567).

2025-10-03  Collin Funk  <collin.funk1@gmail.com>

	maint: remove IRIX support
	* src/ptx.c (main) [HAVE_SETCHRCLASS]: Remove call to setchrclass.
	* src/stty.c (VREPRINT) [!VREPRINT && VRPRNT]: Remove definition.

2025-10-02  Pádraig Brady  <P@draigBrady.com>

	tests: factor: add suggested large prime tests
	* tests/factor/create-test.sh: Add 2 new large primes from:
	https://github.com/coreutils/coreutils/issues/65
	* tests/local.mk: Reference the 2 new generated tests.

2025-10-02  Pádraig Brady  <P@draigBrady.com>

	unexpand: fix heap buffer overflow with --tabs=[+/]NUM
	This avoids CWE-122: Heap-based Buffer Overflow
	where we could write blank characters beyond
	the allocated heap buffer.

	* src/expand-common.c (set_max_column_width): Refactor function from ...
	(add_tab_stop): ... here.
	(set_extend_size): Call new function.
	(set_increment_size): Likewise.
	* NEWS: Mention the bug fix.
	Fixes https://bugs.gnu.org/79555

2025-10-02  Pádraig Brady  <P@draigBrady.com>

	doc: man: consistently format -X[OPTIONAL] form
	This is significant for the date, od, and pr commands
	which have options of the form -X[OPTIONAL], which change like:

	  diff -r man.orig/date.1 man/date.1
	  < \fB\-I[FMT]\fR, \fB\-\-iso\-8601\fR[=\fI\,FMT\/\fR]
	  > \fB\-I\fR[\fI\,FMT\/\fR], \fB\-\-iso\-8601\fR[=\fI\,FMT\/\fR]

	  diff -r man.orig/od.1 man/od.1
	  < \fB\-w[BYTES]\fR, \fB\-\-width\fR[=\fI\,BYTES\/\fR]
	  > \fB\-w\fR[\fI\,BYTES\/\fR], \fB\-\-width\fR[=\fI\,BYTES\/\fR]

	* man/help2man (convert_options): Support options of the form
	-X[PARAM], so that we now consistently format them (in italics).

2025-10-02  Pádraig Brady  <P@draigBrady.com>

	doc: man: consistently italicize --option parameters
	This changes a few pages, but the changes in tail.1
	concisely illustrate the resulting man page changes:

	  $ diff -r man.orig/tail.1 man/tail.1
	  < \fB\-c\fR, \fB\-\-bytes\fR=\fI\,[\/\fR+]NUM
	  > \fB\-c\fR, \fB\-\-bytes\fR=\fI\,[+]NUM\/\fR

	  < \fB\-f\fR, \fB\-\-follow[=\fR{name|descriptor}]
	  > \fB\-f\fR, \fB\-\-follow\fR[=\fI\,{name|descriptor}\/\fR]

	  < \fB\-n\fR, \fB\-\-lines\fR=\fI\,[\/\fR+]NUM
	  > \fB\-n\fR, \fB\-\-lines\fR=\fI\,[+]NUM\/\fR

	* man/help2man: Relax the option match so more --option
	variations are supported, and passed through to convert_option().
	Specifically more variations after '=' are now supported.
	Also split and document the regular expression.
	Reported at https://github.com/coreutils/coreutils/issues/84

2025-10-02  Collin Funk  <collin.funk1@gmail.com>

	maint: prefer unreachable () to NOTREACHED comment
	* src/tsort.c (search_item): Use unreachable () instead of NOTREACHED.

2025-10-01  Collin Funk  <collin.funk1@gmail.com>

	fold: move multi-byte character reading to a module
	* gl/modules/mbbuf: New file.
	* gl/lib/mbbuf.c: Likewise.
	* gl/lib/mbbuf.h: Likewise.
	* gl/local.mk (EXTRA_DIST): Add the new files.
	* bootstrap.conf (gnulib_modules): Add mbbuf.
	* src/fold.c: Include mbbuf.h.
	(fold_file): Use the mbbuf functions instead of calling fread and
	handling the input buffer ourselves.
	* cfg.mk (exclude_file_name_regexp--sc_preprocessor_indentation)
	(exclude_file_name_regexp--sc_GPL_version): Match gl/lib/mbbuf.c and
	gl/lib/mbbuf.h.

2025-09-30  Mathieu Bordere  <mathieu@letmetweakit.com>

	wc: add AVX512 function for line counting
	* configure.ac: Add detection of AVX512 intrinsics for wc.
	* src/local.mk: Build AVX512 wc libraries.
	* src/wc.c: Add runtime detection of AVX512 intrinsics and call
	appropriate function when detected.
	* src/wc.h (wc_lines_avx512): Declare function.
	* tests/wc/wc-cpu.sh: Add a test that disables AVX512 intrinsics.
	* src/wc_avx512.c: New file containing the wc -l implementation using
	AVX512. The logic and code is reused from the AVX2 implementation with
	slight adaptations. Replaced __builtin_popcount by __builtin_popcountll
	and the combination of _mm256_cmpeq_epi8 and _mm256_movemask_epi8 by a
	single call to _mm512_cmpeq_epi8_mask.
	* NEWS: Mention the improvement.

2025-09-28  Pádraig Brady  <P@draigBrady.com>

	maint: update valgrind instructions
	* README-valgrind: Adjust to current repo structure,
	and give clearer step by step instructions.

2025-09-27  Collin Funk  <collin.funk1@gmail.com>

	maint: convert some overflow checks to ckd_add and ckd_mul
	* src/csplit.c (parse_repeat_count): Prefer ckd_add when checking for
	overflows.
	* src/install.c (get_ids): Likewise.
	* src/shred.c (dopass): Likewise.
	* src/tr.c (get_spec_stats): Likewise.
	* src/sort.c (specify_sort_size): Prefer ckd_mul when checking for
	overflows.

2025-09-26  Pádraig Brady  <P@draigBrady.com>

	tests: test: ensure file operations are covered
	A coverage report indicated these weren't tested
	(as generally the test shell builtin is used).

	* tests/test/test-file.sh: Add a new test.
	* tests/local.mk: Reference the new test.

2025-09-26  Bernhard Voelker  <mail@bernhard-voelker.de>

	join: remove unused #include "argmatch.h"
	Prompted by the syntax-check failure:
	  maint.mk: the above files include argmatch.h but don't use it
	  make: *** [maint.mk:741: sc_prohibit_argmatch_without_use] Error 1

	* src/join.c: Remove include, as the previous commit changed from using
	ARRAY_CARDINALITY to countof - for which system.h includes the header.

2025-09-25  Collin Funk  <collin.funk1@gmail.com>

	maint: prefer countof over ARRAY_CARDINALITY
	* bootstrap.conf (gnulib_modules): Add stdcountof-h.
	* src/system.h: Include stdcountof.h.
	(ARRAY_CARDINALITY): Remove definition.
	* .gitignore (/lib/stdcountof.h): Ignore Gnulib generated file.
	* src/csplit.c: Use countof instead of ARRAY_CARDINALITY.
	* src/df.c: Likewise.
	* src/digest.c: Likewise.
	* src/dircolors.c: Likewise.
	* src/factor.c: Likewise.
	* src/join.c: Likewise.
	* src/ls.c: Likewise.
	* src/od.c: Likewise.
	* src/sort.c: Likewise.
	* src/stdbuf.c: Likewise.
	* src/tr.c: Likewise.

2025-09-24  Hannes Braun  <hannes@hannesbraun.net>

	tail: fix tailing larger number of lines in regular files
	* src/tail.c (file_lines): Seek to the previous block instead of the
	beginning (or a little before) of the block that was just scanned.
	Otherwise, the same block is read and scanned (at least partially)
	again. This bug was introduced by commit v9.7-219-g976f8abc1.
	* tests/tail/basic-seek.sh: Add a new test.
	* tests/local.mk: Reference the new test.
	* NEWS: mention the bug fix.

2025-09-24  Pádraig Brady  <P@draigBrady.com>

	tests: wc: fix hardware acceleration disabling test
	* tests/wc/wc-cpu.sh: The message is only printed with wc -l.
	Reported by Mathieu Borderé.

	build: copy: add dependency on $(LIB_SMACK)
	* src/local.mk: Due to gnulib adjustments, this explicit
	dependency is required with the mold linker at least.
	Reported at https://github.com/coreutils/coreutils/issues/113

2025-09-23  Pádraig Brady  <P@draigBrady.com>

	basenc: --base58: fix buffer overflow with input > 15MB
	base58_length() operated naively on an int
	which resulted in an overflow to a negative number
	for any input > 2^31-1/138, i.e. 15,561,475 bytes.

	* src/basenc.c (base_length): Change input and output
	parameter types from int to idx_t since this needs to
	cater for the full input size in the base58 case.
	(base58_length): Likewise.  Also reorder the calculation
	to be less exact, but doing the division first
	to minimize the chance of overflow (which now on 64 bit
	would only happen for inputs > around 6 Exa bytes).
	* tests/basenc/basenc-large.sh: Add a new test,
	that triggers with valgrind or ASAN.
	* tests/local.mk: Reference the new test.
	* NEWS: Mention the bug fix.

2025-09-23  Pádraig Brady  <P@draigBrady.com>

	doc: document gl_cv_crc_pclmul to control hardware acceleration
	doc/coreutils.texi (Harware acceleration configuration):
	Sort the list and add "gl_cv_crc_pclmul".

	build: fix build failure with mismatched pclmul
	* src/cksum.c (pclmul_supported): In the case where
	gnulib has pclmul enabled but coreutils does not,
	ensure we don't reference the coreutils pclmul function.
	Addresses https://bugs.gnu.org/79491

2025-09-23  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2025-09-22  Pádraig Brady  <P@draigBrady.com>

	maint: post-release administrivia
	* NEWS: Add header line for next release.
	* .prev-version: Record previous version.
	* cfg.mk (old_NEWS_hash): Auto-update.

	version 9.8
	* NEWS: Record release date.

	build: update gnulib to latest
	* gnulib: Update to latest to pull Android build fixes,
	and fchownat fixes.

	tests: ls: avoid alignment check with non printable characters
	* tests/ls/block-size.sh: Skip the case where there are
	non-printable characters in ls' output, which is the case
	with NBSP thousands separators on FreeBSD 11 and 12.
	We may drop the MBSW_REJECT_UNPRINTABLE in future from
	ls and numfmt, but for now avoid these characters in the test.
	Reported by Bruno Haible.

	tests: du: avoid false failure in racy test
	* tests/du/move-dir-while-traversing.sh: Expand the work to avoid
	a false failure where du completes before the directory is moved.
	Also expand the timeout to our more standard 10s to avoid the
	"directory mover" being killed before du processes the directory.
	This doesn't perceptibly impact the run time of the test.
	Reported by Bruno Haible on a CentOS 7 system.

	build: revert gnulib update
	There is a pending issue with fchownat:
	https://lists.gnu.org/r/bug-gnulib/2025-09/msg00282.html

2025-09-21  Collin Funk  <collin.funk1@gmail.com>

	build: update gnulib submodule to latest

	build: fix missing declarations on Android
	* configure.ac: Check for statx using gl_CHECK_FUNCS_ANDROID since it is
	hidden for Android API level <= 30.
	* m4/jm-macros.m4 (coreutils_MACROS): Check for syncfs using
	gl_CHECK_FUNCS_ANDROID since it is hidden for Android API level <= 28.

2025-09-21  Paul Eggert  <eggert@cs.ucla.edu>

	maint: comment spelling fixes

	tests: fix OMP_NUM_THREADS misspelling
	* tests/nproc/nproc-quota.sh: Fix misspelling.

	maint: update bootstrap from Gnulib

2025-09-21  Pádraig Brady  <P@draigBrady.com>

	tests: avoid false failure on older Linux kernels
	* tests/fold/fold-zero-width.sh: Check the shell was able to create
	the redirection file, as intermittently on CentOS 5,6,7 this wasn't
	the case, with the shell giving an xmalloc failure due to the ulimit.
	Reported by William Bader and Bruno Haible.

	tests: tail: avoid false failure with overlayfs
	* tests/tail/inotify-dir-recreate.sh: Add an extra check
	that inotify is in use, as it's required for this test.
	Inotify is avoided with overlayfs for which the
	df --local check is not sufficient exclusion for.

2025-09-20  Pádraig Brady  <P@draigBrady.com>

	tests: fold: avoid false failures on Solaris 10
	* tests/fold/fold-characters.sh: Ensure we have independent verification
	of the width of characters before testing based on those widths.
	* tests/fold/fold-zero-width.sh: Likewise.
	* tests/fold/fold.pl: Only compare the exit status,
	as the error message can be translated.

	tests: dd: avoid false failure on Solaris 10
	* tests/dd/no-allocate.sh: Give some extra space to the
	determined vm limit.

	tests: avoid false failure on CentOS 5,6,7
	* tests/fold/fold-zero-width.sh: Increase vm limit to avoid
	failures on CentOS 5,6,7.  Match the limit used in write-errors.sh
	as per commit v9.5-255-g0bd149403

2025-09-20  Collin Funk  <collin.funk1@gmail.com>

	doc: don't capitalize the first letter of cgroup
	This is the correct way to write it as described in the documentation:
	<https://docs.kernel.org/admin-guide/cgroup-v2.html#terminology>.

	* doc/coreutils.texi (nproc invocation): Use cgroup instead of Cgroup.

2025-09-20  Collin Funk  <collin.funk1@gmail.com>

	tests: env: skip a few tests if LD_LIBRARY_PATH is set
	* tests/env/env-null.sh: Skip test if LD_LIBRARY_PATH or platform's
	equivalent is set, since 'env -i' will unset it which may prevent
	programs from running.
	* tests/env/env-S.pl: Likewise.
	Issue and suggested fix reported by Bruno Haible.

2025-09-19  Grisha Levit  <grishalevit@gmail.com>

	touch: fix diagnostic on macOS 26
	* src/touch.c (touch): Do not use open_errno == EEXIST for diagnostic
	if file was a directory as macOS 26 sets it for open("/", O_CREAT, ...).

2025-09-19  Paul Eggert  <eggert@cs.ucla.edu>

	copy: pacify older clang
	* src/copy-file-data.c (copy_file_data):
	Redo conditionals for clarity.
	This pacifies the clang in FreeBSD 11 and OpenBSD 7.6.
	Problem reported by Bruno Haible in:
	https://lists.gnu.org/r/coreutils/2025-09/msg00104.html

2025-09-19  Collin Funk  <collin.funk1@gmail.com>

	dd: don't mistakenly use O_EXCL on GNU/Hurd
	* src/dd.c (v): Add the O_EXCL flag to the set of bits that we do not
	want to use for our definitions.
	* cfg.mk (sc_dd_O_FLAGS): Adjust to pass syntax-check.
	* NEWS: Mention the fix.
	Reported by Bruno Haible.

2025-09-19  Paul Eggert  <eggert@cs.ucla.edu>

	maint: we don’t use Gnulib’s fchownat module
	* bootstrap.conf (gnulib_modules): Remove fchownat.
	It is used only indirectly, via the chownat module.

2025-09-18  Bruno Haible  <bruno@clisp.org>

	fmt: eliminate a clang -Wformat-extra-args warning
	* src/fmt.c (fmt): When not reading from stdin, always mention the
	file name in the error message.

2025-09-18  Paul Eggert  <eggert@cs.ucla.edu>

	maint: we use Gnulib’s stddef-h module directly
	* bootstrap.conf (gnulib_modules): Add stddef-h, since the code
	uses ‘unreachable’ which is supplied by that module.

2025-09-18  Pádraig Brady  <P@draigBrady.com>

	tests: tail/overlay-headers.sh: protect against hang
	* tests/tail/overlay-headers.sh: Protect tail invocation with timeout,
	and extend the possible running period to 60 seconds like other tests.
	Reported by Brudno Haible on T2SDE Linux/alpha

	build: fix compile error on macOS
	* gnulib: Update to latest to pull fix
	for localcharset compile failure on macOS.

	tests: tests/tail/wait.sh: protect against hang
	* tests/tail/wait.sh: This test was seen to hang occasionally
	on an Alpine Linux 3.20 system, so protect the tail(1) call
	with `timeout 60` as done in similar tests.
	Reported by Bruno Haible.

	build: fix link failure on macOS
	* src/local.mk: Explicitly depend on @INTL_MACOS_LIBS@
	which may be not implicitly referenced (in LIBINTL) without gettext.
	This is a new transitive dependency through localename-unsafe.
	We add this globally to ease future maintenance as currently
	6 commands require the localename-unsafe dependency:
	date, du through show-date() (fprintftime), and
	ls, pr, stat, uptime through strftime().

2025-09-17  Pádraig Brady  <P@draigBrady.com>

	build: update gnulib for stringeq adjustment
	* gnulib: Pull in stringeq adjustment.

	tests: write-errors.sh: avoid portability issue with dash
	* tests/misc/write-errors.sh: Use printf rather than echo
	since the echo builtin in dash will interpret backslashes.
	* tests/misc/read-errors.sh: Likewise for consistency.

	cksum,wc: inspect GLIBC_TUNABLES on all architectures
	* gnulib: Update gnulib to latest to pull in change
	to inspect GLIBC_TUNABLES on non x86_64 or aarch64 platforms.
	This was needed on 32 bit x86, which supports calling into
	accelerated code, and so requires inspection of GLIBC_TUNABLES
	to pass the disablement verification in tests/cksum/cksum.sh

2025-09-17  Paul Eggert  <eggert@cs.ucla.edu>

	maint: prefer memeq to memcmp
	* gl/modules/randread-tests (Depends-on): Add stringeq.
	* gl/tests/test-rand-isaac.c (main):
	* src/copy.c (source_is_dst_backup):
	* src/digest.c (b64_equal):
	* src/install.c (have_same_content):
	* src/ls.c (main, parse_ls_color):
	* src/nl.c (check_section):
	* src/od.c (write_block):
	* src/seq.c (seq_fast):
	* src/stty.c (eq_mode):
	* src/system.h (is_nul):
	Prefer memeq to memcmp when either will do.

	maint: STREQ → streq
	Use new Gnulib streq function instead of rolling our own macro.
	* bootstrap.conf (gnulib_modules): Add stringeq.
	* src/rm.c (main): Don’t assume streq is a macro that expands to (...),
	as it is now a function.
	* src/system.h:
	* tests/df/no-mtab-status.sh, tests/df/skip-duplicates.sh:
	(STREQ): Remove.  All uses replaced by streq.

	build: update gnulib submodule to latest

2025-09-17  Pádraig Brady  <P@draigBrady.com>

	tests: fix issues with fold-characters.sh test
	This was noticed with:

	  trap '' PIPE &&  # Ignore SIGPIPE
	  make check TESTS=tests/fold/fold-characters.sh SUBDIRS=.

	* tests/fold/fold-characters.sh: Move memory limit test to ...
	* tests/misc/write-errors.sh: ... which avoids "write error"
	messages on stderr due to the ignored SIGPIPE.  It also protects
	the fold invocation with a timeout(1) so that fold implementations
	that don't exit promptly upon write error don't hang the test suite
	(Like we would have done before commit v9.7-311-gc95c7ee76).

2025-09-17  Pádraig Brady  <P@draigBrady.com>

	doc: remove older ChangeLog items
	* Makefile.am: Update the oldest documented version
	to 8.32 which is now about 5 years old.

2025-09-17  Collin Funk  <collin.funk1@gmail.com>

	maint: remove unnecessary uintmaxtostr usage in printf
	* src/comm.c (compare_files): Use the "%ju" printf directive instead of
	"%s" and printing the result of umaxtostr.
	* src/df.c (get_header): Likewise.
	* src/ls.c (print_long_format): Likewise.
	* src/sort.c (check): Likewise.

2025-09-17  Pádraig Brady  <P@draigBrady.com>

	doc: add hardware acceleration configuration docs
	* NEWS: Mention the new GLIBC_TUNABLES feature.
	* doc/coreutils.texi (Hardware Acceleration): A new node
	detailing the build time and run time configuration options.

2025-09-16  Pádraig Brady  <P@draigBrady.com>

	fold: fix write error checks with invalid multi-byte input
	* src/fold.c (write_out): A new helper to check all writes.
	(fold-file): Use write_out() for all writes.
	* tests/fold/fold-zero-width.sh: Adjust to writing more
	data in various patterns, rather than two buffers of NULs.
	This is a more robust memory bound check, and the '\303' case
	tests this particular logic change.
	* NEWS: fold now exits immediately, not just promptly.

	fold: exit promptly upon write errors
	* NEWS: Mention the improvement.
	* src/fold.c (fold_file): Check for write errors
	after each buffer read from stdin.
	* tests/misc/write-errors.sh: Add test cases.

	maint: basenc: refactor overloaded use of ctx->i member
	* src/basenc.c (base_decode_context): Remove the shared "i" member,
	instead using per encoding data and access functions
	for tracking pending data.

	tests: fold/fold-zero-width.sh: avoid false failure with ENOSPC
	* tests/fold/fold-zero-width.sh: Check relatively large test file
	is created appropriately.  Also apply more idomatic wc -l usage.

	doc: NEWS: fold: clarify mem exhaustion trigger
	* NEWS: Long lines were not an issue in previously
	released coreutils, only the -w limitation was.

	maint: avoid syntax-check failures from recent commits
	* cfg.mk: Avoid spellcheck failures.
	* src/copy-file-data.c: Avoid sc_tight_scope and long_lines failure.
	* src/copy.h: Avoid indentation issues.

2025-09-16  Paul Eggert  <eggert@cs.ucla.edu>

	cp: create_hole now returns off_t
	* src/copy-file-data.c (create_hole): Refactor by returning
	resulting offset, not bool.  All callers changed.

	cp: prefer signed types in copy-file-data.c
	* src/copy-file-data.c (sparse_copy, lseek_copy)
	(copy_file_data): Prefer idx_t to size_t.
	(copy_file_data): Defend against st_size < 0, which can happen on
	ancient buggy platforms.  Check for overflow; the old code was
	wrong on theoretical-but-valid hosts where SIZE_MAX <= INT_MAX.

	cp: don’t allocate a separate zero buffer
	* src/copy-file-data.c (write_zeros): New args abuf, buf_size.
	Use the lazily-allocated buffer, which most likely already exists,
	rather than allocating a separate buffer just for zeros.
	This makes the code more reentrant as there is no longer
	a need for static storage here.  Although there is some CPU
	overhead due to the need to zero out the buffer for each file,
	the overhead is relatively small as the buffer is smallish
	and should be cached.  All callers changed.

	cp: refactor copying to return bytes copied
	This doesn’t change behavior; it simplifies future changes.
	* src/copy-file-data.c (sparse_copy, lseek_copy, copy_file_data):
	Return the number of bytes copied, or -1 on failure,
	instead of merely returning a success indication.
	All callers changed.

	cp: copy_file_data now supports ibytes
	This does not affect current coreutils behavior;
	it is merely to help make copy_file_data more useful in the future.
	* src/copy-file-data.c (lseek_copy): New arg ibytes.
	Caller changed.
	(copy_file_data): Implement the ibytes arg; formerly
	it was always treated as COUNT_MAX, though all callers
	currently pass COUNT_MAX so there was no problem in practice.

	cp: prefer signed type for file byte count
	* src/copy-file-data.c (sparse_copy): max_n_read arg is now
	of type count_t, not uintmax_t.  This is better for debugging
	with -fsanitize=undefined.

	cp: port better to old limited hosts
	Port better ancient platforms where OFF_T_MAX is only 2**31 - 1,
	but some devices have more than that many bytes.
	* src/copy-file-data.c (copy_file_data): Byte count is now
	count_t, not off_t.  All callers changed.  Since we need to check
	for overflow anyway, also check for too-small calls to fadvise.

	cp: refactor out data copying
	* po/POTFILES.in, src/local.mk (copy_sources): Add the new file.
	* src/copy.c: Move the #includes of alignalloc.h, buffer-lcm.h,
	fadvise.h, full-write.h, ioblksize.h to copy-file-data.c.
	(enum copy_debug_val, struct copy_debug): Move these decls to copy.h.
	(punch_hole, create_hole, is_CLONENOTSUP, sparse_copy)
	(write_zeros, lseek_copy, HAVE_STRUCT_STAT_ST_BLOCKS)
	(enum scantype, struct scan_inference, infer_scantype):
	Move to copy-file-data.c.
	(copy_reg): Move the data-copying part of this function
	to the new function copy_file_data in copy-file-data.c.
	* src/copy-file-data.c: New file, taken from part of copy.c.

	cp: refactor src/copy.c
	This is in preparation for splitting this large module.
	* src/copy.c (sparse_copy, lseek_copy): New arg DEBUG, used to
	identify copy debug info instead of using a static var.  All
	callers changed.
	(lseek_copy, infer_scantype): New args SRC_POS and POS.
	Callers changed.
	(copy_file_data): New function, with contents taken from copy.
	(copy_reg): Call it.

2025-09-16  Collin Funk  <collin.funk1@gmail.com>

	doc: NEWS: correct the previous commit
	* NEWS: The memory allocated by 'fold' in the past was also bounded by
	--width.

	doc: NEWS: mention fold can operate on very long lines
	* NEWS: Before commit fb9016d50 (fold: use fread instead of getline,
	2025-08-24), fold required that the maximum line size in a file fit into
	memory. Document that this is no longer the case.

	fold: fix out of bounds write with zero width characters
	* src/fold.c (fold_file): Prefer putchar ('\n') to copying characters.
	If we do not have room in the output buffer print it since it is not a
	full line of text.
	* tests/fold/fold-zero-width.sh: New test case.
	* tests/local.mk (all_tests): Add it.

2025-09-16  Paul Eggert  <eggert@cs.ucla.edu>

	cp: improve umask caching
	* src/copy.c (cached_umask): Avoid syscalls when cached umask is 0.
	This can also help the compiler’s static analysis.

2025-09-14  Collin Funk  <collin.funk1@gmail.com>

	basenc: fix an uninitialized index when decoding an empty file
	* src/basenc.c (base64_decode_ctx_init_wrapper)
	(base64url_decode_ctx_init_wrapper)
	(base32_decode_ctx_init_wrapper)
	(base32hex_decode_ctx_init_wrapper): Initialize ctx->i to zero.
	Fixes https://bugs.gnu.org/79444

2025-09-14  Pádraig Brady  <P@draigBrady.com>

	maint: randperm: remove stale dependency
	* gl/modules/randperm: Remove assert-h dependency
	not required since commit v9.5-34-g26ba82015

2025-09-14  Pádraig Brady  <P@draigBrady.com>

	cksum,wc: support disabling hardware acceleration at runtime
	This is useful to give better test coverage at least,
	and may be useful for users to tune their environment.

	* bootstrap.conf: Reference the cpu-supports gnulib module.
	* src/cksum.c: Use cpu_supports() rather than __builtin_cpu_supports().
	* src/wc.c: Likewise.
	* tests/cksum/cksum.sh: Adjust to testing all implementations.
	* tests/wc/wc-cpu.sh: A new test to do likewise.
	* tests/local.mk: Reference the new wc test.

2025-09-14  Pádraig Brady  <P@draigBrady.com>

	build: update gnulib submodule to latest
	Primarily to get the new cpu-supports module.

2025-09-13  Paul Eggert  <eggert@cs.ucla.edu>

	factor: port to strict C
	Problem found with Oracle Developer Studio 12.6.
	* src/factor.c (factor): Don’t return f() when f returns void.

2025-09-12  Collin Funk  <collin.funk1@gmail.com>

	maint: document some functions used by expand and unexpand
	* src/expand-common.h (get_next_tab_column, cleanup_file_list_stdin)
	(emit_tab_list_info): Document functions.
	* src/expand-common.c (cleanup_file_list_stdin, emit_tab_list_info):
	Likewise.

2025-09-10  Pádraig Brady  <P@draigBrady.com>

	maint: basenc: refactor all encodings to use finalize
	Finalize was required for base58, but it's a more general mechanism
	which simplifies the logic for all encodings

	* src/basenc.c (do_decode): Always call base_decode_ctx_finalize(),
	rather than the awkward double loop at end of buffer.
	* tests/basenc/basenc.pl: Add basenc finalization tests.

2025-09-10  Collin Funk  <collin.funk1@gmail.com>

	maint: cleanup libraries unnecessarily added to fold
	* src/local.mk (src_fold_LDADD): Remove $(MBRTOWC_LIB) since it is
	already added to LDADD. Remove $(LIBC32CONV) and $(LIBUNISTRING) which
	were for an uncommitted patch which used Gnulib's mbfile module.

2025-09-09  Pádraig Brady  <P@draigBrady.com>

	nohup: avoid FORTIFY runtime failure on Bionic libc
	The meaning of non-file permission umask bits is implementation defined.
	On Bionic libc, attempting to set them triggers a FORTIFY runtime check.

	  $ nohup true
	  FORTIFY: umask: called with invalid mask -601
	  Aborted                    nohup true

	* src/nohup.c: (main) Avoid setting non-permission bits in umask.
	Just clear the umask to ensure we create nohup.out with u+rw,
	as we restore the original umask before the exec().
	* tests/misc/nohup.sh: Add a test case.
	* NEWS: Mention the bug fix.

2025-09-08  Pádraig Brady  <P@draigBrady.com>

	basenc: ensure partial padding with newlines induces an error
	* src/basenc.c (has_padding): A more robust helper to
	identify padding in the presence of trailing newlines.
	(do_decode): Use has_padding() rather than just looking
	at the last character.
	* tests/basenc/base64.pl: Fully test commit v9.4-53-g378dc38f4
	by ensuring partially padded data is diagnosed.
	baddecode9 is the case fixed in this commit.
	* NEWS: Mention the bug fix.

2025-09-07  Pádraig Brady  <P@draigBrady.com>

	tests: ensure option aliases are supported
	This implicitly tests the previous commit to
	adjust how date(1) handles multiple named format options.
	Currrently it tests the following are supported:

	  chown  --quiet  --silent
	  date  --rfc-email  --rfc-822  --rfc-2822
	  date  --uct  --utc  --universal
	  dircolors  --bourne-shell  --sh
	  dircolors  --csh  --c-shell
	  head  --quiet  --silent

	* tests/misc/option-aliases.sh: A new test to ensure all
	option aliases supported by a command are supported.
	* Reference the new test.

2025-09-07  Pádraig Brady  <P@draigBrady.com>

	date: support overriding named formats
	* src/date.c (main): Allow specifying different named formats,
	with the last specified taking precedence.
	* NEWS: Mention the bug fix.

2025-09-07  Collin Funk  <collin.funk1@gmail.com>

	cksum: don't leak memory using -a sha3 with OpenSSL
	* gnulib: Update to the latest commit for latest changes to the
	crypto/sha3-buffer and crypto/sha3 modules.

2025-09-05  Collin Funk  <collin.funk1@gmail.com>

	maint: prefer c32isspace to iswspace
	* src/wc.c (wc): Replace call to iswspace with c32isspace.

	tests: fold: check if multi-byte spaces are treated as blank
	This avoids a test failure on FreeBSD 14, MacOS 15, and musl.
	Fix suggested by Pádraig Brady in:
	<https://bugs.gnu.org/79301#32>.
	* tests/fold/fold-spaces.sh (isblank): New function. Only run the tests
	if the character is treated as blank.
	Fixes https://bugs.gnu.org/79301

2025-09-04  Pádraig Brady  <P@draigBrady.com>

	doc: update the md5/sha1 "weak hash" advisory
	* doc/coreutils.texi: Adjust advisory for md5sum and sha1sum
	to include "sha3", and also the more general `cksum -a` interface.

	tests: cksum: check more length variants
	* tests/cksum/cksum-raw.sh: Adjust to non legacy naming,
	and also check various length variations.
	* tests/misc/read-errors.sh: Likewise.

	doc: NEWS: expand on the fold multi-byte enhancements
	* NEWS: Mention all of fold(1) got multi-byte enhancement,
	with -c being an ancillary part of that.

2025-09-04  Pádraig Brady  <P@draigBrady.com>

	cksum: prefer -a sha2 -l ###, to -a sha###
	To make the interface more concise and consistent,
	while being backwards compatible.

	* src/digest.c (main): Continue to support -a "sha###" but
	also support -a "sha2" and treat it like "sha3", except in...
	(output_file): ... maintain the legacy tags for better compatability.
	* doc/coreutils.texi (cksum invocation): Document the -a sha2 option.
	* tests/cksum/cksum-base64.pl: Adjust as per modified --help.
	* tests/cksum/cksum-c.sh: Add new supported SHA2-### tagged variant.
	* NEWS: Mention the new feature.

2025-09-04  Collin Funk  <collin.funk1@gmail.com>

	cksum: add support for SHA-3
	* src/digest.c: Include sha3.h.
	(BLAKE2B_MAX_LEN): Rename to
	DIGEST_MAX_LEN since it is also used for SHA-3.
	(sha3_sum_stream): New function.
	(enum Algorithm, algorithm_args, algorithm_args, algorithm_types)
	algorithm_tags, algorithm_bits, cksumfns, cksum_output_fns): Add entries
	for SHA-3.
	(usage): Mention that SHA-3 is supported. Mention requirements for
	--length with SHA-3.
	(split_3): Use DIGEST_MAX_LEN instead of BLAKE2B_MAX_LEN. Determine the
	length of the digest for SHA-3. Make sure it is 224, 256, 384, or 512.
	(digest_file): Set the digest length in bytes. Use DIGEST_MAX_LEN
	instead of BLAKE2B_MAX_LEN. Always append the digest length to SHA3 in
	the output.
	(main): Allow the use of --length with 'cksum -a sha3'.  Use
	DIGEST_MAX_LEN instead of BLAKE2B_MAX_LEN. Make sure it is 224, 256,
	384, or 512.
	* tests/cksum/cksum-base64.pl (@pairs): Add expected sha3 output.
	(fmt): Modify the output to use SHA3-512 since that is the default.
	(@Tests): Modify arguments for sha3 to use --length=512.
	* tests/cksum/cksum-sha3.sh: New test, based on tests/cksum/b2sum.sh.
	* tests/local.mk (all_tests): Add the test.
	* bootstrap.conf: Add crypto/sha3.
	* gnulib: Update to latest commit.
	* NEWS: Mention the change.
	* doc/coreutils.texi (cksum general options): Mention sha3 as a
	supported argument to the -a option. Mention that 'cksum -a sha3'
	supports the --length option. Mention that SHA-3 is considered secure.

	maint: avoid syntax-check failure from previous commit
	* src/df.c: Don't include uchar.h.
	* src/ls.c: Likewise.
	* src/wc.c: Likewise.

2025-09-04  Collin Funk  <collin.funk1@gmail.com>

	fold: check that characters are not non-breaking spaces when -s is used
	NetBSD 10 and Solaris 11.4 treat non-breaking spaces as blank
	characters unlike glibc.

	* src/system.h: Include uchar.h.
	(c32isnbspace): New function based on iswnbspace from src/wc.c.
	* src/fold.c (fold_file): Use it.
	* src/wc.c (iswnbspace): Remove function.
	(maybe_c32isnbspace): New function.
	(wc, main): Use it.
	Fixes https://bugs.gnu.org/79300

2025-09-04  Collin Funk  <collin.funk1@gmail.com>

	maint: prefer issymlink to readlink with a small buffer
	* bootstrap.conf (gnulib_modules): Add issymlink and issymlinkat.
	* src/copy.c: Include issymlink.h.
	(copy_reg): Use issymlink instead of readlinkat.
	* src/rmdir.c: Include issymlink.h.
	(main): Use issymlink instead of readlink.
	* src/tail.c: Include issymlink.h.
	(recheck, any_symlinks): Use issymlink instead of readlink.
	* src/test.c: Include issymlink.h.
	(unary_operator): Use issymlink instead of readlink.

2025-09-04  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2025-09-04  Bruno Haible  <bruno@clisp.org>

	build: Update after gnulib changed
	* gnulib-tests/Makefile.am: Move the AM_CFLAGS assignment before the
	'include gnulib.mk'.

2025-09-03  Collin Funk  <collin.funk1@gmail.com>

	maint: avoid syntax-check failure from previous commit
	* tests/seq/seq-long-double.sh: Place comma after "I.e.".

2025-09-02  Pádraig Brady  <P@draigBrady.com>

	seq: be more accurate with large integer start values
	* src/seq.c (main): Avoid possibly innacurate conversion
	to long double, for all digit start values.
	* tests/seq/seq-long-double.sh: Add a test case.
	* NEWS: Mention the improvement.
	Fixes https://bugs.gnu.org/79369

2025-09-01  Paul Eggert  <eggert@cs.ucla.edu>

	df: pacify static analysis
	Problem reported by Yubiao Hu <https://bugs.gnu.org/79336>.
	* src/df.c (get_dev): Assume MOUNT_POINT is non-null.

2025-08-31  Pádraig Brady  <P@draigBrady.com>

	ls: fix alignment with locale formatted --size
	Fix allocated size alignment in locales with multi-byte grouping chars.
	Tested with: LC_ALL=sv_SE.utf8 ls --size --block-size=\'k

	* src/ls.c (print_file_name_and_frills): Don't rely on
	printf("%*s", width, string) to pad multi-byte strings appropriately.
	Instead work out the padding required and use:
	printf("%*s%s", padding, "", string) to pad multi-byte appropriately.
	* tests/ls/block-size.sh: Add a test case.
	* NEWS: Mention the bug fix.
	Fixes https://bugs.gnu.org/79347

2025-08-30  Pádraig Brady  <P@draigBrady.com>

	b2sum: --length: fix upper bound check
	* src/digest.c (main): Don't saturate -l to BLAKE2B_MAX_LEN,
	so that the subsequent bounds check is performed.
	* tests/cksum/b2sum.sh: Add a test case.
	* NEWS: Mention the fix introduced in commit v9.5-71-gf2c84fe63

2025-08-29  Collin Funk  <collin.funk1@gmail.com>

	fold: fix handling of invalid multi-byte characters
	* src/fold.c (fold_file): Continue the loop when we have buffered bytes
	but nothing left to read from the file.
	(adjust_column): Don't assume that the character is printable.
	* tests/fold/fold-characters.sh: Add a new test case.
	(bad_unicode): New function.

2025-08-27  Pádraig Brady  <P@draigBrady.com>

	tests: fold: add tests for multi-byte width
	* tests/fold/fold.pl: The i18n patch didn't actually test folding
	of multi-byte characters, so add tests for various multi-byte forms.

	tests: fold: copy i18n patch tests
	* tests/fold/fold.pl: Copy tests from Fedora,
	removing copy & pasted logic that was
	extraneous to either the i18n patch or upstream.

	tests: parameterize IO_BUFSIZE
	* src/getlimits.c (main): Output IO_BUFSIZE, useful for
	sizing data for tests.
	* tests/fold/fold-characters.sh: Use it rather than hardcoding.

2025-08-27  Pádraig Brady  <P@draigBrady.com>

	build: fold: fix build failure with C99
	GCC 10.2 gave the following error:
	"error: label at end of compound statement"

	* src/fold.c (fold_file): Add a ";" to avoid C2X specific syntax.

2025-08-27  Collin Funk  <collin.funk1@gmail.com>

	fold: don't truncate multibyte characters at the end of the buffer
	* src/fold.c (fold_file): Replace invalid characters with the original
	byte read. Copy multibyte sequences that may not yet be read to the
	start of the buffer before reading more bytes.
	* tests/fold/fold-characters.sh: Add a test case.

2025-08-26  Pádraig Brady  <P@draigBrady.com>

	tests: fold: consolidate all fold tests in tests/fold
	* tests/misc/fold.pl: Move from here to ...
	* tests/fold/fold.pl: ... here.
	* tests/local.mk: Adjust accordingly.

2025-08-26  Pádraig Brady  <P@draigBrady.com>

	tests: fold: add a memory constraint test
	Enforcing this interface behavior is worthwhile
	irrespective of our current implementation,
	to ensure future or other implementations conform.

	* tests/fold/fold-characters.sh: Ensure the fold implementation
	uses bounded memory.

2025-08-24  Collin Funk  <collin.funk1@gmail.com>

	fold: use fread instead of getline
	* src/fold.c: Include ioblksize.h.
	(fold_file): Use two IO_BUFSIZE-sized buffers. Use fread instead of
	getline. Check for if we reached the end of file.

2025-08-24  Pádraig Brady  <P@draigBrady.com>

	tests: nproc: fix false failure on some systems
	* tests/nproc/nproc-quota.sh: Also simulate sched_getscheduler()
	as this will not be called on older or non linux, or
	may return ENOSYS on Alpine.
	Fixes https://bugs.gnu.org/79299

2025-08-24  Collin Funk  <collin.funk1@gmail.com>

	maint: prefer STRUCT_UTMP to struct gl_utmp
	* cfg.mk (sc_prohibit-struct-gl_utmp): New rule for 'make syntax-check'.
	* src/pinky.c (time_string, print_entry, scan_entries, short_pinky):
	Use STRUCT_UTMP instead of struct gl_utmp.
	* src/uptime.c (print_uptime, print_uptime, uptime): Likewise.
	* src/users.c (list_entries_users, users): Likewise.
	* src/who.c (time_string, print_user, print_boottime, print_deadprocs)
	(print_login, print_initspawn, print_clockchange, print_runlevel)
	list_entries_who, scan_entries, who): Likewise.

2025-08-23  Pádraig Brady  <P@draigBrady.com>

	tests: cp: ensure copy offload is not disabled for sparse files
	Related to commits v9.1-109-g879d2180d and v9.7-248-g306de6c26

	* tests/cp/sparse-perf.sh: This edge case was missed a couple of times,
	so add a test to ensure we attempt copy offload.

2025-08-23  Collin Funk  <collin.funk1@gmail.com>

	fold: add the --characters option
	* src/fold.c: Include mcel.h.
	(count_bytes): Remove variable.
	(counting_mode, last_character_width): New variables.
	(shortopts, long_options): Add the option.
	(adjust_column): If --characters is in used account for number of
	characters instead of their width.
	(fold_file): Use getline and iterate over the result with mcel functions
	to handle multibyte characters.
	(main): Check for the option.
	* src/local.mk (src_fold_LDADD): Add $(LIBC32CONV), $(LIBUNISTRING), and
	$(MBRTOWC_LIB).
	* tests/fold/fold-characters.sh: New file.
	* tests/fold/fold-spaces.sh: New file.
	* tests/fold/fold-nbsp.sh: New file.
	* tests/local.mk (all_tests): Add the tests.
	* NEWS: Mention the new option.
	* doc/coreutils.texi (fold invocation): Likewise.

2025-08-23  Paul Eggert  <eggert@cs.ucla.edu>

	cp: improve hole handling on squashfs
	Better fix for problem reported by Jeremy Allison
	<https://bugs.gnu.org/79267>.
	* src/copy.c (struct scan_inference): New type, replacing
	union scan_inference.  All uses changed.  This is so
	infer_scantype can report the first hole's offset when known.
	(lseek_copy): 5th arg is now struct scan_inference const *,
	not just off_t.  All uses changed.
	(infer_scantype): If SEEK_SET+SEEK_HOLE do not find a hole,
	fall back on ZERO_SCANTYPE.

	cp: go back to copy_file_range optimization
	This reverts part of the previous change.
	* src/copy.c (lseek_copy): When calling sparse_copy, do not
	ask it to scan for zeros unless --sparse=always, so that it
	can use copy_file_range which can be far more efficient.

2025-08-21  Paul Eggert  <eggert@cs.ucla.edu>

	cp: always punch holes that we make
	Problem reported by Jeremy Allison <https://bugs.gnu.org/79267>.
	* src/copy.c (create_hole, sparse_copy): Omit arg PUNCH_HOLES,
	as we always punch holes now.  All uses changed.
	(lseek_copy): When calling sparse_copy, scan for holes when
	sparse_mode == SPARSE_AUTO, as that means we are making holes.
	(copy_reg): Always punch any hole made at end.

2025-08-21  Pádraig Brady  <P@draigBrady.com>

	tests: nproc: add a test for cgroup quotas
	* tests/nproc/nproc-quota.sh: New root only test.
	* tests/local.mk: Reference the new test.

2025-08-19  Collin Funk  <collin.funk1@gmail.com>

	maint: prefer https to http
	* doc/sort-version.texi (Other version/natural sort implementations):
	Use https in documentation link.
	* tests/chmod/symlinks.sh: Use https in license text.

2025-08-19  Pádraig Brady  <P@draigBrady.com>

	nproc: honor cgroup v2 CPU quotas
	* NEWS: Mention the new feature.
	* doc/coreutils.texi (nproc invocation): Mention that
	cgroup CPU quotas can limit the reported number.
	* gnulib: Update to new nproc gnulib implementation:
	https://github.com/coreutils/gnulib/commit/9b07115f4a

2025-08-19  Collin Funk  <collin.funk1@gmail.com>

	logname: list David MacKenzie as the author
	* src/logname.c (AUTHORS): List David as the author.
	* AUTHORS: Likewise.

2025-08-15  Paul Eggert  <eggert@cs.ucla.edu>

	realpath: improve doc and NEWS

2025-08-15  Collin Funk  <collin.funk1@gmail.com>

	maint: avoid syntax-check failure from previous commit
	* src/tsort.c: Don't include long-options.h since the previous commit
	removed the call to parse_gnu_standard_options_only. This avoids a
	sc_prohibit_long_options_without_use syntax-check failure.

2025-08-15  Paul Eggert  <eggert@cs.ucla.edu>

	tsort: add do-nothing -w option
	This is for conformance to POSIX.1-2024
	* src/tsort.c: Include getopt.h.
	(main): Accept and ignore -w.  Do not bother altering
	the usage message, as the option is useless.
	* tests/misc/tsort.pl (cycle-3): New test.

2025-08-12  Pádraig Brady  <P@draigBrady.com>

	maint: use short form bug URLs
	* cfg.mk (sc_prohibit-long-form-bug-urls): Disallow long form in code.
	* scripts/git-hooks/commit-msg: Disallow long form in commit messages.
	* NEWS: Shorten long urls.
	* bootstrap.conf: Likewise.
	* configure.ac: Likewise.
	* scripts/git-hooks/commit-msg: Likewise.
	* src/csplit.c: Likewise.
	* src/fmt.c: Likewise.
	* src/make-prime-list.c: Likewise.
	* src/nohup.c: Likewise.
	* tests/od/od-float.sh: Likewise.
	* tests/rm/r-root.sh: Likewise.
	* tests/tail/inotify-race.sh: Likewise.
	* tests/tail/inotify-race2.sh: Likewise.

2025-08-12  Bruno Haible  <bruno@clisp.org>

	basenc: Don't trigger undefined behaviour in mini-gmp
	* src/basenc.c (base58_encode): Avoid calling mpz_import on an empty
	limb sequence.

2025-08-10  Collin Funk  <collin.funk1@gmail.com>

	realpath: support the -E option required by POSIX
	* src/realpath.c (longopts): Add the option.
	(main): Likewise.
	(usage): Add the option to the --help message.
	* tests/misc/realpath.sh: Add a simple test.
	* doc/coreutils.texi (realpath invocation): Mention the new option.
	* NEWS: Likewise.

2025-08-10  Pádraig Brady  <P@draigBrady.com>

	doc: --base58: add example usage to info
	* doc/coreutils.texi (basenc invocation): Add an example
	using --base58 to generate a unique ID.  This also demonstrates
	compound usage of the basenc command, to convert to/from binary.

2025-08-09  Pádraig Brady  <P@draigBrady.com>

	doc: rearrange NEWS to more standard ordering
	* NEWS: Also move items to more appropriate sections.
	Also use more consistent quoting.

2025-08-09  Pádraig Brady  <P@draigBrady.com>

	basenc: add base58 support
	A 58 character encoding that:
	 - avoids visually ambiguous 0OIl characters
	 - uses only alphanumeric characters
	Described at:
	 - https://tools.ietf.org/html/draft-msporny-base58-03

	This implementation uses GMP (or gnulib's gmp fallback).
	Performance is good in comparison to other implementations.
	For example when using libgmp on an i7-5600U system,
	encoding is 530 times faster, and decoding 830 times faster
	than the implementation using arbitrary precision ints in cpython 3.13.

	Memory use is proportional to the size of input.

	Encoding benchmarks:

	  $ time yes | head -c65535 | src/basenc --base58 -w0 >file.enc
	  real    0m0.018s

	  ./configure --quiet --without-libgmp && make -j $(nproc)
	  $ time yes | head -c65535 | src/basenc --base58 -w0 >file.enc
	  real    0m3.431s

	  # dnf install python3-base58
	  $ time yes | head -c65535 | base58 >file.enc  # cpython 3.13
	  real    0m9.700s

	Decoding benchmarks:

	  $ time src/basenc --base58 -d <file.enc >/dev/null
	  real    0m0.010s

	  $ ./configure --without-libgmp && make  # gnulib gmp
	  $ time src/basenc --base58 -d <file.enc >/dev/null
	  real    0m0.145s

	  $ time base58 -d <file.enc >/dev/null  # cpython 3.13
	  real    0m8.302s

	* src/basenc.c (base_decode_ctx_finalize, base_encode_ctx_init,
	base_encode_ctx, base_encode_ctx_finalize): New functions to
	provide more general processing functionality.
	(base58_{de,en}code_ctx{_init,,_finalize}): New functions to
	accumulate all input before calling ...
	(base58_{de,en}code): ... the GMP based encoding/decoding routines.
	(do_encode, do_decode): Call the ctx variants if enabled.
	* doc/coreutils.texi (basenc invocation): Describe the new option,
	and indicate the main use case being interactive user use.
	* src/local.mk: Link basenc with GMP.
	* tests/basenc/basenc.pl: Add test cases.
	* NEWS: Mention the new feature.

2025-08-09  Pádraig Brady  <P@draigBrady.com>

	basenc: fix stripping of '=' chars in some encodings
	* src/basenc.c (do_decode): With -i ensure we strip '=' chars
	if there is no padding for the chosen encoding.
	* tests/basenc/basenc.pl: Add a test case.
	* NEWS: Mention the bug fix.

2025-08-09  Collin Funk  <collin.funk1@gmail.com>

	maint: prefer attribute.h in .c files
	* src/basenc.c (base16_encode, z85_encoding, do_decode): Use
	ATTRIBUTE_NONSTRING instead of ATTRIBUTE_NONSTRING.
	* src/basenc.c (sc_prohibit-_gl-attributes): New rule for
	'make syntax-check'.

2025-08-08  Paul Eggert  <eggert@cs.ucla.edu>

	cp: omit some needless lseek calls
	The sparse code sometimes issued multiple lseeks against the
	same file without doing anything in betwee.  Optimize them away
	by keeping track of the last hole output, in a way that
	crosses the sparse_copy function call boundary.
	* src/copy.c (sparse_copy): New arg hole_size, replacing old args
	scan_holes and last_write_made_hole.  All callers changed.
	(sparse_copy, lseek_copy): Do not create hole at
	end; let the caller deal with it.  All callers changed.
	(lseek_copy): New args hole_size and total_n_read.  Caller changed.
	(copy_reg): Create hole at end for both lseek_copy and sparse_copy.

	cp: --sparse=always was missing some holes
	The sparse code assumed that st_blksize was the minimum hole size.
	However, st_blksize is an optimum I/O buffer size, not the file
	system fundamental block size.  Use ST_NBLOCKSIZE instead;
	although it may underestimate the true block size that just slows
	‘cp’ down a bit, without introducing bugs.
	* src/copy.c (sparse_copy): Arg scan_holes replaces
	the old hole_size arg.  All callers changed.
	(lseek_copy): Remove hole_size arg; no longer needed.
	Caller changed.

2025-08-06  Collin Funk  <collin.funk1@gmail.com>

	maint: use consistent references to standard files in messages
	* cfg.mk (sc_standard_outputs): Add a grep command for source files.
	* src/du.c (main): Use standard input instead of stdin, standard output
	instead of stdout, and standard error instead of stderr in messages.
	* src/nohup.c (main): Likewise.
	* src/sort.c (main): Likewise.
	* src/split.c (main): Likewise.
	* src/stdbuf.c (main): Likewise.
	* src/wc.c (main): Likewise.
	* tests/du/files0-from.pl (@Tests): Adjust test case to new messages.
	* tests/sort/sort-files0-from.pl: Likewise.
	* tests/wc/wc-files0-from.pl: Likewise.

2025-08-04  Bernhard Voelker  <mail@bernhard-voelker.de>

	maint: remove now-unused include of 'safe-read.h'
	'make syntax-check' complains:
	  src/tail.c
	  maint.mk: the above files include safe-read.h but don't use it
	  make: *** [maint.mk:737: sc_prohibit_safe_read_without_use] Error 1

	The removal was missed for tail.c in recent commit d3c7072a0950.

	* src/tail.c (safe-read.h): Remove include.

2025-08-04  Paul Eggert  <eggert@cs.ucla.edu>

	maint: prefer same-inode.h
	This does not change behavior on POSIX platforms; it’s mostly to
	make it clearer when we’re looking for file identity.
	* src/cat.c (main):
	* src/copy.c (struct dir_list, is_ancestor, copy_internal):
	* src/tail.c (struct File_spec, record_open_fd, recheck)
	(tail_forever_inotify, tail_file):
	* src/test.c (binary_operator):
	Use psame_inode, PSAME_INODE, or SAME_INODE instead of comparing
	device and inode numbers by hand.

	tail: refactor ‘failable’
	* src/tail.c (recheck, tail_file): Do not mark a file as tailable
	merely because --retry is not in effect.  Simplify internal logic.
	This should not change behavior; it’s just for clarity and to
	make the code match the comments better.

	tail: fix race between read and fstat
	* src/tail.c (get_file_status): Remove, since after the changes
	described below it would be called in just one place and it’s a
	bit clearer to inline by hand.
	(tail_file): Don’t call fstat after reading the file, as that
	misses changes arriving between read and fstat.  Instead, reuse
	the fstat done before reading the file.

	tail: track errno more accurately
	This matters only in some obscure cases hard to test for.
	* src/tail.c (file_lines, pipe_lines, pipe_bytes, start_bytes)
	(start_lines, tail_bytes, tail_lines, tail): New return
	convention, which reports errno.  All callers changed.
	(recheck): Don’t lose track of errno if a regular file is
	replaced by a symlink.
	(get_file_status): Set errno to 0 on success.
	(tail_file): Be more careful about f->errnum.
	It is now -1 only if the failure was not due to
	a system call failing.

	tail: omit redundant assignment
	* src/tail.c (recheck): f->remote must be true already,
	so don’t set it to true.

	tail: prefer readlink to lstat+S_ISLNK
	When not already calling lstat for some other reason,
	prefer readlink to lstat+S_ISLNK,
	as readlink does not suffer from EOVERFLOW issues.
	* src/rmdir.c (main):
	* src/tail.c (recheck, any_symlinks):
	* src/test.c (unary_operator):

	tail: fix unlikely races with >=2 --pids
	Also, fix commentary to talk about “nonexistent” rather than
	“dead” processes, since the code looks for the former not the
	latter and the difference matters for zombies.
	* src/tail.c (some_writers_exist): Rename from writers_are_dead,
	negate the sense, don’t have a special and counterintuitive case
	for !nbpids, remove PIDs found not to exist, and avoid some
	though not all unlikely races when kernels reuse PIDs.
	(tail_forever): Optimize via blocking I/O even if --pid was used,
	so long as all the writers no longer exist.
	(tail_forever, tail_forever_inotify): Simplify the writers_dead
	logic; there is no need to have a local var to track this, since
	we can use pids and nbpids now.
	(parse_options): Also free and clear pids if !forever.

	tail: prefer < 0 to == -1
	* src/tail.c (valid_file_spec, recheck, writers_are_dead)
	(tail_forever, check_fspec, tail_forever_inotify, tail_file)
	(parse_options, main): Be a bit more systematic about checking
	for sign, rather than for exact equality or inequality,
	when the sign is enough.  Makes the code a bit clearer
	now that -2 sometimes means success.

	tail: record file offset more carefully
	* src/tail.c (struct File_spec): New member read_pos, replacing
	size, since the value was really a read position not a size.
	All uses changed.
	(xlseek): Move defn up.
	(record_open_fd): If the read_pos (formerly) size arg is unknown,
	compute it here if it is a regular file.
	(file_lines): Return the resulting read pos (or -1 on failure)
	instead of storing it via a pointer.  Caller changed.
	Simplify by using SEEK_CUR instead of SEEK_SET when that is easy.
	Avoid reading the same data twice when there are not enough
	lines in the file.
	(pipe_lines): Return -2 on success, -1 on failure, rather than
	updating a read pos via a pointer (which was weird for pipes anyway).
	Caller changed.
	(pipe_bytes, tail_bytes, tail_lines, tail):
	Return -1 on failure, a file offset if known, and < -1 otherwise,
	instead of storing a file offset via a pointer.  Caller changed.
	(pipe_bytes): Take initial file offset as an arg, or -1 if unknown.
	(start_bytes, start_lines): Return -1 (not 1) on error, -2 (not
	-1) on EOF, and do not accept pointer to read pos as an arg since
	neither we nor our caller know the read pos.  Callers changed.
	(recheck): Do not assume a newly-opened file is at offset zero,
	as this is not always true on Solaris.
	(tail_forever, check_fspec): Use dump_remainder result only
	on regular files, to prevent (very unlikely) overflow.
	(tail_file): Remove no-longer-needed TAIL_TEST_SLEEP code.

	maint: prefer 'read' to 'safe_read'
	In the old days, safe_read acted more like what full_read does now.
	When that went away, some code that invoked safe_read should
	have gone back to plain 'read' but I guess we never got around to it.
	Simplify this code by going back to plain 'read'.
	Use safe_read only in csplit.c, which has a signal handler
	and where 'read' can therefore fail with EINTR.
	Although safe_read also checks for oversize buffers,
	that is better done via io_blksize.
	* src/cat.c (simple_cat, cat):
	* src/head.c (copy_fd, elide_tail_lines_pipe)
	* src/tac.c (tac_seekable, copy_to_temp):
	(elide_tail_lines_seekable, head_lines):
	* src/tail.c (dump_remainder, file_lines, pipe_lines)
	(pipe_bytes, start_bytes, start_lines, tail_forever_inotify):
	* src/tr.c (plain_read):
	Use plain 'read', not safe_read, since there is no
	need to worry about signals or oversize requests.
	Also, there is no longer a need to include safe-read.h.
	* src/ioblksize.h: Include sys-limits.h, for SYS_BUFSIZE_MAX.
	(io_blksize): Max out at SYS_BUFSIZE_MAX.

	tail: prefer signed types to size_t, blksize_t
	* src/tail.c (struct File_spec, xwrite_stdout, file_lines)
	(pipe_lines, pipe_bytes, start_bytes, any_live_files)
	(tail_forever, any_remote_file, any_non_remote_file)
	(any_symlinks, any_non_regular_fifo, tailable_stdin)
	(tail_forever_inotify, ignore_fifo_and_pipe, main):
	Prefer a signed type to size_t, if possible.
	Ordinarily this is idx_t, but use int when the value
	must fit in int anyway.
	(file_lines): Similarly for blksize_t, which had no business
	being here anyway.
	(main): Check for overflow in the oddball case where ptrdiff_t is
	narrower than int.

	tail: prefer intmax_t to uintmax_t
	Signed types let us debug better, by using -fsanitize=undefined.
	* doc/local.mk (doc/constants.texi):
	Adjust change from macro to enum.
	* src/tail.c (COPY_TO_EOF, COPY_A_BUFFER)
	(DEFAULT_MAX_N_UNCHANGED_STATS_BETWEEN_OPENS):
	Now enum constants, not macros.
	(COPY_TO_EOF, COPY_A_BUFFER): Now negative, not positive.
	(count_t): New typedef.  Use it instead of uintmax_t.
	(COUNT_MAX): New macro; use it instead of UINTMAX_MAX.
	(struct File_spec, max_n_unchanged_stats_between_opens)
	(dump_remainder, file_lines, pipe_lines, pipe_bytes)
	(start_bytes, start_lines, tail_forever, check_fspec)
	(tail_forever_inotify, tail_bytes, tail_lines, tail, tail_file)
	(parse_obsolete_option, parse_options, main):
	Prefer count_t to uintmax_t.

	tail: don’t output more lines than requested
	* src/tail.c (file_lines): Fix an unlikely bug where ‘tail -n N’
	could output more than N lines if standard input is a largish
	regular file with large initial offset that starts with (say) N-1
	lines after the initial offset, but grows to N+1 lines between the
	fstat and read calls.  In this case ‘tail -n N’ now outputs N-1
	lines, not N+1; that is, it pretends the file grew after ‘tail’
	read it.  That is better than outputting more than N lines.

	tail: xlseek switch → table
	* src/tail.c (xlseek): Turn a switch statement into a table.

	tail: prettyname cleanup
	* src/tail.c: Use ‘prettyname’ consistently as the identifier
	for a prettified file name, as opposed to ‘pretty_filename’,
	‘pretty_name’, and ‘name’.  This makes the code easier to follow.
	(struct File_spec): New member prettyname.
	(pretty_name): Remove.
	All uses of pretty_name (f) replaced by f->prettyname.
	(close_fd, fremote): Accept struct File_spec, not name.
	All callers changed.
	(main): Initialize the new prettyname member.
	This is simpler/smaller than calling pretty_name everywhere.

	tail: optimize tail -n +2**63
	* src/tail.c (tail_lines): Also optimize ‘tail -n +N’
	on a seekable file, where OFF_T_MAX <= N < UINTMAX_MAX.
	Of course this is very unlikely.

	tail: refactor SEEK_END and lines
	* src/tail.c (tail_lines): Refactor to simplify the confusing
	code for using SEEK_END when counting lines.  The old code
	had a ‘end_pos != 0’ expression that was always true.

	tail: refactor to skip stat call on failure
	* src/tail.c (tail_bytes): New function.
	(tail_bytes, tail_lines, tail): Accept struct stat pointer from
	caller instead of calling fstat ourselves.  All callers changed.
	(tail_file): Skip a call to fstat if fstat already failed.
	* tests/tail/follow-stdin.sh: Adjust to match new behavior
	on failure, which omits a redundant diagnostic.

	tail: speed up -c N for huge N
	When the user specifies -c N where 2**63 <= N, don’t give
	up and use the slow method (which will exhaust memory if
	the file is large).  Instead, treat it as N = 2**63 - 1,
	since that has equivalent effect.
	* src/tail.c (tail_bytes): With -c N and large N, adjust
	the code so that lseeks can still be used without
	affecting correctness.  Formerly the code gave up and
	did a sequential pass through the whole input, which
	could easily exhaust memory.

	tail: allow >=2**64 in traditional form
	This better matches the treatment of POSIX form,
	e.g., ‘tail +Nc’ is now like ‘tail -c +N’ even when N is large.
	* src/tail.c: Don’t include xstrtol.h.
	(parse_obsolete_option): Treat numbers greater than UINTMAX_MAX as
	if they are UINTMAX_MAX.  Parse the number by hand with saturating
	arithmetic; nowadays that’s simpler than using xstrtoumax.  There
	is no need for a diagnostic now, as the error cannot happen any more.
	* tests/tail/tail.pl (obs-plus-c3): New test.

	tail: check OFF_T_MAX vs COPY_A_BUFFER
	* src/tail.c: Document an otherwise-unstated assumption.

	tail: fix SEEK_END typo
	* src/tail.c (tail_lines): Fix embarrassing SEEK_END typo.
	Luckily this matters only in never-used (though valid) invocations.

	tail: simplify -c+ on regular files
	* src/tail.c (tail_bytes): Simplify the -c+N case by treating
	regular files like other files; if the lseek fails for whatever
	reason, fall back on the unoptimized version instead of reporting
	a fatal error.

	maint: don’t lseek memory objects
	This affects behavior only on memory objects, which are not in Linux.
	Formerly the code would use lseek on these objects,
	but POSIX says the result of lseek is unspecified on them,
	and in QNX lseek has undefined behavior on typed memory objects.
	* src/head.c (elide_tail_bytes_file, elide_tail_lines_file):
	Omit unnecessary uses of presume_input_pipe.
	Improve some out-of-date comments.
	(head): Do not assume a file is seekable merely because its
	st_size is usable.  Instead, seek only on regular files.
	* src/od.c (skip): Do not seek on memory objects.

	wc: don’t assume opening a file puts you at start
	This is not true on Solaris when opening /dev/stdin; it could be
	at a nonzero file offset.  Arguably Linux should do likewise.
	* src/wc.c (wc): Omit last arg, and act as if it is always -1.
	All uses changed.

	head: simplify head_bytes
	* src/head.c (diagnose_read_failure): New function.
	Use it when possible, to simplify callers.
	(head_bytes): Use copy_fd and diagnose_copy_fd_failure instead of
	reinventing the wheel.

	head: omit unnecessary lseek
	* src/head.c (elseek_diagnostic): New function.
	(elseek): Use it.
	(head_lines): Use it to avoid an unnecessary lseek.

2025-08-03  Collin Funk  <collin.funk1@gmail.com>

	readlink: improve documentation for POSIXLY_CORRECT in --help
	* NEWS: Improve wording to not imply POSIXLY_CORRECT=1 readlink -q will
	be verbose.
	* src/readlink.c (usage): Mention the affect of POSIXLY_CORRECT on
	-s (--silent), -q (--quiet), and -v (--verbose) in the help message.
	(main): Remove spurious newline added by previous commit.
	* doc/coreutils.texi (readlink invocation): Mention that -s (--silent)
	and -q (--quiet) are not the default when POSIXLY_CORRECT is set.

	readlink: emit errors when POSIXLY_CORRECT is set
	* src/readlink.c (main): Set verbose if the POSIXLY_CORRECT environment
	variable is set.
	* tests/readlink/readlink-posix.sh: New file.
	* tests/local.mk (all_tests): Add it.
	* NEWS: Mention the change.
	* doc/coreutils.texi (readlink invocation): Document the behavior of
	POSIXLY_CORRECT.

2025-08-02  Pádraig Brady  <P@draigBrady.com>

	doc: mention copy_file_range data corruption avoidance
	* NEWS: Mention this important data corruption issue.

2025-08-02  Paul Eggert  <eggert@cs.ucla.edu>

	build: update gnulib submodule to latest

2025-08-01  Bruno Haible  <bruno@clisp.org>

	maint: date: refactor to be entirely bottom-up
	* src/date.c (show_date_helper): Move function. Remove forward
	declaration.

	date: fix calendar-related test failures on macOS and OpenBSD
	* bootstrap.conf (gnulib_modules): Add xsetenv.
	* src/date.c: Include xsetenv.h.
	(set_LC_TIME): New function.
	(show_date_helper): Call set_LC_TIME instead of setlocale.
	* po/POTFILES.in: Add lib/xsetenv.c.
	Fixes https://bugs.gnu.org/79118

2025-08-01  Collin Funk  <collin.funk1@gmail.com>

	build: update gnulib submodule to latest

	build: fix previous commit
	* src/local.mk (src/speedlist.h): Pass correct arguments $(COMPILE). Use
	tabs consistently.

2025-07-31  Collin Funk  <collin.funk1@gmail.com>

	build: don't use '$<' in non-suffix rules
	* src/local.mk (src/speedlist.h): Use the file name instead of '$<'
	which is not supported by OpenBSD make.

2025-07-29  Pádraig Brady  <P@draigBrady.com>

	du: improve diagnostics for --time-style
	* src/system.h (x_timestyle_args): A new function refactored from ...
	* src/ls.c (decode_switches): ... here.
	* src/du.c: Use refactored x_timestyle_args() to output a custom error.
	Addresses https://bugs.gnu.org/79113

	doc: use consistent references to standard files
	* cfg.mk (sc_standard_outputs): A new syntax check to
	enforce standard references.
	* doc/coreutils.texi: s/stderr/standard error/ etc.
	* src/date.c: Likewise.
	* src/dd.c: Likewise.
	* src/env.c: Likewise.
	* src/sort.c: Likewise.
	* src/split.c: Likewise.
	* src/stty.c: Likewise.
	* src/timeout.c: Likewise.
	* src/who.c: Likewise.

2025-07-27  Collin Funk  <collin.funk1@gmail.com>

	doc: update git version documented in HACKING
	* HACKING: Mention that git version 1.6.4 or later is required since
	'./bootstrap' will fail otherwise.

2025-07-27  Paul Eggert  <eggert@cs.ucla.edu>

	doc: mention 2025 speedup on large composites

2025-07-26  Pádraig Brady  <P@draigBrady.com>

	maint: avoid :> pattern in tests
	This was seen to trigger the EXIT trap on cygwin

	* cfg.mk (sc_prohibit_colon_redirection): Disallow all
	cases of :> in tests/
	* tests/cksum/md5sum-bsd.sh: Adjust to avoid more
	stringent syntax check.

2025-07-26  Collin Funk  <collin.funk1@gmail.com>

	tests: avoid a false failure on Cygwin
	* tests/cksum/md5sum-bsd.sh: Use 'echo' instead of ':' to redirect to
	the file. Otherwise 'Exit $fail' is not called on Cygwin.

	maint: avoid syntax-check failure from previous commit
	* src/test.c (binary_operator): Place string argument on a separate line
	to avoid sc_error_quotes syntax-check failure.

2025-07-25  Paul Eggert  <eggert@cs.ucla.edu>

	test: simplify for clarity
	This should help avoid further audit confusion,
	such as was just fixed by removing a FIXME.
	* src/test.c (enum binop): New type.
	(get_mtime): Return a struct timespec instead of returning
	a bool and storing a struct timespec.  All callers changed.
	(binop): Return an int recording either success (an enum binop)
	or failure (-1).  All callers changed.
	(binary_operator): Accept an enum binop, so that we need
	not recompute the op type.  All callers changed.  Simplify.

2025-07-25  Harry Fellowes  <harryfellowes1@gmail.com>  (tiny change)

	test: removed dead code for unrecognised binary operators
	the fallback error in binary_operator() was unreachable, since invalid
	binary operators are rejected in three_arguments() via binop() which
	returns false and prevents entry into binary_operator().

	this dead code was unreachable and safe to remove

	ref: line 636 where "binary operator expected" is generated.

2025-07-23  Collin Funk  <collin.funk1@gmail.com>

	tests: date: add tests for the Ethiopian calendar
	* tests/date/date-ethiopia.sh: New file.
	* tests/local.mk (all_tests): Add the test.

	tests: date: add tests for the Solar Hijri calendar
	* tests/date/date-iran.sh: New file.
	* tests/local.mk (all_tests): Add the test.

2025-07-22  Pádraig Brady  <P@draigBrady.com>

	install: with -d, use more accurate diagnostics
	* gnulib: Update to latest to get the fix to
	propagate the appropriate error message.
	* tests/install/basic-1.sh: Add a test case.
	* NEWS: Mention the bug fix.
	Addresses https://bugs.gnu.org/79072

2025-07-22  Collin Funk  <collin.funk1@gmail.com>

	tests: date: add tests for the Thai solar calendar
	* tests/date/date-thailand.sh: New file.
	* tests/local.mk (all_tests): Add the test.

2025-07-21  Collin Funk  <collin.funk1@gmail.com>

	doc: NEWS: mention that 'date' now supports non-Gregorian calendars
	Suggested by Bruno Haible in:
	<https://lists.gnu.org/r/bug-gnulib/2025-07/msg00091.html>.

	* NEWS: Mention the improvement.

2025-07-21  Collin Funk  <collin.funk1@gmail.com>

	build: update gnulib submodule to latest
	* bootstrap: Update using './bootstrap --bootstrap-sync'.

2025-07-21  Bruno Haible  <bruno@clisp.org>

	date: update documentation regarding non-Gregorian calendars
	* doc/coreutils.texi (Calendars): New section.

	date: force a Gregorian calendar for options --iso-8601 and --rfc-3339
	* src/date.c (show_date_helper): Add a use_c_locale parameter.
	(batch_convert): Add a format_in_c_locale parameter.
	(main): Set format_in_c_locale to true if any of the options --rfc-3339,
	--iso-8601, -R is seen.

2025-07-12  Pádraig Brady  <P@draigBrady.com>

	tests: sort: add a test for equivalent floats
	* tests/sort/sort-float.sh: Ensure equivalent floats
	are treated as such.

2025-07-11  Paul Eggert  <eggert@cs.ucla.edu>

	tests: fix fraction comparison in sort-float
	Problem reported by Cosima Neidahl <https://bugs.gnu.org/78985#13>.
	* tests/sort/sort-float.sh: At top level, use C locale at first.
	(dbl_minima_order): Assume C locale.
	Use string comparison for the fractional parts.

	2025-07-10  Paul Eggert  <eggert@cs.ucla.edu>

	tests: fix integer overflow in sort-float
	Problem reported by Cosima Neidahl <https://bugs.gnu.org/78985>.
	* tests/sort/sort-float.sh (dbl_minima_order):
	Use expr instead of test, to avoid problems with integers
	too large for the shell.

2025-07-10  Paul Eggert  <eggert@cs.ucla.edu>

	tests: fix integer overflow in sort-float
	Problem reported by Cosima Neidahl <https://bugs.gnu.org/78985>.
	* tests/sort/sort-float.sh (dbl_minima_order):
	Use expr instead of test to compare fractions,
	to avoid problems with integers too large for the shell.

	factor: remove SINGLE_WORKS
	* src/factor.c (SINGLE_WORKS): Remove, and remove its use,
	as the buggy code that it is referring to has been removed.

	factor: use 64-bit internal counters
	* src/factor.c (factor_using_pollard_rho)
	(factor_using_pollard_rho2, mp_factor_using_pollard_rho):
	Use int_fast64_t for internal counters rather than int, as int
	could overflow on some somewhat-practical examples.  Problem
	discovered on a hypothetical platform where W_TYPE_SIZE is neither
	32 nor 64, when factoring 0x7ffffffffffffeab7fffffffffff7369 ==
	170141183460469225450570946617781744489, causing k to overflow in
	mp_factor_using_pollard_rho.  Presumably a similar problem exists
	in the previous stable coreutils 9.7, too, on 32-bit platforms
	with somewhat-larger test cases, though I haven’t take the
	somewhat-extensive CPU time to discover it.

	factor: fix mp_factor_using_pollard_rho aliasing
	* src/factor.c (mp_factor_using_pollard_rho):
	Fix recently-introduced aliasing bug by computing q
	before g gets updated in place.  Problem discovered
	on a hypothetical platform where W_TYPE_SIZE
	is neither 32 nor 64.

	maint: fix apostrophe in old NEWS

	factor: speed up converting strings to uuint
	* src/factor.c: Do not include c-ctype.h.
	(strtouuint): Don’t bother generating a number on
	error; just return a strtol_error value other than LONGINT_OK.
	Speed up overflow checking.

	factor: simplify primes table
	* src/factor.c (primes_ptab): New table of primes, replacing
	primes_diff and primes_diff8.  All uses changed.  This is simpler
	and should improve performance slightly.  Although this limits the
	table’s primes to 2**15 instead of to 668221, the limit can easily
	grow to 2**32 by changing the type of ‘prime’, without hurting
	performance significantly compared to the primes_diff and
	primes_diff8 approach.
	* src/make-prime-list.c (output_primes):
	For each prime p, output p instead of two differences.

	factor: prefer false for boolean 0
	* src/factor.c: Prefer false to 0 for booleans.

	maint: port speedgen to FreeBSD 15
	* src/speedgen: Avoid ‘trap 'command' ERR’, as ERR
	does not conform to POSIX and does not work in
	FreeBSD 15 sh.

	factor: speed up Pollard-rho loop counters
	* src/factor.c (factor_using_pollard_rho)
	(factor_using_pollard_rho2, mp_factor_using_pollard_rho):
	Use int, not unsigned long int, for counters that won’t go above
	2**31 on practical platforms.  This yields a significant speedup
	on GCC 15 x86-64, and using signed values allows for automatic
	checks for overflow when using gcc -fsanitize=undefined.

	factor: avoid an mpz init+clear
	* src/factor.c (mp_factor_insert_ui): Rename fom
	mp_factor_insert_ui, and change arg type from unsigned long int to
	mp_limb_t.  All uses changed.  This avoids creating and freeing a
	small mpz_t.
	(mp_factor_using_division): Add a static assert requiring that
	that mp_limb_t be wide enough, which it should be (and is in
	standard GMP).

	factor: Pollard-rho a is now mp_limb_t
	* src/factor.c (factor_using_pollard_rho)
	(factor_using_pollard_rho2): Use mp_limb_t, not unsigned long int,
	for a parameter.  This avoids some casts, and avoids a theoretical
	bug where converting to mp_limb_t loses info.

	factor: redo ge2 in terms of lt2
	lt2 a bit more natural, given the current implementation.
	* src/factor.c (lt2): New function.
	(ge2): Rewrite in terms of lt2.
	(gt2): Remove.  All callers changed to use lt2.

	factor: speed up umul_ppmm when !USE_LONGLONG_H
	* src/factor.c (umul_ppmm): When !USE_LONGLONG_H so we need to
	define this, speed things up if there is an unsigned type uuroom_t
	wide enough to hold two words.  Do not make a similar change for
	udiv_qrnnd, as it is not performance critical and anyway on GCC 15
	x86-64 that would mean a subroutine call.

	factor: streamline gcd2_odd
	* src/factor.c (gcd2_odd): Omit a gt2 and adjusts other
	tests accordingly.  Omit duplicate code that makes A odd.

	factor: faster gcd_odd since 2nd is odd
	* src/factor.c (gcd_odd, gcd2_odd): Speed up, given that the
	second argument is always odd.
	(gcd_odd): Avoid recomputing a temporary.
	(gcd2_odd): Test for zero only if a multiple of B.
	This saves an ‘assume’.

	doc: update ‘factor’ benchmarks

	factor: prefer exact division
	* src/factor.c (mp_factor_using_division, mp_factor_using_pollard_rho):
	Use exact division when it suffices, as it’s typically faster.

	factor: tune submod2
	* src/factor.c (submod2): Use ckd_sub to subtract by hand rather
	than using sub_ddmmss plus a compare.  This speeds things up a
	bit, on x86-64 with GCC 15 anyway.

	factor: DELIM and DIVBLOCK no longer macros
	* src/factor.c (DELIM): Now a constant, not a macro.
	(divblock): Now a static inline function, not a macro DIVBLOCK.
	All uses changed.

	factor: simplify by assuming !PROVE_PRIMALITY
	* src/factor.c (PROVE_PRIMALITY, mp_millerrabin): Remove.
	All uses removed, and surrounding code simplified.

	factor: simplify by assuming USE_BAILLIE_PSW
	* src/factor.c (make_uuint2, powm, powm2, millerrabin)
	(millerrabin2, USE_BAILLIE_PSW): Remove; no longer used.
	(prime_p, prime2_p): Simplify by assuming USE_BAILLIE_PSW.

	factor: prime comments
	* src/factor.c: Add comments re prime functions.

	factor: no ferror+fclose
	* src/make-prime-list.c (main): Avoid parallel calls
	to ferror and fclose.

	factor: define SQUARE_OF_FIRST_OMITTED_PRIME
	* src/make-prime-list.c (output_primes): Output
	SQUARE_OF_FIRST_OMITTED_PRIME, not FIRST_OMITTED_PRIME.  All uses
	changed.  This way, the uses don’t need to worry about casts to
	avoid overflow.

	factor: simplify add_ssaaaa default
	* src/factor.c (add_ssaaaa): Simplify default implementation.

	factor: speed up ge2, gt2
	* src/factor.c (ge2, gt2): Now branchless static functions.

	factor: improve millerrabin2 API
	* src/factor.c (make_uuint2): New function.
	(powm2, millerrabin2): Pass two-word args as uuints,
	not as mp_limb_t const [2] pointers.  All uses changed.
	(prime2_p): Rework to use the new API, fixing a FIXME.

	factor: put FACTORS first
	* src/factor.c (factor_using_division, mp_finish_up_in_single)
	(mp_finish_in_single, factor_using_pollard_rho)
	(factor_using_pollard_rho2, factor_up, factor):
	Put FACTORS arg first, for consistency.
	This is just a refactoring and should not affect speed.

	factor: use 1-word code only when tested
	* src/factor.c (print_factors): Use single-precision code only
	when word size is 32 or 64, as it isn't tested for other sizes and
	is known to not work when it the size is 128.  This change does
	not affect any known practical platforms.

	factor: decrement Miller-Rabin tests from 25 to 24
	This avoids some seemingly-unnecessary code in mpz_probab_prime_p.
	* src/factor.c (MR_REPS): Shrink from 25 to 24, and add commentary.

	factor: don’t prove primality
	Suggested for consideration by Torbjörn Granlund in:
	https://lists.gnu.org/r/coreutils/2025-01/msg00000.html
	* src/factor.c (PROVE_PRIMALITY): Now defaults to false.
	(mp_prime_p): Help the compiler by telling it mpz_prob_prime_p
	returns nonnegative.
	* tests/factor/create-test.sh (bigprime): Test 2^400 - 593,
	since that’s now practical.
	* tests/local.mk (factor_tests): Add new test.

	factor: add comments to factor.c

	factor: always use Baillie-PSW
	* src/factor.c (USE_BAILLIE_PSW): New constant.
	(prime_p, prime2_p): Use it, i.e., always use Baillie-PSW.
	Do so by using mp_prime_p.  Do not tell GCC these functions
	are pure; the pure mark was present only to pacify GCC
	and is no longer needed now that thes functions call mp_prime_p.

	build: update gnulib submodule to latest

	factor: use mpz_probab_prime_p
	Inspired by a proposal by Torbjörn Granlund in:
	https://lists.gnu.org/r/coreutils/2025-01/msg00000.html
	* src/factor.c (mp_prime_p): Use mpz_probab_prime_p rather than doing
	it by hand, as mpz_probab_prime_p uses Baillie-PSW which is a win.
	This removes the need for the ret2 label and goto.

	factor: don’t give up before last prime in table
	* src/factor.c (prime_p, prime2_p, mp_prime_p): Do not skip the
	flag_prove_primality test for the last prime in the table, i.e.,
	when r == PRIMES_PTAB_ENTRIES - 1.
	(mp_prime_p): There is no longer a need for the ret1 label or goto.

	factor: move prime_p local in
	* src/factor.c (mp_prime_p): Refactor by moving local further in.

	factor: port back to mini-gmp
	mini-gmp lacs mpn_tdiv_qr, so supply an emulation of it
	when using mini-gmp.
	* src/factor.c (copy_mpn_from_mpz, mpn_tdiv_qr) [!mpn_tdiv_qr]:
	New functions.

	factor: speed up multiprecision Pollard’s rho
	These changes are taken from a proposal by Torbjörn Granlund in:
	https://lists.gnu.org/r/coreutils/2025-01/msg00000.html
	On my x86-64 platform, they improve speed by more than 8× when
	factoring 340282366920938463463374607431768211457.
	* src/factor.c (mp_modadd, mp_modsub, mp_modadd_1, mp_mulredc):
	New functions.
	(MP_FACTOR_USING_POLLARD_RHO_N_MAX): New macro.
	(mp_factor_using_pollard_rho): Act on mpn not mpz, and on
	mp_limb_t not unsigned long int.  Reorder args.  All uses changed.

	factor: use function for binv
	* src/factor.c (binv_limb): New function, replacing the old
	binv macro.  All uses changed.

	factor: use a more functional style
	This is mostly to make the code a bit easier to read.
	It shrinks the size of factor.o by 0.7% on my x86-64 platform
	though it doesn’t affect CPU performance significantly.
	* src/factor.c (mp_no_factors): Rename from mp_factor_init.
	(mp_no_factors, mp_factor_using_division, mp_factor):
	Return struct mp_factors rather than modifying one passed by reference.
	All uses changed.

	factor: use single vector in struct mp_factors
	* src/factor.c (struct mp_factor): New type.
	(struct mp_factors): Use it to replace P and E with F.
	All uses changed.

	factor: omit unnecessary divisions by small primes
	* src/factor.c (mp_factor_using_division):
	When continuing in single precision, don’t divide by primes that
	were already cast out in multiple precision.
	On my platform this gave a 2.5% speedup when factoring
	2**128 + 172261 = 4999 * 68070087401668026297934508388031283,
	as W_TYPE_SIZE == 64 and 4999 is the last prime in the primes table.

	factor: use primes_diff more consistently
	* src/factor.c (mp_factor_using_division): Use index into
	primes_diff consistently with other uses.  This is mostly just a
	style change, and likely doesn’t change the generated machine code.

	factor: refactor to for later performance speedup
	This does not affect performance much, but it should allow future
	performance improvements.
	* src/factor.c (factor_using_division): Two new args I and P,
	which generalize this function.  All uses changed.
	(mp_finish_up_in_single, factor_up): New functions, like the
	non-*_up* versions but with two new args PRIME_IDX and PRIME.
	They mostly just have the old body of the old non-*_up_ versions.
	(mp_finish_in_single, factor): Rewrite in terms of the new functions.

	factor: switch from mp to single when doable
	This significantly improves performance when a number exceeds
	2**(W_TYPE_SIZE - 1) and is the product of a prime less than
	FIRST_OMITTED_PRIME and another prime less than 2**(W_TYPE_SIZE - 1).
	On my platform, for example, it doubled the speed of factoring
	4999 * (2**128 - 159).
	* src/factor.c (mp_size, mp_finish_in_single): New functions.
	(mp_factor_using_division, mp_factor_using_pollard_rho):
	Finish using single precision when possible.
	* tests/factor/factor.pl (lt-5000-times-128-bit): New test.

	factor: primes_diff idx type consistency
	* src/factor.c (factor_insert_refind):
	Use idx_t for indexes into primes_diff,
	for consistency with other indexes into primes_diff.
	This has no practical effect unless the primes_diff
	table becomes unreasonably large.

	factor: omit q from mp_factor_using_division
	* src/factor.c (mp_factor_using_division): Remove unused local.

	factor: mp insert multiplicity too
	Support a multiplicity argument in the mp case, too.
	This helps keeps the two cases in sync, for maintenance.
